/*定义节点类node，描述当前走法*/
Node = function (obj) {
    this.score = obj.score || null; //分数
    this.id = parseInt(obj.id || 0); //id - 0 - ...
    this.index = parseInt(obj.index || 0); //处于当前分支的第几个
    this.pater = parseInt(obj.pater || 0); //父节点id
    this.child = []; //子节点id
    this.step = obj.step || ""; //当前招法 例："2337"
    this.stepcn = obj.stepcn || ""; //招法解析 例：炮二平五
    this.state = obj.state || 0; //棋子状态，吃将杀等
    this.eatKey = obj.eatKey || ""; //吃掉的棋子
    this.openbookDetail = obj.openbookDetail || []; //开局分析
    this.computerDetail = obj.computerDetail || []; //中局分析
    this.chessdbDetail = obj.chessdbDetail || []; //残局分析
    this.tipsStep = obj.tipsStep || []; //先后提示信息
    this.currentFen = obj.currentFen || null; //当前fen
    this.action = obj.action || ''; //吃将杀等
}
/*定义控制类*/
comm.init = function (a, k) {
    comm.cMap = comm.cMap || a; //初始棋子矩阵
    comm.map = comm.arr2Clone(a); //当前棋子矩阵
    comm.nowManKey = !1; //现在选中的棋子
    comm.nodes = comm.nodes || []; //nodes节点序列
    comm.isAnimating = !1; //棋子移动中
    comm.mans = {}; //所有的man对象
    comm.notes = comm.notes || []; //注释信息
    comm.isOffensive = comm.isOffensive || 0; //先后手0红1黑
    comm.sMap = comm.sMap || []; //编辑棋盘下的处于棋盘外的棋子
    comm.sMapList = comm.sMapList || {}; //编辑棋盘下的处于棋盘外的所有棋子
    var a = a || initMap;
    createMans(a);
    if (!comm.nodes.length) {
        var obj = { id: 0, pater: 0, step: 0, index: 0, stepcn: 0, currentFen: comm.getBoard() };
        var node = new Node(obj);
        node.pater = -1;
        comm.nodes.push(node);
    }
    k == !0 ? (comm.isPlay = !0) : (comm.isPlay = !1);
}
comm.initChessBymap = function (map) {
    if (isVerticalReverse == 1) {
        chessBottomLayer.removeChild(board), chessBottomLayer.addChildAt(verticalReverseboard, 0)
    }
    cleanChess();
    comm.map = comm.arr2Clone(map);
    comm.mans = {};
    createMans(map);
    // for (var m = 0; m < map.length; m++) {
    //     for (var o = 0; o < map[m].length; o++) {
    //         var n = map[m][o];
    //         n && (comm.mans[n].x = o, comm.mans[n].y = m, comm.mans[n].isShow = !0)
    //     }
    // }
}
comm.initLight = function (move_data) {
    if (!!move_data && !!move_data.to_pos) {
        if (isVerticalReverse == 1) {
            showLight(8 - move_data.to_pos.x, 9 - move_data.to_pos.y);
            showPane(8 - move_data.from_pos.x, 9 - move_data.from_pos.y);
        } else {
            showLight(move_data.to_pos.x, move_data.to_pos.y);
            showPane(move_data.from_pos.x, move_data.from_pos.y);
        }
    }
}
/*播放声音*/
handleComplete = function (e) {
    // console.log(e)
}
handleFailed = function (e) {
    // console.log(e)
}
comm.soundplay = function (e, type) {
    if (voicemode) {
        if (type == 'message') {
            var soundName = 'widget://assets/audio/message_' + vue.sound_type + '/' + e + '.mp3';
        } else if (type == 'count') {
            var soundName = 'widget://assets/audio/count_' + vue.sound_type + '/' + e.slice(5) + '.mp3';
        } else if (type == 'chess') {
            var soundName = 'widget://assets/audio/chess_' + vue.sound_type + '/' + e + '.mp3';
        } else {
            var soundName = 'widget://assets/audio/' + e + '.mp3';
        }
        soundPlayer.openPlayer({
            path: soundName,
        }, function(ret) {
           
        });
    }
}
/*根据map和step生成招法*/
comm.createMove = function (map, step) {
    var move = comm.Step2XY(step);
    try {
        var h = "";
        var man;
        if (!isVerticalReverse) {
            man = comm.mans[map[move.src.y][move.src.x]];
            if (man != undefined) {
                h += man.text;
                map[move.dst.y][move.dst.x] = map[move.src.y][move.src.x];
                delete map[move.src.y][move.src.x]
                if (man.my === RED) {
                    h += comm.createRedMove(man, step, !0);
                } else {
                    h += comm.createBlackMove(man, step, !0);
                }
            }
        } else {
            man = comm.mans[map[move.src.y][move.src.x]];
            if (man != undefined) {
                h += man.text;
                map[move.dst.y][move.dst.x] = map[move.src.y][move.src.x];
                delete map[move.src.y][move.src.x];
                if (man.my === BLACK) {
                    h += comm.createBlackMove(man, step, !1);
                } else {
                    h += comm.createRedMove(man, step, !1);
                }
            }
        }
    } catch (e) {
        console.log(e);
        reportBugly(4)
    }
    return h;
}
/*生成红子着法*/
comm.createRedMove = function (man, step, flag) {
    var move = comm.Step2XY(step);
    var h = "";
    var newX;
    var mumTo = ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十"];
    flag ? newX = reverseX(move.dst.x) : newX = move.dst.x;
    flag ? h += mumTo[reverseX(move.src.x)] : h += mumTo[move.src.x];
    if (move.dst.y > move.src.y) {
        flag ? h += "退" : h += "进";
        if (man.pater == "m" || man.pater == "s" || man.pater == "x") {
            h += mumTo[newX];
        } else {
            h += mumTo[move.dst.y - move.src.y - 1];
        }
    } else if (move.dst.y < move.src.y) {
        flag ? h += "进" : h += "退";
        if (man.pater == "m" || man.pater == "s" || man.pater == "x") {
            h += mumTo[newX];
        } else {
            h += mumTo[move.src.y - move.dst.y - 1];
        }
    } else {
        h += "平";
        h += mumTo[newX];
    }
    return h;
}
/*生成黑子着法*/
comm.createBlackMove = function (man, step, flag) {
    var move = comm.Step2XY(step);
    var h = "";
    var newX;
    var mumTo = ["１", "２", "３", "４", "５", "６", "７", "８", "９", "10"];
    flag ? newX = move.dst.x : newX = reverseX(move.dst.x);
    flag ? h += mumTo[move.src.x] : h += mumTo[reverseX(move.src.x)];
    if (move.dst.y > move.src.y) {
        flag ? h += "进" : h += "退";
        if (man.pater == "M" || man.pater == "S" || man.pater == "X") {
            h += mumTo[newX];
        } else {
            h += mumTo[move.dst.y - move.src.y - 1];
        }
    } else if (move.dst.y < move.src.y) {
        flag ? h += "退" : h += "进";
        if (man.pater == "M" || man.pater == "S" || man.pater == "X") {
            h += mumTo[newX];
        } else {
            h += mumTo[move.src.y - move.dst.y - 1];
        }
    } else {
        h += "平";
        h += mumTo[newX];
    }
    return h;
}
/*获取编辑棋盘数据*/
comm.getsMap = function () {
    if (isVerticalReverse) {
        MapEx = {
            "c": ["c0", "c1"],
            "m": ["m0", "m1"],
            "p": ["p0", "p1"],
            "x": ["x0", "x1"],
            "s": ["s0", "s1"],
            "z": ["z0", "z1", "z2", "z3", "z4"],
            "C": ["C0", "C1"],
            "M": ["M0", "M1"],
            "P": ["P0", "P1"],
            "X": ["X0", "X1"],
            "S": ["S0", "S1"],
            "Z": ["Z0", "Z1", "Z2", "Z3", "Z4"]
        }
    } else {
        MapEx = {
            "C": ["C0", "C1"],
            "M": ["M0", "M1"],
            "P": ["P0", "P1"],
            "X": ["X0", "X1"],
            "S": ["S0", "S1"],
            "Z": ["Z0", "Z1", "Z2", "Z3", "Z4"],
            "c": ["c0", "c1"],
            "m": ["m0", "m1"],
            "p": ["p0", "p1"],
            "x": ["x0", "x1"],
            "s": ["s0", "s1"],
            "z": ["z0", "z1", "z2", "z3", "z4"]
        }
    }
    for (var i = 0; i < comm.map.length; i++) {
        for (var j = 0; j < comm.map[i].length; j++) {
            var temp = comm.map[i][j];
            if (temp && temp != "j0" && temp != "J0") {
                item = temp.slice(0, 1);
                index = temp.slice(1, 2);
                (MapEx[item]).remove(temp);
            }
        }
    }
    return JSON.parse(JSON.stringify(MapEx));
}
comm = comm || {};
/*数组克隆*/
comm.arr2Clone = function (e) {
    for (var a = [], m = 0; m < e.length; m++) {
        a[m] = e[m].slice();
    }
    return a
}
//对象克隆
comm.clone = function (obj) {
    var o;
    switch (typeof obj) {
        case 'undefined':
            break;
        case 'string':
            o = obj + '';
            break;
        case 'number':
            o = obj - 0;
            break;
        case 'boolean':
            o = obj;
            break;
        case 'object':
            if (obj === null) {
                o = null;
            } else {
                if (obj instanceof Array) {
                    o = [];
                    for (var i = 0, len = obj.length; i < len; i++) {
                        o.push(comm.clone(obj[i]));
                    }
                } else {
                    o = {};
                    for (var k in obj) {
                        o[k] = comm.clone(obj[k]);
                    }
                }
            }
            break;
        default:
            o = obj;
            break;
    }
    return o;
}
/*一维数组翻转*/
comm.arrReverseEx = function (e) {
    for (var a = [], m = 0; m < e.length; m++) {
        a[m] = e[e.length - 1 - m];
    }
    return a
}
/*判断字符串是否为JSON格式*/
comm.isJSON = function (str) {
    if (typeof str == 'string') {
        try {
            var obj = JSON.parse(str);
            if (str.indexOf('{') > -1) {
                return true;
            } else {
                return false;
            }

        } catch (e) {
            showTipsStep(str);
            return false;
        }
    }
    return false;
}
/*字符大小写互换*/
comm.ReverseCase = function (ch) {
    if (ch >= 'A' && ch <= 'Z') {
        return ch.toLowerCase();
    }
    if (ch >= 'a' && ch <= 'z') {
        return ch.toUpperCase();
    }
}
/*获取当前执方*/
comm.getHold = function (isBegin) {
    var ret;
    /* 红方先手 isOffensive = 0
     * 黑方先手 isOffensive = 1
     */
    if (isBegin) {
        (comm.isOffensive == 0) ? ret = RED : ret = BLACK;
    } else {
        (comm.isOffensive == movesIndex % 2) ? ret = RED : ret = BLACK;
    }
    return ret;
}
/*获取对方执方*/
comm.getOppHold = function () {
    var ret;
    /* 红方先手 isOffensive = 0
     * 黑方先手 isOffensive = 1
     */
    (comm.isOffensive == movesIndex % 2) ? ret = BLACK : ret = RED;
    return ret;
}
/*判断是否在棋盘内*/
comm.CheckInBoard = function (point) {
    return point.x > -1 & point.x < 9 & point.y > -1 & point.y < 10;
}
/*坐标变换(a-i)->(0-8),(0-9)->(9-0)，解析返回的中局残局库信息使用*/
comm.transformat = function (e) {
    var o = e.split("");
    var a = [];
    for (var i = 0; i < 4; i++) {
        a[i] = {
            "a": "0",
            "b": "1",
            "c": "2",
            "d": "3",
            "e": "4",
            "f": "5",
            "g": "6",
            "h": "7",
            "i": "8",
            "0": "9",
            "1": "8",
            "2": "7",
            "3": "6",
            "4": "5",
            "5": "4",
            "6": "3",
            "7": "2",
            "8": "1",
            "9": "0"
        }[o[i]] || "";
    }
    return a.join("");
}
/*获取Fen字符串*/
comm.getFen = function (mapdata) {
    var result = "position fen ";
    var board = comm.getBoard(mapdata);
    result += board + " - - 0 1";
    if (result.indexOf("k") != -1 && result.indexOf("K") != -1) return result;
    return "";
}
/*将棋盘数组转化成FEN格式*/
comm.getBoard = function (mapdata, isBegin) {
    var map = '';
    comm.getReverse() ? (map = mapdata ? mapdata : arrReverse(comm.arr2Clone(comm.map))) : (map = mapdata ? mapdata : comm.arr2Clone(comm.map));
    var key = "";
    var coutZero = 0;
    var board = "";
    for (var i = 0; i < 10; i++) {
        coutZero = 0;
        for (var j = 0; j < 9; j++) {
            key = map[i][j];

            if (!key) {
                coutZero++;
                continue;
            }
            if (coutZero > 0) {
                board += "" + coutZero;
                coutZero = 0;
            }
            board += comm.getFenKey(key);
        }
        if (coutZero > 0) {
            board += "" + coutZero;
            coutZero = 0;
        }
        if (i < (map.length - 1)) {
            board += "/";
        }
    }
    comm.getHold(isBegin) == 1 ? (board += " w") : (board += " b");
    return board;
}
resetBoardString = function (board) {
    if (isReverseBoard(board)) {
        var temp = board.slice(0, board.length - 2).split("/").reverse();
        var temp2 = board.slice(board.length - 2, board.length);
        var result = "";
        for (var i = 0; i < temp.length; i++) {
            var str = temp[i].split("").reverse().join("");
            if (i < (temp.length - 1)) {
                result += str + "/";
            } else {
                result += str;
            }
        }
        return result + temp2;
    }
    return board;
}

function isReverseBoard(str) {
    var temp = str.split("/");
    for (var i = 0; i < 3; i++) {
        if (temp[i].indexOf('K') != -1) {
            return true;
        }
    }
    return false;
}
/*获取棋盘取反状态*/
comm.getReverse = function () {
    for (var i = 0; i < 3; i++) {
        for (var j = 3; j < 6; j++) {
            if (comm.map[i][j] == "J0") {
                return !1;
            }
        }
    }
    return !0;
}
/*id2name*/
comm.id2name = {
    16: "J",
    17: "S",
    18: "X",
    19: "M",
    20: "C",
    21: "P",
    22: "Z",
    8: "j",
    9: "s",
    10: "x",
    11: "m",
    12: "c",
    13: "p",
    14: "z"
}
/*name2id*/
comm.name2id = {
    J: 16,
    S: 17,
    X: 18,
    M: 19,
    C: 20,
    P: 21,
    Z: 22,
    j: 8,
    s: 9,
    x: 10,
    m: 11,
    c: 12,
    p: 13,
    z: 14
}
comm.getFenKey = function (e) {
    var key = {
        "J0": "k",
        "X0": "b",
        "X1": "b",
        "S0": "a",
        "S1": "a",
        "Z0": "p",
        "Z1": "p",
        "Z2": "p",
        "Z3": "p",
        "Z4": "p",
        "C0": "r",
        "C1": "r",
        "M0": "n",
        "M1": "n",
        "P0": "c",
        "P1": "c",
        "j0": "K",
        "x0": "B",
        "x1": "B",
        "s0": "A",
        "s1": "A",
        "z0": "P",
        "z1": "P",
        "z2": "P",
        "z3": "P",
        "z4": "P",
        "c0": "R",
        "c1": "R",
        "m0": "N",
        "m1": "N",
        "p0": "C",
        "p1": "C"
    }[e] || "";
    return key;
}
/*上下翻转后,所有node节点的走法转换*/
comm.reverseMoves = function () {
    for (a = 0; a < comm.nodes.length; a++) {
        var node = comm.nodes[a];
        if (node && node.step) {
            node.step = reverseStep(node.step);
        }
    }
}
/*步法step转坐标*/
comm.Step2XY = function (e) {
    var m = e.split("");
    var o = { src: { x: parseInt(m[0]), y: parseInt(m[1]) }, dst: { x: parseInt(m[2]), y: parseInt(m[3]) } };
    return o;
}
/*步法step转坐标*/
comm.Step2FT = function (e) {
    var m = e.split("");
    var o = { from_pos: { x: parseInt(m[0]), y: parseInt(m[1]) }, to_pos: { x: parseInt(m[2]), y: parseInt(m[3]) } };
    return o;
}
/*step的XY坐标互换*/
comm.YX2XY = function (e) {
    var m = e.split("");
    var o = [];
    o[0] = m[1];
    o[1] = m[0];
    o[2] = m[3];
    o[3] = m[2];
    return o.join("");
}
/*坐标转步法step*/
comm.XY2Step = function (move) {
    return move.src.x + "" + move.src.y + move.dst.x + move.dst.y;
}
/*解析以cid，x，y为信息的棋盘数组，转化为map*/
comm.parseMap = function (e) {
    var a = e, m = emptyMap.concat(), o = {};
    for (var n = 0; n < a.length; n++) {
        var t = a[n];
        var s = comm.id2name[t.cid];
        var r = "";
        void 0 == o[s] ? (o[s] = 0, r = s + o[s]) : (o[s]++, r = s + o[s]),
            m[reverseY(t.y - 1)][t.x - 1] = r
    }
    return m
}
/*解析以step,id，perid,index为信息的moves，转化为*/
comm.parseMoves = function (e) {
    var a = e;
    for (var m = 0; m < a.length; m++) {
        a[m].src.x = a[m].src.x - 1;
        a[m].src.y = reverseY((a[m].src.y - 1));
        a[m].dst.x = a[m].dst.x - 1;
        a[m].dst.y = reverseY((a[m].dst.y - 1))
    }
    return a
}
/*解析以step,id，perid,index为信息的moves,转换为step,id，perid数组*/
comm.parseMovesEx = function (e) {
    if (!comm.nodes.length) {
        var obj = { id: 0, pater: 0, step: 0, index: 0, stepcn: 0, currentFen: comm.getBoard() };
        var node = new Node(obj);
        node.pater = -1;
        comm.nodes.push(node);
    }
    for (var a = [], m = 0; m < e.length; m++) {
        if (a[e[m].index]) {
            if (e[m] && e[m].step) {
                a[e[m].index].push([e[m].step, e[m].id, e[m].perid]);
            }

        } else {
            a[e[m].index] = new Array();
            if (e[m] && e[m].step) {
                a[e[m].index].push([e[m].step, e[m].id, e[m].perid]);
            }

        }
        if (e[m] && e[m].step) {
            var obj = { id: e[m].id, pater: e[m].perid, step: e[m].step, index: parseInt(e[m].index) + 1 };
            var node = new Node(obj);
            comm.nodes[node.id] = node;
            comm.nodes[node.pater].child.push(node.id);
        }

    }
    currentId = 0;
    return a
}
/*验证FEN的合法性*/
comm.VerifyFEN = function (s) {
    if (s) {
        if (s.indexOf('k') == -1 || s.indexOf('K') == -1) {
            return false;
        }
        s = s.replace(/[\r\n]/, '');
        s = s.replace(/%20/, ' ');
        s = s.replace(/\+/, ' ');
        s = s.replace(/ b.*/g, ' b');
        s = s.replace(/ w.*/g, ' w');
        s = s.replace(/ r.*/g, ' w');
        if (s.search(/\+/) != -1) {
            s = s.substr(0, s.search(/\+/));
        }

        var a = new Array();
        var sum = 0;
        var w = new String(s.substr(s.length - 2, 2));
        w = w.toLowerCase();
        if (w != ' w' && w != ' b') {
            return (0);
        }
        s = s.substr(0, s.length - 2);
        a = String(s).split(/\//);
        if (a.length != 10) {
            return (0);
        }
        for (var x = 0; x < 10; x++) {
            sum = 0;
            if (String(a[x]).search(/[^1-9kabnrcpKABNRCP]/) != -1) {
                return (0);
            }
            a[x] = String(a[x]).replace(/[kabnrcpKABNRCP]/g, '1');
            while (String(a[x]).length != 0) {
                sum = sum + Number(String(a[x]).charAt(0));
                a[x] = String(a[x]).substr(1);
            }
            if (sum != 9) {
                return (0);
            }
        }
        return (1);
    } else {
        return (0);
    }
}
/*检查将、士、象、兵、卒的位置是否合法*/
comm.checkMans = function (e, p) {
    a = p.y;
    m = p.x;
    e = e.slice(0, 1);
    var result = {};
    (isVerticalReverse == 0) ? (result = {
        "J": (a > -1 & 3 > a & m > 2 & 6 > m),
        "X": (((a == 0 || a == 4) & (m == 2 || m == 6)) || (a == 2 & (m == 0 || m == 4 || m == 8))),
        "S": (((a == 0 || a == 2) & (m == 3 || m == 5)) || (a == 1 & (m == 4))),
        "Z": (((a == 3 || a == 4) & (m == 0 || m == 2 || m == 4 || m == 6 || m == 8)) || (a > 4 & 10 > a)),
        "j": (a > 6 & 10 > a & m > 2 & 6 > m),
        "x": (((a == 5 || a == 9) & (m == 2 || m == 6)) || (a == 7 & (m == 0 || m == 4 || m == 8))),
        "s": (((a == 7 || a == 9) & (m == 3 || m == 5)) || (a == 8 & (m == 4))),
        "z": (((a == 5 || a == 6) & (m == 0 || m == 2 || m == 4 || m == 6 || m == 8)) || (a > -1 & 5 > a)),
        "C": !0,
        "M": !0,
        "P": !0,
        "c": !0,
        "m": !0,
        "p": !0
    }
    [e] || !1) : (result = {
        "j": (a > -1 & 3 > a & m > 2 & 6 > m),
        "x": (((a == 0 || a == 4) & (m == 2 || m == 6)) || (a == 2 & (m == 0 || m == 4 || m == 8))),
        "s": (((a == 0 || a == 2) & (m == 3 || m == 5)) || (a == 1 & (m == 4))),
        "z": (((a == 3 || a == 4) & (m == 0 || m == 2 || m == 4 || m == 6 || m == 8)) || (a > 4 & 10 > a)),
        "J": (a > 6 & 10 > a & m > 2 & 6 > m),
        "X": (((a == 5 || a == 9) & (m == 2 || m == 6)) || (a == 7 & (m == 0 || m == 4 || m == 8))),
        "S": (((a == 7 || a == 9) & (m == 3 || m == 5)) || (a == 8 & (m == 4))),
        "Z": (((a == 5 || a == 6) & (m == 0 || m == 2 || m == 4 || m == 6 || m == 8)) || (a > -1 & 5 > a)),
        "C": !0,
        "M": !0,
        "P": !0,
        "c": !0,
        "m": !0,
        "p": !0
    }
    [e] || !1)
    return result;
}
/*检查将军*/
comm.checkJiang = function () {
    for (var e = 0; e < 3; e++) {
        for (var a = 3; a < 6; a++) {
            var m = comm.map[e][a];
            if (m == "J0" || m == "j0") {
                var flag = 0;
                for (var o = e + 1; o < comm.map.length; o++) {
                    m = comm.map[o][a];
                    if (m == "J0" || m == "j0") {
                        if (flag == 0)
                            return !1;
                    } else if (m) {
                        flag++;
                    }
                }
                return !0;
            }
        }
    }
    return !0;
}
/*获取URL参数*/
comm.getUrlParam = function (e) {
    var a = new RegExp("(^|&)" + e + "=([^&]*)(&|$)"),
        m = window.location.search.substr(1).match(a);
    return null != m ? unescape(m[2]) : null
}
/*获取运行环境信息*/
getEnv = function () {
    var e = navigator.userAgent.toLowerCase();
    return /micromessenger(\/[\d\.]+)*/.test(e) ? "weixin" : /qq\/(\/[\d\.]+)*/.test(e) || /qzone\//.test(e) ? "qq" : "web"
}
/*设置各种按键是否可用*/
setEnable = function (e, a) {
    1 == a ? (vue[e] = false) : (vue[e] = true)
}
Array.prototype.indexOf = function (val) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == val) return i;
    }
    return -1;
};
Array.prototype.remove = function (val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};
/*判断数组中是否包含某字符串*/
Array.prototype.contains = function (needle) {
    for (i in this) {
        if (this[i].indexOf(needle) > 0)
            return i;
    }
    return -1;
}

