/*解析返回信息*/
var flagWaitAjax=false;
comm.ParseMsg = function (data) {
    if (data.errno == 0) {
        switch (data.data.type) {
            case 0: //开局
                if (data.data.params.isStartLibrary === 3) {
                    flagWaitAjax = true;
                }
                console.log(JSON.stringify(data.data));
                comm.DealOpenbook(data.data.result, data.data.movesIndex, data.data.params);
                break;
            case 1: //中局
                console.log(data.data.params.isStartLibrary);

                if (mode == playmode.CHESSANALYSE && data.data.params.isRetry) {
                    comm.DealRetry(data.data);
                } else {
                    comm.DealPosition(data.data.result, data.data.score, data.data.movesIndex, data.data.isKjk, data.data.isCjk, data.data.params, data.data.isInfinite);
                }

                break;
            case 2: //残局
                comm.DealCjk(data.data.result, data.data.score, data.data.movesIndex, data.data.params);
                break;
            default:
                break;
        }
    } else {
        vue.$toast(data.message);
    }
    if (isanalyse && mode != playmode.CHESSANALYSE) {
        waitServerPlay = false;
    }
}
comm.DealRetry = function (data) {
    var tempItem = vue.retryList.list[vue.retryItem.index];
    if (tempItem.testMove == tempItem.correctMove) tempItem.isCorrect = true;
    var score = comm.isOffensive ? -data.score : data.score;
    var obj = getRetryObj(data.isKjk, tempItem.isCorrect, score, vue.retryItem.id);
    tempItem.testScore = score;
    tempItem.testGrade = obj.grade;
    tempItem.testColor = obj.color;
    tempItem.isAnalyse = false;
    vue.$set(vue.retryList.list, vue.retryItem.index, tempItem);
    if (movesIndex > 0 && vue.isRetry) {
        cleanLine2();
        movesIndex -= 1;
        currentId = movesIndex;
        if (comm.nodes[movesIndex].child[comm.nodes[movesIndex].child.length - 1] == comm.nodes[comm.nodes.length - 1].id && movesIndex != comm.nodes.length - 2) {
            comm.nodes.pop();
            comm.nodes[movesIndex].child.pop();
        }
        moves = comm.getMoves4Server();
        waitServerPlay = true;
        vue.clickRetryItem(vue.retryItem.index);
    }
}
/*解析返回的开局库信息*/
comm.DealOpenbook = function (list, index, params) {
    var node = comm.nodes[params.currentId];
    node.tipsStep[0] = list[0] && list[0][0];
    var openList = [];
    for (var i = 0; i < list.length; i++) {
        var info = list[i];
        if (info[0]) {
            openList[i] = {};
            openList[i].step = info[0];
            var total = parseInt(info[1]) + parseInt(info[2]) + parseInt(info[3]);
            openList[i].win = Math.round(parseInt(info[1]) / total * 100);
            openList[i].loss = Math.round(parseInt(info[3]) / total * 100);
            openList[i].he = 100 - Math.round(parseInt(info[1]) / total * 100) - Math.round(parseInt(info[3]) / total * 100);
            if (info[4]){
                openList[i].fenValue = info[4];
            } else if (info[5]){
                openList[i].fenValue = info[5];
            } else {
                openList[i].fenValue = 0;
            }
        }
    }
    node.openbookDetail = openList;
    //电脑执黑或者红，自动走棋
    if (!isanalyse && mode == playmode.ANALYSE) {
        var tempIndex = vue.startLibrary == 3||vue.startLibrary == 4 ? analyseMachine[1].kaiju : analyseMachine[0].kaiju;
        tempIndex = parseInt(tempIndex.split(',')[1]);
        setTimeout((function () {
            if (list[0] && Math.ceil(index / 2) <= tempIndex && params.currentId == comm.nodes.length - 1) {
                console.log("走棋");
                Player.serverAIPlay(list[0][0]);
            }
        }), 300);
    }
    if (mode == playmode.CREATE){
        replayBtnUpdate();
    }
}
/*解析返回引擎信息*/
var lastRefreshTime=0;
comm.DealPosition = function (list, score, index, isKjk, isCjk, params) {
    console.log(params.isStartLibrary);
    console.log(vue.startLibrary);
    if (params.isStartLibrary != vue.startLibrary) return;
    var node = comm.nodes[params.currentId];
    if (node) {
        node.isKjk = isKjk;
        var middleList = [];
        if (typeof list == "string" && (list.match("checkmate") || list.match("stalemate") || list.match("slatemate") || list.match("none"))) {
            if (mode != playmode.ANALYSE || !isCjk) comm.onGameEnd();
        } else {
            for (var i = 0; i < list.length; i++) {
                var tempList = {};
                tempList.depth = list[i][0];
                tempList.list = list[i][2];
                tempList.step = list[i][2][0];
                tempList.tmpStr = '';
                var tempScore = list[i][1];
                comm.isOffensive ? tempList.score = -tempScore : tempList.score = tempScore;
                var tempArr = list[i][2];
                for (var j = 0; j < tempArr.length; j++) { //返回的推荐步数，限制只显示四招
                    var step = tempArr[j];
                    if (j < 2 && i === 0) {
                        if (node) {
                            node.tipsStep[j] = step;
                        }
                    }
                }
                var flag = true;
                for (var k = 0; k < node.computerDetail.length; k++) {
                    if (vue.wzVip == 1) {
                        if (node.computerDetail[k].depth == tempList.depth) {
                            if (tempList.list && node.computerDetail[k].list && tempList.list.length > node.computerDetail[k].list.length) {
                                node.computerDetail[k] = tempList;
                            }
                            flag = false;
                        }
                    }
                }
                if (flag) middleList.push(tempList);
            }
        }
        console.log("判断会员");
        if (vue.wzVip == 1) {
            node.computerDetail = middleList.concat(node.computerDetail);
            node.computerDetail.sort(function (a, b) {
                if (b[0] && a[0]) {
                    return b[0].depth - a[0].depth;
                }
            })
        } else {
            node.computerDetail = middleList;
        }
        if (node.chessdbDetail.length == 0) {
            comm.isOffensive ? node.score = -score : node.score = score;
        }
        console.log(mode == playmode.ANALYSE && comm.nodes.length >= 1);
        if (mode == playmode.ANALYSE && comm.nodes.length >= 1) {
            if (new Date().getTime() - lastRefreshTime > 0) {
                lastRefreshTime = new Date().getTime();
                if (vue.startLibrary == 3) {
                    if (flagWaitAjax) {
                        vue.refreshJushi();
                    } else {
                        setTimeout((function () {
                            vue.refreshJushi();
                        }), 2000);
                    }
                } else {
                    vue.refreshJushi();
                }
            }
        }
        if (mode == playmode.CHESSANALYSE) {
            if (comm.nodes.length >= 1 && (vue.dataY.length == 0 || typeof vue.dataY[analyseIndex][analyseIndex2] == 'undefined')) {
                vue.refreshJushi2(analyseIndex, turnScore(node.score));
            }
            analyseIndex2 = index + 1;
        }

        if (!isanalyse && mode != playmode.CHESSANALYSE && typeof list != "string" && list[0]) {

            // if (mode == playmode.ANALYSE && ((list[0][0] < 24 && vue.depth == -1) || isCjk)) return;

            if (((comm.getHold() == BLACK && b_autoset) || (comm.getHold() == RED && r_autoset)) && movesIndex == moves.length) {

                if (mode == playmode.ANALYSE && vue.currentAnalyseData.show) {
                    vue.rebackCurrent();
                }
                setTimeout((function () {

                    if (params.currentId == comm.nodes.length - 1) {

                        Player.serverAIPlay(list[0][2][0]);
                    }
                }), 300);
            }
        }
    }
}
/*解析返回的残局库信息*/
comm.DealCjk = function (list, score, index, params) {
    console.log("DealCjk");
    var node = comm.nodes[params.currentId];
    node.tipsStep[0] = list && list[0] && list[0][0];
    var endList = [];
    if (list.length == 0) {
        comm.onGameEnd();
    } else {
        for (var i = list.length - 1; i >= 0; i--) {
            var info = list[i];
            endList[i] = {};
            endList[i].step = info[0];
            endList[i].result = (comm.getHold() == 1 ? '红' : '黑') + info[2];
            endList[i].sha = info[2] != '和' ? Math.ceil(info[3].split("-")[1] / 2) : '';
        }
    }
    node.chessdbDetail = endList;
    if (node.score != null) {
        comm.isOffensive ? node.score = -score : node.score = score;
        //更新局势图
        if (mode == playmode.CHESSANALYSE) {
            var option = vue.myChart.getOption();
            var serIndex = vue.getSeries(params.currentId);
            vue.dataY[serIndex][index] = turnScore(node.score);
            option.series[serIndex].data = vue.dataY[serIndex];
            vue.myChart.setOption(option, true);
        }
    } else {
        comm.isOffensive ? node.score = -score : node.score = score;
    }
    if (mode == playmode.ANALYSE && comm.nodes.length >= 1) {
        vue.refreshJushi();
    }
    if (!isanalyse && mode != playmode.CHESSANALYSE) {
        if (((comm.getHold() == BLACK && b_autoset) || (comm.getHold() == RED && r_autoset)) && movesIndex == moves.length) {
            if (mode == playmode.ANALYSE && vue.currentAnalyseData.show) {
                vue.rebackCurrent();
            }
            setTimeout((function () {
                if (list[0] && params.currentId == comm.nodes.length - 1) {
                    Player.serverAIPlay(list[0][0]);
                }
            }), 300);
        }
    }
}
sortList = function (list) {
    for (var x = 0; x < list.length - 1; x++) {
        for (var y = 0; y < list.length - 1 - x; y++) {
            var temp1 = parseInt((list[y].split(",")[3] || "0-100").split("-")[1]);
            var temp2 = parseInt((list[y + 1].split(",")[3] || "0-100").split("-")[1]);
            if (temp1 < temp2) {
                var times = list[y];
                list[y] = list[y + 1];
                list[y + 1] = times;
            }
        }
    }
    var sheng = [];
    var fu = [];
    var he = [];
    for (var i = 0; i < list.length; i++) {
        if (list[i].split(",")[2] == '胜') {
            sheng.push(list[i]);
        }
        if (list[i].split(",")[2] == '和') {
            he.push(list[i]);
        }
        if (list[i].split(",")[2] == '负') {
            fu.push(list[i]);
        }
    }
    if (comm.getHold() == 1) { //红走
        fu = fu.reverse();
        list = fu.concat(he).concat(sheng);
    } else {
        // sheng = sheng.reverse();
        // he = he.reverse();
        fu = fu.reverse();
        list = fu.concat(he).concat(sheng);
    }
    return list;
}
/*查找是否存在分支, 不存在分支则创建node节点*/
comm.branch = function (move) {
    step = comm.XY2Step(move);
    /*如果链表为空，插入根节点*/
    if (!comm.nodes.length) {
        var obj = { id: 0, pater: 0, step: 0, index: 0, stepcn: 0, currentFen: comm.getBoard() };
        var node = new Node(obj);
        node.pater = -1;
        comm.nodes.push(node);
        return false;
    }
    /*检查是否已存在*/
    if (!comm.checkbranch(step)) {
        var obj = {
            id: comm.nodes.length,
            pater: currentId,
            step: step,
            index: movesIndex,
            stepcn: stepcn,
            state: state,
            eatKey: eatKey
        };
        var node = new Node(obj);
        comm.nodes.push(node);
        comm.nodes[node.pater].child.push(node.id);
        currentId = comm.nodes.length - 1;
        eatKey = "";
        return false;
    }
    return true;
}
/*检查分支*/
comm.checkbranch = function (step) {
    if (comm.nodes[currentId].child.length == 0) {
        return !1;
    } else {
        var childID = comm.nodes[currentId].child;
        for (var i = 0; i < childID.length; i++) {
            var childstep = comm.nodes[childID[i]].step;
            if (childstep == step) {
                currentId = comm.nodes[childID[i]].id;
                return !0;
            }
        }
    }
    return !1;
}
comm.deleteBranch = function (index) {
    var childID = comm.nodes[currentId].child[index];
    var childIDs = comm.getChildNodes(childID);
    for (var i = 0; i < childIDs.length; i++) {
        delete comm.nodes[childIDs[i]];
    }
    comm.nodes[currentId].child.splice(index, 1);
    replayBtnUpdate();
    vue.hasChange = true;
}
comm.getChildNodes = function (root) {
    var childnodes = [];

    function nodeList(node) {
        if (!node) {
            return false;
        }
        childnodes.push(node.id);
        if (node.child && node.child.length > 0) {
            for (var i = 0; i < node.child.length; i++) {

                nodeList(comm.nodes[node.child[i]]);
            }
        }
        return childnodes;
    }

    return nodeList(comm.nodes[root]);
}
//获取所有的分支序列
comm.getBranch = function (root) {
    var branchs = [];
    function nodeList(node, path) {
        if (!node) {
            return false;
        }
        if (!path) {
            path = ''
        }
        if (node.child && node.child.length > 0) {

            path = path + node.id + '/';

            for (var i = 0; i < node.child.length; i++) {

                nodeList(comm.nodes[node.child[i]], path);
            }
        } else {

            path = path + node.id;
            branchs.push(path);
            return;

        }
        return branchs;
    }

    var list = nodeList(comm.nodes[root], '') || [];
    if (comm.nodes.length == 1) {
        list = ["0"];
    }
    var paths = [];
    for (var i = 0; i < list.length; i++) {
        paths[i] = {};
        paths[i].X = [];
        paths[i].Y = [];
        paths[i].ID = list[i].split("/");
        for (var j = 0; j < list[i].split("/").length; j++) {
            paths[i].ID[j] = parseInt(paths[i].ID[j]);
            paths[i].X[j] = j;
            // paths[i].Y[j] = Math.round(1000*Math.log(comm.nodes[paths[i].ID[j]].score));
            var temp = turnScore(comm.nodes[paths[i].ID[j]].score);
            paths[i].Y[j] = temp;
        }
    }
    return paths;
}

comm.getChessScore = function (map) {
    var map = map || comm.map;
    var score = { red: 0, black: 0 };

    for (var i = 0; i < 10; i++) {
        for (var j = 0; j < 9; j++) {
            var man = map[i][j];
            if (man != '' && man != undefined) {

                if (chessScore[man[0]] != undefined) {
                    if (/[A-Z]/.test(man[0])) { //黑方
                        score.black += chessScore[man[0]];
                    } else {
                        score.red += chessScore[man[0]];
                    }
                }
            }
        }
    }
    return score;
}
comm.setHistoryStorage = function () {
    console.log("weiwei setHistoryStorage")
    var data = {};
    data.cMap = comm.cMap;
    data.moves = comm.getMoves4Server2();
    data.notes = comm.getNewNotes4Server();
    data.movesIndex = movesIndex;
    data.canvasList = vue.canvasList;
    data.reportResult = vue.reportResult;
    var thinkinfo = [];
    for (var i = 0; i < comm.nodes.length; i++) {
        if (comm.nodes[i]) {
            var temp = {};
            temp.id = comm.nodes[i].id;
            temp.score = comm.nodes[i].score;
            temp.isKjk = comm.nodes[i].isKjk;
            temp.computerDetail = JSON.stringify(comm.nodes[i].computerDetail);
            temp.openbookDetail = JSON.stringify(comm.nodes[i].openbookDetail);
            temp.chessdbDetail = JSON.stringify(comm.nodes[i].chessdbDetail);
            temp.tipsStep = JSON.stringify(comm.nodes[i].tipsStep);
            thinkinfo.push(temp);
        }
    }
    data.thinkinfo = thinkinfo;
    var historyChessdata = localStorage.getItem('historyChessdata');
    try {
        if (historyChessdata) {
            historyChessdata = JSON.parse(historyChessdata);
            if (data.moves.length > 0) {
                if (historyChessdata.chessid) {
                    historyChessdata.chessid[chessid] = JSON.stringify(data);
                } else {
                    historyChessdata.chessid = {};
                    historyChessdata.chessid[chessid] = JSON.stringify(data);
                }
                localStorage.setItem('historyChessdata', JSON.stringify(historyChessdata));
            }
        } else {
            historyChessdata = {};
            if (data.moves.length > 0) {
                historyChessdata.chessid = {};
                historyChessdata.chessid[chessid] = JSON.stringify(data);
                localStorage.setItem('historyChessdata', JSON.stringify(historyChessdata));
            }
        }
    } catch (e) {
        localStorage.removeItem('historyChessdata');
    }
}
comm.clearHistoryStorage = function (chessId) {
    var historyChessdata = JSON.parse(localStorage.getItem("historyChessdata") || "{}");
    if (historyChessdata && historyChessdata.chessid && historyChessdata.chessid[chessId]) {
        historyChessdata.chessid[chessId] = '';
        localStorage.setItem('historyChessdata', JSON.stringify(historyChessdata));
    }
}
comm.step2cidmoves = function (moves) {
    moves = moves.replace(/^\s*|\s*$/g, "");
    var tempmove = moves.split(" ");
    var step = [];
    for (var i = 0; i < tempmove.length; i += 4) {
        var temp = {};
        temp.step = tempmove[i];
        temp.id = tempmove[i + 1];
        temp.perid = tempmove[i + 2];
        temp.index = tempmove[i + 3];
        step.push(temp);
    }
    return step;
}
comm.getMoves4Server2 = function () {
    var e = "";
    for (var a = 1; a < comm.nodes.length; a++) {
        var node = comm.nodes[a];
        if (node && node.id) {
            e += " " + node.step + " " + node.id + " " + node.pater + " " + (node.index - 1);
        }

    }
    return e
}
/*获取分支数量*/
comm.getBrachLength = function () {
    return comm.nodes[currentId].child.length;
}
/*获取当前节点*/
comm.getCurrentNode = function () {
    return comm.nodes[currentId];
}
/*判断是否为第一步*/
comm.isFirst = function () {
    return (movesIndex == 0);
}
/*判断是否为最后一步*/
comm.isEnd = function () {
    return (movesIndex == moves.length);
}
/*获取步法的长度*/
comm.getMovesLength = function () {
    moves = comm.getMoves4Server();
    return moves.length;
}
/*转到第几步*/
comm.gotoStep = function (moves, index, seriesIndex) {
    cleanLine();
    cleanLine2();
    cleanLineBranch();
    hideDots();
    hideBorder();
    hideLight();
    hidePane();
    cleanChess();
    currentId = 0;
    if (mode != playmode.CHESSANALYSE) {
        waitServerPlay = false;
    }
    comm.init(comm.cMap, !0);
    if (moves) {
        for (var e = 0; e < index; e++) {
            currentId = moves[e].id;
            var step = comm.Step2XY(moves[e].step);
            var nowManKey = comm.map[step.src.y][step.src.x];
            var resultKey = comm.map[step.dst.y][step.dst.x];
            if (resultKey) {
                var man = comm.mans[resultKey];
                man.isShow = !1;
                if (man.chess.parent) {
                    man.chess.parent.removeChild(man.chess)
                }
            }
            var nowMan = comm.mans[nowManKey];
            delete comm.map[nowMan.y][nowMan.x];
            comm.map[step.dst.y][step.dst.x] = nowManKey;
            nowMan.x = step.dst.x;
            nowMan.y = step.dst.y;
            nowMan.move();
            if (e == (index - 1)) {
                showPane(step.src.x, step.src.y);
                showLight(step.dst.x, step.dst.y);
            }
        }
    }
    if (mode == playmode.ANALYSE && vue.tabActive == 2) {
        vue.autoScroll();
    }
    onChangeTip(index, seriesIndex);
}
comm.getMoves4Server = function (id) {
    try {
        if (!comm.nodes.length) {
            return [];
        }
        if (mode == playmode.AIPLAY) {
            for (var e = [], a = 1; a < comm.nodes.length; a++) {
                e[a - 1] = comm.nodes[a];
            }
            return e
        }
        var e = [];
        var tempID = currentId;
        if (id) {
            var tempID = id;
        }
        /*向后延伸,获取终局ID,多条路径，默认选择第一条*/
        while (comm.nodes[tempID].child.length > 0) {
            tempID = comm.nodes[tempID].child[0];
        }
        /*回溯整条路径*/
        while (comm.nodes[tempID].pater > -1) {
            e.push(comm.nodes[tempID]);
            tempID = comm.nodes[tempID].pater;
        }
        return e.reverse();
    } catch (e) {
         console.log("getMoves4Server"+e,"weiwei");
        reportBugly(1)
    }
}
comm.getNewNotes4Server = function () {
    var e = [],
        o = "";

    for (var a = 0; a < comm.notes.length; a++) {
        o = (comm.notes[a]);
        if (o) {
            var temp = {};
            temp.id = a;
            temp.note = o;
            e.push(temp);
        }
    }
    return JSON.stringify(e)
}
/*显示走法*/
comm.showStep = function (step) {
    var tempmap = comm.arr2Clone(comm.map);
    stepcn = comm.createMove(tempmap, step);
    move = comm.Step2XY(step);
    if (!isVerticalReverse) {
        man = comm.mans[tempmap[move.dst.y][move.dst.x]];
    }
    return stepcn;
} //路路新增
/*游戏结束*/
comm.onGameEnd = function (type, reason, result) {
    waitServerPlay = false;
    var tempReason = '';
    var tempResult = 1;
    if (!type) {
        if (comm.Checked(comm.getOppHold())) {
            tempReason = '绝杀';
            showTip("gameCheckmate");
        } else {
            tempReason = '困毙';
            showTip("gameStalemate");
        }
        tempResult = comm.getHold() > 0 ? 2 : 1;
    } else {
        if (type == 'renshu') {
            tempReason = '我方认输';
            tempResult = computerHold > 0 ? 1 : 2;
        } else if (type == 'qiuhe') {
            tempReason = '我方求和';
            tempResult = 3;
        } else {
            tempReason = reason;
            tempResult = result;
        }
    }
    if (mode == playmode.AIPLAY) {
        setTimeout(function () {
            if (vue.pageType == 'man_machine'){
                if(comm.nodes[0].currentFen==InitFen){
                    if(type=='renshu'){
                        tempResult=2
                    }
                    vue.ajaxPost(xqwxt_url + '&op=ai_rank_set&do=chess', {
                         result:tempResult,
                         level_id:vue.currentLevel
                    }, function (vm, ret) {
                      vue.selfRate=ret.data
                    })
                }
                localStorage.removeItem('AiHistory');
            } 
            vue.qlcp_result.reason = tempReason;
            vue.qlcp_result.winner = tempResult;
            vue.qlcp_result.steps = Math.ceil(movesIndex / 2);
            var temp = {
                result: tempResult,
                reason: tempReason
            }
            onSend(temp, '', function (chessid) {
                vue.qlcp_result.chessid = chessid;
                vue.popupOver = true;
                if (vue.pageType == 'man_machine'){
                    mode = playmode.GAMEOVER
                }
            });
        }, 500);
    }
}
/*检查是否被将军*/
comm.Checked = function (my) {
    try {
        // if (waitServerPlay) {
        //     setTimeout((function () {
        //         comm.Checked(my)
        //     }), 500);
        //     return;
        // }
        my == BLACK ? jiang = comm.mans["j0"] : jiang = comm.mans["J0"];
        for (var key in comm.mans) {
            man = comm.mans[key];
            if (man.my != my || !man.isShow) {
                continue;
            }
            man.ps = man.bl();
            if (Player.indexOfPs(man.ps, [jiang.x, jiang.y])) {
                man.ps = [];
                return true;
            }
            man.ps = [];
        }
        return false;
    } catch (e) {
        reportBugly(2)
         console.log(e,"weiwei");
        return false;
    }
}
comm.getArrayKey = function (a, obj) {
    var i = a.length;
    while (i--) {
        if (a[i] === obj) {
            return i;
        }
    }
    return false;
}
/*解析注释信息*/
comm.parseNote = function (e) {
    for (var a = e, n = 0; n < a.length; n++) {
        var t = a[n].id + 1;
        comm.notes.length = t,
            comm.notes[t - 1] = a[n].note;
    }
}
/*解析思考细节信息*/
comm.parseThinkinfo = function (e) {
    for (var i = 0; i < e.length; i++) {
        if (e[i].id >= 0 && comm.nodes[e[i].id]) {
            comm.nodes[e[i].id].score = e[i].score;
            comm.nodes[e[i].id].isKjk = e[i].isKjk;
            comm.nodes[e[i].id].chessdbDetail = JSON.parse(e[i].chessdbDetail);
            comm.nodes[e[i].id].openbookDetail = JSON.parse(e[i].openbookDetail);
            comm.nodes[e[i].id].computerDetail = JSON.parse(e[i].computerDetail);
            comm.nodes[e[i].id].tipsStep = JSON.parse(e[i].tipsStep);
        }
    }
}
/*解析走法信息*/
comm.parseMoves = function (e) {
    for (var a = e, m = 0; m < a.length; m++) {
        a[m].src.x = a[m].src.x - 1,
            a[m].src.y = reverseY((a[m].src.y - 1)),
            a[m].dst.x = a[m].dst.x - 1,
            a[m].dst.y = reverseY((a[m].dst.y - 1))
    }
    return a
}
comm.getReport = function (index) {
    var index = index || 0;
    var branchs = comm.getBranch(index);
    if (branchs.length == 0) {
        return false;
    }
    var mainBranch = branchs[index]['ID'];
    for (var i = 1; i < mainBranch.length; i++) {
        comm.nodes[mainBranch[i]].userScore = parseInt(comm.nodes[mainBranch[i]].score) - parseInt(comm.nodes[mainBranch[i - 1]].score);
    }
    var report = {
        red: {
            zhongju: 100,
            canju: 100,
            losekill: 0,
            shiwu: 0,
            zonghe: 0,
            haszhongju: 0,
            hascanju: 0
        },
        black: {
            zhongju: 100,
            canju: 100,
            losekill: 0,
            shiwu: 0,
            zonghe: 0,
            haszhongju: 0,
            hascanju: 0
        }
    }
    if (comm.cMap.toString() === InitMap.toString()) {
        var kaiju = true;
        report.red.kaiju = report.black.kaiju = 100;
    } else {
        var kaiju = false;
    }
    var canIndex = 0;
    for (var i = 1; i < mainBranch.length; i++) {
        var tempScore = parseInt(comm.nodes[mainBranch[i]].score) - parseInt(comm.nodes[mainBranch[i - 1]].score);
        var tempChessScore = comm.nodes[mainBranch[i]].chessScore;
        if ((i % 2 == 1 && comm.isOffensive == 1) || (i % 2 == 0 && comm.isOffensive == 0)) {
            tempScore = -tempScore;
            var role = 'black';
        } else {
            var role = 'red';
        }
        if (i <= 20 && kaiju) {
            if (tempScore < -reportDefine.BK.S) {
                report[role].kaiju -= comm.getBaseLog(reportDefine.BK.log, -tempScore - reportDefine.BK.S);
            } else if (tempScore > reportDefine.BK.S) {
                // report[role].kaiju += comm.getBaseLog(reportDefine.BK.log, tempScore - reportDefine.BK.S);
            }

        } else {
            if (parseInt(tempChessScore.red) < reportDefine.isCJ && parseInt(tempChessScore.black) < reportDefine.isCJ) { //进入残局
                report[role].hascanju = 1;
                if (!canIndex) {
                    canIndex = i;
                }
                if (tempScore < -reportDefine.BC.S) {
                    report[role].canju -= comm.getBaseLog(reportDefine.BC.log, -tempScore - reportDefine.BC.S);
                } else if (tempScore > reportDefine.BC.S) {
                    // report[role].canju += comm.getBaseLog(reportDefine.BC.log, tempScore - reportDefine.BC.S);
                }
            } else { //中局
                if (comm.nodes[mainBranch[i]].score < 29000) {
                    report[role].haszhongju = 1;
                    if (tempScore < -reportDefine.BZ.S) {
                        report[role].zhongju -= comm.getBaseLog(reportDefine.BZ.log, -tempScore - reportDefine.BZ.S);
                    } else if (tempScore > reportDefine.BZ.S) {
                        // report[role].zhongju += comm.getBaseLog(reportDefine.BZ.log, tempScore - reportDefine.BZ.S);
                    }
                }
            }
        }
        //判断杀棋
        if (-tempScore > reportDefine.BS.S && ((role == 'red' && comm.nodes[mainBranch[i - 1]].score > 10000) || (role == 'black' && comm.nodes[mainBranch[i - 1]].score < -10000))) {
            if (comm.nodes[mainBranch[i - 1]].tipsStep && (comm.nodes[mainBranch[i - 1]].tipsStep[0] != comm.nodes[mainBranch[i]].step)) {
                report[role].losekill++;
                comm.nodes[mainBranch[i]].losekill = 1;
                var tempFlag1 = false;
                for (var k = 0; k < vue.canvasList.length; k++) {
                    if (vue.canvasList[k].id == i - 1) {
                        tempFlag1 = true;
                    }
                }
                if (!tempFlag1) {
                    vue.canvasList.push({
                        id: i - 1,
                        fen: comm.nodes[mainBranch[i - 1]].currentFen,
                        type: role == 'red' ? 1 : 2
                    })
                }
            }
        }
        //判断失误
        if (-tempScore > reportDefine.SW.S && ((role == 'red' && comm.nodes[mainBranch[i - 1]].score < 10000) || (role == 'black' && comm.nodes[mainBranch[i - 1]].score > -10000))) {
            if (comm.nodes[mainBranch[i - 1]].tipsStep && (comm.nodes[mainBranch[i - 1]].tipsStep[0] != comm.nodes[mainBranch[i]].step)) {
                comm.nodes[mainBranch[i]].isSW = 1;
                report[role].shiwu++;
                var tempFlag2 = false;
                for (var k = 0; k < vue.canvasList.length; k++) {
                    if (vue.canvasList[k].id == i - 1) {
                        tempFlag2 = true;
                    }
                }
                if (!tempFlag2) {
                    vue.canvasList.push({
                        id: i - 1,
                        fen: comm.nodes[mainBranch[i - 1]].currentFen,
                        type: role == 'red' ? 3 : 4
                    })
                }
            }
        }
    }

    //计算综合分数
    if (report.red.kaiju) {
        if (report.red.haszhongju && report.red.hascanju) {
            report.red.zonghe = (report.red.kaiju + report.red.zhongju + report.red.canju) / 3;
            report.black.zonghe = (report.black.kaiju + report.black.zhongju + report.black.canju) / 3;
        } else if (report.red.haszhongju) {
            report.red.zonghe = (report.red.kaiju + report.red.zhongju) / 2;
            report.black.zonghe = (report.black.kaiju + report.black.zhongju) / 2;
        } else if (report.red.hascanju) {
            report.red.zonghe = (report.red.kaiju + report.red.canju) / 2;
            report.black.zonghe = (report.black.kaiju + report.black.canju) / 2;
        } else {
            report.red.zonghe = report.red.kaiju;
            report.black.zonghe = report.black.kaiju;
        }
    } else {
        if (report.red.haszhongju && report.red.hascanju) {
            report.red.zonghe = (report.red.zhongju + report.red.canju) / 2;
            report.black.zonghe = (report.black.zhongju + report.black.canju) / 2;
        } else if (report.red.haszhongju) {
            report.red.zonghe = report.red.zhongju;
            report.black.zonghe = report.black.zhongju;
        } else if (report.red.hascanju) {
            report.red.zonghe = report.red.canju;
            report.black.zonghe = report.black.canju;
        }
    }

    for (var key in report) {
        for (var j in report[key]) {
            report[key][j] = parseInt(report[key][j]);
            report[key][j] = report[key][j] > 100 ? 100 : report[key][j];
            report[key][j] = report[key][j] < 0 ? 0 : report[key][j];
        }
    }
    report.canIndex = canIndex;

    return report;
}
comm.getBaseLog = function (x, y) {
    return Math.log(y) / Math.log(x);
}
/*遍历节点*/
comm.searchNodes = function (index) {
    try {
        var branchs = comm.getBranch(index);
        var tempbranch = [];
        for (var i = 0; i < branchs.length; i++) {
            tempbranch = branchs[i].ID;
            if (i > 0) {
                comm.map = comm.clone(comm.cMap);
                cleanChess();
                comm.init(comm.map, !0);
            }
            for (var j = 0; j < tempbranch.length; j++) {
                if (tempbranch[j] != 0) {
                    var tempNode = comm.nodes[tempbranch[j]];
                    currentId = tempbranch[j];
                    movesIndex = j;
                    if (!comm.nodes[tempbranch[j]].stepcn) {
                        var tempMap = comm.arr2Clone(comm.map);
                        comm.nodes[tempbranch[j]].stepcn = comm.createMove(tempMap, tempNode.step);
                    }
                    Player.stepPlay(tempNode.step);
                    comm.nodes[tempbranch[j]].chessScore = comm.getChessScore();
                    comm.nodes[tempbranch[j]].currentFen = comm.getBoard()
                }
            }
        }
    } catch (e) {
        console.log(e,"weiwei");
        reportBugly(3)
    }
}
comm.getMap4Server2 = function (e) {
    var map6server = "";
    for (var a = 10, m = 0; m < e.length; m++) {
        for (var o = e[m], n = 0; n < o.length; n++) {
            var t = o[n];
            if (t) {
                var s = comm.name2id[t.split("")[0]];
                map6server += " " + s + " " + (n + 1) + " " + a;
            }
        }
        a--
    }
    return map6server
}
comm.getNotes4Server = function () {
    var e = "",
        o = "";
    for (var a = 0; a < comm.notes.length; a++) {
        o = (comm.notes[a]);
        if (o) {
            e += " " + a + " " + o;
        }
    }
    return e
}
comm.getinitBoard = function () {
    //comm.getReverse() ? map = comm.arrReverse(comm.Cmap) : map = comm.arr2Clone(comm.map);
    map = comm.cMap;
    var key = "";
    var coutZero = 0;
    var board = "";
    for (var i = 0; i < 10; i++) {
        coutZero = 0;
        for (var j = 0; j < 9; j++) {
            key = map[i][j];

            if (!key) {
                coutZero++;
                continue;
            }
            if (coutZero > 0) {
                board += "" + coutZero;
                coutZero = 0;
            }
            board += comm.getFenKey(key);
        }
        if (coutZero > 0) {
            board += "" + coutZero;
            coutZero = 0;
        }
        if (i < (map.length - 1)) {
            board += "/";
        }
    }
    comm.isOffensive != 1 ? (board += " w") : (board += " b");
    return board;
}
