/*初始化*/
initialization = function (e, id, map, type, vertical, step) {
    comm.pointStartX = (CANVAS_W - SPACE_W * 9) / 2;
    comm.pointStartY = (CANVAS_H - SPACE_H * 10 - 10) / 2;
    if (id) {
        initCanvasById(e, id);
        for (var a = 0; a < map.length; a++) {
            for (var m = 0; m < map[a].length; m++) {
                var o = map[a][m];
                if (o) {
                    var n = new Man(o);
                    n.x = m;
                    n.y = a;
                    var t = addChess(n.pater);
                    n.chess = t;
                    n.move()
                }
            }
        }
        if (type) {
            if (step) {
                drawLine3(step, 1, type);
            } else {
                drawLine3(comm.nodes[vue.branchList[0].ID[parseInt(id) + 1]].step, 4, type);
            }
            initBoard(1);
        } else {
            initBoardByVertical(vertical);
        }
    } else {
        initCanvas(e);
        comm.dot = {
            dots: []
        }; //提示点
        initChess(initMap);
    }
}
/*响应声音按钮*/
onSound = function () {
    voicemode == 1 ? voicemode = 0 : voicemode = 1
}
/*摆满棋子*/
onFullBroad = function (e) {
    cleanChess();
    cleanChessEx();
    isVerticalReverse ? initMap = arrReverse(InitMap) : initMap = comm.arr2Clone(InitMap);
    comm.sMap = comm.arr2Clone(sMapEmpty),
        comm.sMapList = JSON.parse(JSON.stringify(emptychessMan)),
        comm.init(initMap, !1);
    vue.isFull = true;
}
/*清空棋子*/
onCleanBroad = function (e) {
    cleanChess();
    cleanChessEx();
    var emptyMap;
    isVerticalReverse ? emptyMap = arrReverse(EmptyMap) : emptyMap = comm.arr2Clone(EmptyMap);
    isVerticalReverse ? comm.sMap = comm.arr2Clone(sMapFullReveser) : comm.sMap = comm.arr2Clone(sMapFull);
    comm.sMapList = JSON.parse(JSON.stringify(chessMan));
    comm.init(emptyMap, !1);
    createMansEx(comm.sMap);
    vue.isFull = false;
}
/*响应先后手*/
onOffensive = function () {
    if (movesIndex > 0 || comm.nodes.length > 1) {
        vue.$toast('棋局已开始，请重新开始后再选择');
        vue.isOffensiveTog = !vue.isOffensiveTog;
        return;
    }
    comm.isOffensive == 1 ? comm.isOffensive = 0 : comm.isOffensive = 1;
    vue.isOffensive == 1 ? vue.isOffensive = 0 : vue.isOffensive = 1;
    if (comm.isOffensive == 0) {
        vue.$toast('红先');
    } else {
        vue.$toast('黑先');
    }
}
/*响应棋谱所有着法分析模式*/
onAnalyseOriginal = function () {
    voicemode = 0;
    resultList = comm.getBranch(0);
    vue.branchList = resultList;
    var tempIndex = -1;
    var tempIndex2 = -1;
    var maxIndex = resultList.length;
    counter = 0;
    ainterval = setInterval(function () {
        if (analyseIndex < maxIndex) { //分支存在
            if (analyseIndex2 < resultList[analyseIndex].ID.length) { //单个分支遍历结束
                if (tempIndex2 != analyseIndex2) {
                    tempIndex = analyseIndex;
                    tempIndex2 = analyseIndex2;
                    movesIndex = analyseIndex2;
                    if (movesIndex == 0) {
                        cleanChess();
                        comm.map = comm.clone(comm.cMap);
                        comm.init(comm.map, !0);
                    }
                    currentId = resultList[analyseIndex].ID[analyseIndex2];
                    var temp_map = comm.arr2Clone(comm.map);
                    var temp_node = comm.nodes[currentId];
                    if (temp_node.step) {
                        temp_node.stepcn = comm.createMove(temp_map, temp_node.step);
                        temp_node.chessScore = comm.getChessScore(temp_map);
                    }
                    moves = comm.getMoves4Server(resultList[analyseIndex].ID[analyseIndex2]);
                    if (movesIndex > 0) {
                        Player.stepPlay(temp_node.step, 1);
                        temp_node.currentFen = comm.getBoard();
                        // onChangeTip(movesIndex);
                        cleanLine();
                    } else {
                        temp_node.currentFen = comm.getBoard();
                    }
                    if (comm.nodes[resultList[analyseIndex].ID[analyseIndex2]].score == null) {
                        sendMessage();
                    } else {
                        var temp_score = '';
                        var score_list = [];
                        for (var i = 0; i < resultList[analyseIndex].ID.length; i++) {
                            temp_score = comm.nodes[resultList[analyseIndex].ID[i]].score;
                            if (temp_score == null) {
                                vue.refreshJushi2(analyseIndex, temp_score, score_list);
                                analyseIndex2 = i;
                                comm.gotoStep(comm.getMoves4Server(resultList[analyseIndex].ID[analyseIndex2]), i - 1);
                                break;
                            } else {
                                score_list.push(turnScore(temp_score));
                            }
                        }
                    }
                }
            } else {
                analyseIndex++; //分支数增加
                analyseIndex2 = 0;
                tempIndex = -1;
                tempIndex2 = -1;
            }
        } else { //遍历结束
            // mode = playmode.ANALYSE;
            waitServerPlay = true;
            vue.clickChart();
            vue.reportResult = comm.getReport(0);
            comm.setHistoryStorage();
            vue.mode = 0;
            if (myRole == 2) {
                setTimeout(function () {
                    onReverse();
                }, 150);
            }
            replayBtnUpdate();
            clearInterval(ainterval);
            voicemode = 1;
            toastDisplay('加载完成');
            setTimeout(function () {
                var option = vue.myChart.getOption();
                option.series[0].markPoint.data.push({
                    symbol: 'roundRect',
                    symbolSize: 0,
                    animation: false,
                    coord: [20, vue.myChart.getModel().getComponent('yAxis').axis.scale._extent[1]],
                    label: {
                        position: 'right',
                        offset: [2, 15],
                        formatter: function () {
                            return '10(中局)'
                        },
                        color: '#ffffff',
                        backgroundColor: '#644227',
                        padding: 4,
                        borderRadius: 4,
                        fontSize: 10
                    },
                });
                option.series[0].markLine.data.push({
                    xAxis: 20,
                    label: {
                        show: false
                    }
                });
                if (vue.reportResult.canIndex) {
                    var canIndex = vue.reportResult.canIndex;
                    option.series[0].markPoint.data.push({
                        symbol: 'roundRect',
                        symbolSize: 0,
                        animation: false,
                        coord: [canIndex, vue.myChart.getModel().getComponent('yAxis').axis.scale._extent[1]],
                        label: {
                            position: 'right',
                            offset: [2, 15],
                            formatter: function () {
                                return '(' + parseInt(canIndex / 2) + '残局)'
                            },
                            color: '#ffffff',
                            backgroundColor: '#644227',
                            padding: 4,
                            borderRadius: 4,
                            fontSize: 10
                        },
                    });
                    option.series[0].markLine.data.push({
                        xAxis: canIndex,
                        label: {
                            show: false
                        }
                    });
                }
                vue.myChart.setOption(option, true);
                onClickChart(vue.dataY[0].length - 1, vue.branchList[0].ID[vue.dataY[0].length - 1], 0);
            }, 300)
        }
        if (counter > 8000) {
            clearInterval(ainterval); // 超过最大尝试次数，清除轮询器
            toastDisplay('加载失败');
            mode = playmode.ANALYSE;
            voicemode = 1;
            vue.clickChart();
            vue.mode = 0;
            replayBtnUpdate();
        }
        counter++;
    }, 50);
}
/*电脑执黑*/
onBluePlay = function () {
    if (b_autoset != 0) {
        waitServerPlay = false;
        b_autoset = 0;
        vue.blackautoplayTog = false;
        cleanComputerDetail();
        computer = '';
        computerHold = 0;
    } else {
        toastDisplay('电脑执黑');
        b_autoset = 1;
        computer = 'black';
        computerHold = BLACK;
        vue.blackautoplayTog = true;
        if (comm.getHold() == BLACK && !waitServerPlay) {
            Player.AIPlay();
        }
    }
}
/*电脑执红*/
onRedPlay = function () {
    if (r_autoset != 0) {
        waitServerPlay = false;
        r_autoset = 0;
        vue.redautoplayTog = false;
        cleanComputerDetail();
        computer = '';
        computerHold = 0;
    } else {
        toastDisplay('电脑执红');
        r_autoset = 1;
        computer = 'red';
        computerHold = RED;
        vue.redautoplayTog = true;
        if (comm.getHold() == RED && !waitServerPlay) {
            Player.AIPlay();
        }
    }
}
/*响应翻转按钮*/
onReverse = function () {
    if (mode == playmode.EDITBOARD) {
        cleanChess();
        cleanChessEx();
        cleanDefaultChessEx();
        isVerticalReverse ? (isVerticalReverse = 0, chessBottomLayer.removeChild(verticalReverseboard), chessBottomLayer.addChildAt(board, 0)) :
            (isVerticalReverse = 1, chessBottomLayer.removeChild(board), chessBottomLayer.addChildAt(verticalReverseboard, 0));
        comm.map = arrReverse(comm.map);
        comm.sMap = comm.arrReverseEx(comm.sMap);
        comm.sMapList = comm.getsMap();
        displayChessDefaultPos(!vue.verticalreverseTog);
        comm.init(comm.map, !1);
        createMansEx(comm.sMap);
        vue.verticalreverseTog = !vue.verticalreverseTog;

    } else {
        // if ((b_autoset != 0 || r_autoset != 0) && mode != playmode.AIPLAY) {
        //     toastDisplay('请取消电脑思考，再点击翻转');
        //     vue.verticalreverseTog = !vue.verticalreverseTog;
        //     return;
        // }
        if (comm.isAnimating) return;
        if (mode == playmode.AIPLAY && comm.getHold() == computerHold ) {
            if(!vue.start || vue.start!=1){
                vue.$toast('电脑思考中，无法翻转');
            }
            vue.verticalreverseTog = !vue.verticalreverseTog;
            return;
        }
        if (waitServerPlay && mode != playmode.CHESSANALYSE) return;

        if (mode == playmode.ANALYSE && vue.currentAnalyseData.show) return;
        isVerticalReverse ? (isVerticalReverse = 0, chessBottomLayer.removeChild(verticalReverseboard), chessBottomLayer.addChildAt(board, 0)) :
            (isVerticalReverse = 1, chessBottomLayer.removeChild(board), chessBottomLayer.addChildAt(verticalReverseboard, 0));
        comm.reverseMoves();
        comm.map = arrReverse(comm.map);
        comm.cMap = arrReverse(comm.cMap);
        cleanChess();
        comm.init(comm.map, !0);
        hideBorder();
        hideDots();
        hidePane();
        hideLight();
        var node = comm.nodes[currentId];
        if (currentId > 0) {
            showPane(node.step[0], node.step[1]);
            showLight(node.step[2], node.step[3]);
        }
        if (mode == playmode.ANALYSE && (vue.currentAnalyseData.show == false || vue.currentAnalyseData.index == 0)) {
            if (node.openbookDetail.length == 0 && node.chessdbDetail.length == 0) {
                cleanLine();
                if (node.tipsStep.length == 2 && vue.displayLine) {
                    showTipsStep(node.tipsStep[0], 1);
                    showTipsStep(node.tipsStep[1], 2);
                }
                if (node.tipsStep.length == 1 && vue.displayLine) {
                    showTipsStep(node.tipsStep[0], 1);
                }
            } else {
                cleanLine();
                if (node.openbookDetail && node.openbookDetail.length != 0) {
                    if (vue.displayLine) {
                        showTipsStep(node.openbookDetail[0].step, 4);
                    }
                } else {
                    if (vue.displayLine) {
                        showTipsStep(node.chessdbDetail[0].step, 4);
                    }
                }
            }
        }
        if (mode == playmode.CREATE){
            cleanLine();
            if (vue.displayLine) {
            drawCreateLine(comm.nodes[currentId].openbookDetail);
            }
        }
        if (mode == playmode.CHESSANALYSE) {
            if (vue.retryItem.isActive) {
                cleanLine();
                cleanLine2();
                if (vue.retryItem.testStep) {
                    var step = vue.retryItem.testStep;
                    if (isVerticalReverse) {
                        step = reverseStep(step);
                    }
                    step = comm.Step2XY(step);
                    showPane(step.src.x, step.src.y);
                    showLight(step.dst.x, step.dst.y);
                    drawLineArrow(vue.retryItem.testStep, 2, vue.retryItem.testColor);
                    drawCircleResult(vue.retryItem.testStep, 1, vue.retryItem.testGrade, vue.retryItem.testColor);
                    waitServerPlay = true;
                } else {
                    var step = comm.nodes[movesIndex + 1].step;
                    if (isVerticalReverse) {
                        step = reverseStep(step);
                    }
                    drawLineArrow(step, 1, '#ff4444');
                }
            } else if (vue.playingList.index == 0 && !vue.playingList.isCorrect) {
                chessAnalyseShape();
            } else if (vue.playingList.index) {
                var step = vue.playingList.list[vue.playingList.index - 1];
                if (isVerticalReverse) {
                    step = reverseStep(step);
                }
                step = comm.Step2XY(step);
                showPane(step.src.x, step.src.y);
                showLight(step.dst.x, step.dst.y);
            }
        }
        if (mode == playmode.REPLAY) {
            var temp = vue.chessUser[0];
            vue.chessUser[0] = vue.chessUser[1];
            vue.chessUser[1] = temp;
        }
        if (mode == playmode.TREE) {
            cleanLineTree();
            for (var i = 0; i < vue.treeList.length; i++) {
                if (vue.treeList[i].isActive == true) {
                    var tempStep = vue.treeList[i].move;
                    drawLineArrow(tempStep, 1)
                }
            }
        }
        displayBranch();
    }
}
/*响应开局按钮*/
onReplayFirst = function () {
    if (waitServerPlay) {
        toastDisplay("电脑思考中,请稍后重试");
        return;
    }
    if (comm.isAnimating) {
        return;
    }
    if (b_autoset != 0 || r_autoset != 0) {
        toastDisplay("请取消电脑思考，再点击开局");
        return;
    }
    cleanDetail();
    vue.nextStepDialog = false;
    movesIndex = 0;
    currentId = 0;
    moves = comm.getMoves4Server();
    comm.gotoStep(moves, movesIndex);
    displayBranch();
    replayBtnUpdate();
}
/*响应终局按钮*/
onReplayEnd = function () {
    if (waitServerPlay) {
        toastDisplay("电脑思考中,请稍后重试");
        return;
    }
    if (comm.isAnimating) {
        return;
    }
    if (b_autoset != 0 && r_autoset != 0) {
        toastDisplay("请取消电脑思考，再点击终局");
        return;
    }
    cleanDetail();
    vue.nextStepDialog = false;
    moves = comm.getMoves4Server();
    movesIndex = moves.length;
    comm.gotoStep(moves, movesIndex);
    replayBtnUpdate();
}
/*响应自动播放按钮*/
onAutoreplay = function () {
    if (b_autoset != 0 || r_autoset != 0) {
        toastDisplay('请取消电脑思考，再点击自动播放');
        return;
    } else if (movesIndex >= comm.nodes.length - 1) {
        toastDisplay('播放结束');
        clearInterval(autoreplayset);
        autoreplayset = 0;
        vue.autoReplay = 0;
    } else {
        if (autoreplayset != 0) {
            toastDisplay('播放结束');
            clearInterval(autoreplayset);
            autoreplayset = 0;
            vue.autoReplay = 0;
        } else {
            toastDisplay('开始自动播放');
            autoreplayset = setInterval(onReplayNext, 1000);
            vue.autoReplay = 1;
        }
    }
}
/*响应上一步按钮*/
onReplayPrev = function () {
    if (waitServerPlay) {
        if (mode == playmode.CHESSANALYSE) {
            if (vue.mode == 1) {
                vue.$toast('局势图加载中，请稍后');
                return;
            }
        } else {
            return;
        }
    }
    if (comm.isAnimating) {
        return;
    }
    cleanDetail();
    vue.nextStepDialog = false;
    if (movesIndex > 0) {
        movesIndex--;
        comm.gotoStep(moves, movesIndex);
    }
    displayBranch();
    eatKey = '';
    state = 0;
    if (mode != playmode.CHESSANALYSE && mode != playmode.ANALYSE){
        console.log("replayBtnUpdate5");
        replayBtnUpdate();
    }
    if (movesIndex == 0 && api.pageParam.step) {
        var step = api.pageParam.step;
        setTimeout(function () {
            isVerticalReverse ? step = reverseStep(step) : '';
            drawLine(step, 3, api.pageParam.type);
        }, 100)
    }
    if (mode == playmode.ANALYSE && vue.startLibrary == 4) {
        ReCompute();
    }
}
/*响应下一步按钮*/
onReplayNext = function () {
    if (waitServerPlay) {
        if (mode == playmode.CHESSANALYSE) {
            if (vue.mode == 1) {
                vue.$toast('局势图加载中，请稍后');
                return;
            }
        } else {
            return;
        }
    }
    if (comm.isAnimating) {
        return;
    }
    replayNextset();
}
replayNextset = function () {
    /*统计分支数*/
    var countPath = comm.getBrachLength();
    vue.countPath = countPath;
    if (countPath == 1) {
        vue.nextStepDialog = false;
        /*一条分支直接走棋*/
        var childID = comm.nodes[currentId].child[0];
        var step = comm.nodes[childID].step;
        if (mode == playmode.CHESSANALYSE) {
            Player.stepPlay(step, '', 1);
        } else {
            Player.stepPlay(step, 1);
        }
        movesIndex++;
        currentId = childID;
        if (mode == playmode.ANALYSE && vue.tabActive == 2) {
            vue.autoScroll();
        }
        onChangeTip(movesIndex);
        if (mode != playmode.CHESSANALYSE && mode != playmode.ANALYSE){
            console.log("replayBtnUpdate6");
            replayBtnUpdate();
        }
        if (mode == playmode.ANALYSE && vue.startLibrary == 4) {
            ReCompute();
        }
    } else if (countPath > 1) {
        /*多条分支弹出提示框*/
        /*自动播放控制*/
        vue.nextStepDialog = true;
        if (autoreplayset != 0) {
            toastDisplay('播放结束');
            clearInterval(autoreplayset);
            autoreplayset = 0;
            vue.autoReplay = 0;
        }
        displayBranch();
    }
    if (autoreplayset != 0 && movesIndex >= moves.length) {
        toastDisplay('播放结束');
        clearInterval(autoreplayset);
        autoreplayset = 0;
        vue.autoReplay = 0;
    }
}
/*响应上变按钮*/
onBranchPrev = function () {
    if (waitServerPlay) {
        toastDisplay("电脑思考中,请稍后重试");
        return;
    }
    if (comm.isAnimating) {
        return;
    }
    movesIndex = vue.prevBranchIndex;
    moves = comm.getMoves4Server();
    comm.gotoStep(moves, movesIndex);
    displayBranch();
    replayBtnUpdate();
}
/*响应下变按钮*/
onBranchNext = function () {
    if (waitServerPlay) {
        toastDisplay("电脑思考中,请稍后重试");
        return;
    }
    if (comm.isAnimating) {
        return;
    }
    movesIndex = vue.nextBranchIndex;
    moves = comm.getMoves4Server();
    comm.gotoStep(moves, movesIndex);
    displayBranch();
    replayBtnUpdate();
}
function hasBranchChange() {
    moves = comm.getMoves4Server();
    vue.prevBranchIndex = -1;
    vue.nextBranchIndex = -1;
    for (var i = movesIndex - 2; i >= 0; i--) {
        if (comm.nodes[moves[i].id].child.length > 1) {
            vue.prevBranchIndex = i + 1;
            break;
        } else {
            vue.prevBranchIndex = -1;
        }
    }
    if (vue.prevBranchIndex == -1 && currentId != 0 && comm.nodes[0].child.length > 1) {
        vue.prevBranchIndex = 0;
    }
    for (var j = movesIndex; j < moves.length; j++) {
        if (comm.nodes[moves[j].id].child.length > 1) {
            vue.nextBranchIndex = j + 1;
            break;
        } else {
            vue.nextBranchIndex = -1;
        }
    }
}
/*反馈错误数据*/
// onErrordata = function () {
//     if (comm.nodes.length > 1) {
//         if (mode == playmode.AIPLAY) {
//             toastDisplay('已删除错误数据,请重走!');
//             onChessRegret();
//             ReCompute()
//         } else {
//             if (isanalyse) {
//                 toastDisplay('重新思考中!');
//                 ReCompute()
//             } else {
//                 toastDisplay('请打开分析模式后再使用!');
//             }
//         }
//     } else {
//         if (mode == playmode.AIPLAY) {
//             toastDisplay('还未开始走棋!');
//         } else {
//             if (isanalyse) {
//                 toastDisplay('重新思考中!');
//                 ReCompute()
//             } else {
//                 toastDisplay('请打开分析模式后再使用!');
//             }
//         }
//     }
// }
/*创建棋谱*/
onCreate = function () {
    mode = playmode.EDITBOARD;
    setEnable("prevBtn2", !1);
    setEnable("nextBtn2", !1);
    cleanChess();
    console.log("comm.init5")
    comm.init(comm.map, !1);
    onCleanBroad();
}
onSave = function () {
    mode = playmode.ANALYSE;
    comm.notes = [];
    comm.nodes = [];
    comm.cMap = comm.arr2Clone(comm.map);
    cleanChess();
    cleanChessEx();
    resizeBoard();
    movesIndex = 0;
    currentId = 0;
    comm.init(comm.map, !0);
    vue.isOffensiveTog = comm.getHold() == 1 ? false : true;
    if (comm.getHold() == computerHold) {
        Player.AIPlay();
    } else {
        sendMessage();
    }
}
/*是否显示箭头*/
OnshowArrow = function () {
    if (mode == playmode.TREE) {
        if (vue.displayLine) {
            vue.displayLine = 0;
            cleanLineTree();
            vue.actions[vue.actions.length - 1].name = '显示提示';
        } else {
            vue.displayLine = 1;
            for (var i = 0; i < vue.treeList.length; i++) {
                if (vue.treeList[i].isActive == true) {
                    var tempStep = vue.treeList[i].move;
                    drawLineArrow(tempStep, 1)
                }
            }
            vue.actions[vue.actions.length - 1].name = '隐藏提示';
        }
    } else {
        if (vue.displayLine) {
            vue.displayLine = 0;
            cleanLine();
            if (mode == playmode.ANALYSE) {
                replayBtnUpdate();
            }
        } else {
            vue.displayLine = 1;
            vue.tipsNum--;
            if (mode == playmode.ANALYSE) {
                replayBtnUpdate();
            } else if (mode == playmode.CREATE){
                drawCreateLine(comm.nodes[currentId].openbookDetail);
            } else {
                if (comm.getHold() != computerHold) {
                    showTipsStep(comm.nodes[currentId].tipsStep[0], 1);
                }
            }
        }
    }
}
/*是否显示提示*/
OnshowAIInfo = function () {
    if (vue.displayArrow) {
        vue.displayArrow = 0;
        toastDisplay("隐藏提示");
    } else {
        vue.displayArrow = 1;
        toastDisplay("显示提示");
    }
}
/*悔棋*/
onChessRegret = function () {
    if (vue.regretNum===0 && vue.wzVip != 1){
        vue.$dialog.confirm({
            title: '王者象棋VIP付费功能',
            message: '开通王者象棋VIP后可继续查看',
            confirmButtonText: '去开通',
            confirmButtonColor: '#3388ff',
            cancelButtonColor: '#666666'
        }).then(function () {
            vue.openPage('data/vip');
        }).catch(function () {
        });
        return;
    }
    // if (waitServerPlay) {
    //     toastDisplay("电脑思考中,请稍后重试");
    //     return;
    // }
    if (comm.nodes.length == 0) {
        toastDisplay("还没开始下棋呢");
        return;
    }
    if (comm.isAnimating) {
        return;
    }
    waitServerPlay = false;
    moves = comm.getMoves4Server();
    computerHold == comm.getHold() ? flag = 1 : flag = 2;

    if (movesIndex - flag > -1) {
        movesIndex -= flag;
        comm.gotoStep(moves, movesIndex);
        comm.nodes.length = movesIndex + 1;
        comm.nodes[movesIndex].child = [];
        vue.isAnalyse = false;
        vue.regretNum--;
    }
    console.log("replayBtnUpdate10");
    replayBtnUpdate();
}
onCreateRegret = function () {
    if (movesIndex > 0) {
        movesIndex -= 1;
        vue.hasChange = true;
        comm.gotoStep(moves, movesIndex);
        comm.nodes.length = movesIndex + 1;
        comm.nodes[movesIndex].child = [];
    }
    replayBtnUpdate();
}
/*出招*/
onAttackMove = function (step) {
    if (isVerticalReverse == 1) {
        var move = comm.Step2XY(reverseStep(step));
    } else {
        var move = comm.Step2XY(step);
    }
    Player.selected(move.src);
    Player.clickBoard(move.dst);
    waitServerPlay = !1;
    cleanDetail();
}
/*保存棋谱*/
onSend = function (ai_result, chessId, cb) {
    if (isVerticalReverse) {
        comm.reverseMoves();
        comm.cMap = arrReverse(comm.cMap);
    }
    var moves = comm.getMoves4Server2();
    var _json = {
        "moves": moves,
        "source": vue.pageType,
        'fen': comm.getBoard(comm.clone(comm.cMap), 1),
        'newnotes': comm.getNewNotes4Server(),
        'chessid': chessId
    };
    if (mode == playmode.AIPLAY) {
        _json.computer = computer;
        _json.level = vue.currentLevel;
        _json.result = ai_result ? ai_result.result : 0;
        _json.reason = ai_result ? ai_result.reason : null;
    }
    mySendMessage(mysetting.routes.saveChess, _json, function (response) {
        if (isVerticalReverse) {
            comm.reverseMoves();
            comm.cMap = arrReverse(comm.cMap);
        }
        if (response.errno == 0) {
            if (mode == playmode.AIPLAY) {
                if (cb) cb(response.data.chessid);
            } else {
                vue.$toast('保存成功');
                if (ai_result) {
                    mySendMessage(mysetting.routes.editChess, {
                        chessid: response.data.chessid,
                        title: ai_result.title,
                        redname: ai_result.redname,
                        blackname: ai_result.blackname,
                        comment: ai_result.comment,
                        result: ai_result.result,
                    }, function () {
                        if (cb) cb(response.data.chessid);
                    })
                } else {
                    if (cb) cb(response.data.chessid);
                }
            }
        } else {
            vue.$toast(response.message);
        }
    })
}
/*编辑棋谱*/
onEditboard = function () {
    mode = playmode.EDITBOARD;
    cleanDetail();
    cleanLine();
    cleanLine2();
    cleanLineBranch();
    hideBorder();
    hideDots();
    hidePane();
    hideLight();
    cleanChess();
    resizeBoard();
    displayChessDefaultPos(false);
    if (comm.getHold() == 1) {
        comm.isOffensive = 0;
        vue.isOffensive = 0
    } else {
        comm.isOffensive = 1;
        vue.isOffensive = 1
    }
    comm.nodes = [];
    currentId = 0;
    movesIndex = 0;
    // isanalyse = 0;
    r_autoset = 0;
    b_autoset = 0;
    vue.redautoplayTog = false;
    vue.blackautoplayTog = false;
    vue.noteValue = '';
    chessdata = '';
    chessid = 0;
    isVerticalReverse ? comm.sMap = comm.arr2Clone(sMapFullReveser) : comm.sMap = comm.arr2Clone(sMapFull);
    comm.sMapList = comm.getsMap();
    comm.init(initMap, !1);
    var ss = 0;
    for (x in comm.sMapList) {
        m = parseInt(ss / 6);
        n = ss % 6;
        if (comm.sMapList[x].length > 0) {
            comm.sMap[m][n] = comm.sMapList[x][0];
            m ? flag = boardset.routside : flag = boardset.boutside;
            createMan(comm.sMap[m][n], flag, n * boardset.outsidescale);
            drawNum(m, n, comm.sMapList[x].length);
        } else {
            comm.sMap[m][n] = "";
        }
        ss++;
    }

    waitServerPlay = false;
}
