/*走子相关*/
/*响应Canvas点击事件*/
comm.stageClick = function (e) {
    if (mode == playmode.GAMEOVER) {
        return;
    }
    if (api.connectionType == 'none') {
        vue.$toast('网络连接断开，请检查网络设置');
        return ;
    }
    if (mode == playmode.ONLINE) {
        if (vue.role == 3) {
            vue.pageIndex == 3 ? vue.isFullScreen = !vue.isFullScreen : '';
            return;
        }
        if (vue.chairId != vue.current_user) {
            return;
        }
    }
    Player.clickCanvas(e);
}
var Player = Player || {};
Player.clickCanvas = function (e) {
    if (mode == playmode.CHESSANALYSE && waitServerPlay) {
        return;
    }
    if (!waitServerPlay) {
        var point = Player.getClickPoint(e);
        Player.clickBoard(point);
    } else {
        if (isanalyse) {
            toastDisplay("分析模式中,请稍后重试");
        }
    }
}
/*点击棋盘*/
Player.clickBoard = function (point) {
    var manKey = Player.getClickMan(point);
    var src = Player.getNowManPoint();
    if (mode == playmode.ONLINE && src && typeof src.x != "undefined" && !waitServerPlay && ((movesIndex % 2 == 0 && vue.role == 1) || (movesIndex % 2 == 1 && vue.role == 2))) {
        if (src.x == point.x && src.y == point.y) {
            Player.cancleSelected();
        } else {
            if (manKey) {
                var o = comm.mans[manKey];
                if (o.my == comm.getHold() && manKey) {
                    hideDots();
                    Player.selected(point, manKey); /*换选棋子*/
                    return;
                }
            }
            if (!Player.indexOfPs(Player.getNowMan().ps, [point.x, point.y])) {
                Player.cancleSelected();
                return;
            }
            var c_s_body = {};
            if (isVerticalReverse == 1) {
                c_s_body.move_chess_data = {
                    "from_pos": { x: 8 - src.x, y: 9 - src.y },
                    "to_pos": { x: 8 - point.x, y: 9 - point.y },
                    "board": comm.getBoard()
                }
            } else {
                c_s_body.move_chess_data = {
                    "from_pos": { x: src.x, y: src.y },
                    "to_pos": { x: point.x, y: point.y },
                    "board": comm.getBoard()
                }
            }
            waitServerPlay = true;
            manKey ? Player.clickMan(point) : Player.clickPoint(point);
            mySendMessage(mysetting.routes.chessMove, c_s_body, function (data) {
                if (data.errno == 0) {
                    waitServerPlay = false;
                    if (data.message != '') {
                        toastDisplay(data.message);
                    }
                    setTimeout(function () {
                        showLight(point.x, point.y);
                    }, 200);
                } else {
                    if (data.errno == -999) {
                        var s_c_body = data.data;
                        vue.scenePlay(s_c_body);
                    } else {
                        toastDisplay(data.message);
                        waitServerPlay = false;
                        movesIndex--;
                        if (eatKey != '') {
                            comm.map[src.y][src.x] = comm.map[point.y][point.x];
                            comm.map[point.y][point.x] = eatKey;
                        } else {
                            comm.map[src.y][src.x] = comm.map[point.y][point.x];
                            delete (comm.map[point.y][point.x]);
                        }
                        cleanChess();
                        comm.init(comm.map, !0);
                        comm.initLight(data.data.prevMove);
                    }
                }
                eatKey = '';
                state = 0;
            })
        }
    }
    else {
        manKey ? Player.clickMan(point) : Player.clickPoint(point);
    }
}
/*点击棋子*/
Player.clickMan = function (point) {
    var manKey = Player.getClickMan(point);
    /*是否已经选中一个棋子*/
    if (comm.nowManKey) {
        /*两次棋子相同*/
        if (comm.nowManKey == manKey) {
            /*取消选中*/
            Player.cancleSelected();
        } else {
            if (mode == playmode.EDITBOARD) {
                /*交换棋子*/
                var man = Player.getNowMan();
                var src = { x: man.x, y: man.y };
                var dst = point;
                Player.exchangMan(src, dst);
            } else {
                var o = comm.mans[manKey];
                if (o.my != comm.getHold()) {
                    /*吃子*/
                    Player.eatMan(point);
                } else {
                    /*选中当前棋子*/
                    Player.selected(point);
                }
            }
        }
    } else {
        /*选中当前棋子*/
        if (mode == playmode.EDITBOARD) {
            Player.selected(point);
        } else {
            var o = comm.mans[manKey];
            if (o.my != comm.getHold()) {
                hideDots();
                // toastDisplay("对方下子");
            } else {
                /*选中当前棋子*/
                Player.selected(point);
            }
        }
    }
}
/*点击棋盘点*/
Player.clickPoint = function (point) {
    if (mode == playmode.EDITBOARD) {
        if (comm.nowManKey) {
            /*移动棋子*/
            var src = Player.getNowManPoint();
            var dst = point;
            Player.moveMan(src, dst);
        }
    } else {
        if (comm.nowManKey && comm.CheckInBoard(point)) {
            /*移动棋子*/
            var src = Player.getNowManPoint();
            var dst = point;
            Player.moveMan(src, dst);
            comm.isAnimating = !0;
        }
    }

}
/*落子*/
Player.stepEnd = function (move) {
    console.log("mode:"+mode)
    if (mode == playmode.EDITBOARD) {
        return;
    }
    movesIndex++;
    var nodeChange = false;
    if (mode == playmode.CHESSANALYSE) {
        hideTips();
    }
    if (mode == playmode.ONLINE) {
        if ((movesIndex % 2 == 0 && vue.role == 1) || (movesIndex % 2 == 1 && vue.role == 2) || vue.role == 3) {
            setTimeout(function () {
                showLight(move.dst.x, move.dst.y);
            }, 200);
        }
        comm.branch(move);
    } else {
        if (mode == playmode.TREE) {
            var tempStep = comm.XY2Step(move);
            if (comm.nodes[currentId + 1] && comm.nodes[currentId + 1].step != tempStep) {
                nodeChange = true;
                comm.nodes.length = currentId + 1;
                comm.nodes[currentId].child = [];
            }
        }
        var hasBranch = comm.branch(move);
        /* 检查走棋是否被将军。如果是，说明这是在送死，撤销走棋并返回false。*/
        if (comm.Checked(comm.getHold())) {
            showTip("gameError");
            waitServerPlay = false;
            movesIndex--;
            movesIndex > 0 ? currentId = moves[movesIndex - 1].id : currentId = 0;
            var cKey = comm.getArrayKey(comm.nodes[comm.nodes[comm.nodes.length - 1].pater].child, comm.nodes[comm.nodes.length - 1].id);
            if (cKey !== false) {
                comm.nodes[comm.nodes[comm.nodes.length - 1].pater].child.splice(cKey, 1);
            }
            if (comm.nodes[comm.nodes.length - 1].eatKey != '') {
                comm.map[move.src.y][move.src.x] = comm.map[move.dst.y][move.dst.x];
                comm.map[move.dst.y][move.dst.x] = comm.nodes[comm.nodes.length - 1].eatKey;
                removeOnDrops.pop();
            } else {
                comm.map[move.src.y][move.src.x] = comm.map[move.dst.y][move.dst.x];
                delete (comm.map[move.dst.y][move.dst.x]);
            }
            comm.nodes.pop();
            cleanChess();
            comm.init(comm.map, !0);
            moves = comm.getMoves4Server();
            eatKey = '';
            state = 0;
            return false;
        } else {
            var checked = comm.Checked(comm.getOppHold());
            if (checked) {
                showTip("gameChecked");
                state ^= STATE.CHECKED;
            } else if (state == STATE.EAT) {
                showTip("gameEat");
            }
            moves = comm.getMoves4Server();
        }
        eatKey = '';
        state = 0;
        cleanLine(); //新增(路路)
        cleanLine2(); //新增(路路)
        cleanLineBranch();
        cleanDetail();
        comm.nodes[currentId].currentFen = comm.getBoard();
        if (mode == playmode.TREE) {
            if (!nodeChange && vue.allTreeList[vue.treeIndex + 1] && vue.allTreeList[vue.treeIndex + 1].length != 0) {
                vue.treeIndex = vue.treeIndex + 1;
                vue.treeList = vue.allTreeList[vue.treeIndex];
                cleanLineTree();
                for (var i = 0; i < vue.treeList.length; i++) {
                    if (vue.treeList[i].isActive == true) {
                        drawLineArrow(vue.treeList[i].move, 1);
                    }
                }
            } else {
                for (var i = 0; i < vue.treeList.length; i++) {
                    if (vue.treeList[i].isActive == true) {
                        for (var j = 0; j < vue.treeList.length; j++) {
                            if (vue.treeList[j].move == comm.XY2Step(move)) {
                                if (i != j) {
                                    vue.allTreeList[vue.treeIndex][i].isActive = false;
                                    vue.allTreeList[vue.treeIndex][j].isActive = true;
                                }
                                break;
                            }
                        }
                        break;
                    }
                }
                vue.treeList = [];
                if (vue.allTreeList[vue.treeIndex + 1]) {
                    vue.allTreeList.length = vue.treeIndex + 1;
                }
                if (vue.isLesson) {
                    vue.getMovesList();
                } else {
                    vue.getCategoryList();
                }
            }
            if (comm.isFirst()) {
                vue.prevBtn = true;
            } else {
                vue.prevBtn = false;
            }
        }
        setTimeout((function () {
            // box1.visible = !0;
            showLight(move.dst.x, move.dst.y);
            //添加分数
            comm.nodes[currentId].chessScore = comm.getChessScore(comm.map);
            if (mode == playmode.ANALYSE || mode == playmode.REPLAY || mode == playmode.CREATE) vue.hasChange = true;
            if (mode == playmode.ANALYSE) {
                vue.stopHighData();
                if (isanalyse) {
                    if (!hasBranch) {
                        waitServerPlay = true;
                        sendMessage();
                    } else {
                        vue.refreshJushi();
                    }
                } else {
                    waitServerPlay = false;
                    if (comm.getHold() == BLACK) {
                        if (b_autoset) {
                            Player.AIPlay();
                        } else {
                            sendMessage()
                        }
                    } else {
                        if (r_autoset) {
                            Player.AIPlay();
                        } else {
                            sendMessage()
                        }
                    }
                }

            }
            if (mode == playmode.AIPLAY || mode == playmode.TEST) {
                waitServerPlay = false;
                (computerHold != comm.getHold()) ? sendMessage() : Player.AIPlay();
            } else if (mode == playmode.CHESSANALYSE) {
                waitServerPlay = true;
                if (isVerticalReverse) {
                    var tempStep = reverseStep(comm.nodes[currentId].step);
                } else {
                    var tempStep = comm.nodes[currentId].step;
                }
                vue.$set(vue.retryItem, 'isAnalyse', true);
                vue.$set(vue.retryItem, 'testStep', tempStep);
                vue.$set(vue.retryItem, 'testMove', comm.nodes[currentId].stepcn);
                vue.$set(vue.retryList.list, vue.retryItem.index, vue.retryItem);
                sendMessage();
            } else if (mode == playmode.CREATE) {
                sendMessage();
                replayBtnUpdate();
            }else {
                replayBtnUpdate();
            }
        }), 300);
    }
}
Player.analyseAction = function (action) {
    if ((action & actions.action_juesha) != 0) {
        if ((action & actions.action_jiang) != 0) {
            return 'juesha';
        } else {
            return 'kunbi';
        }
    } else if ((action & actions.action_jiang) != 0) {
        return 'jiangjun';
    } else if ((action & actions.action_chi) != 0) {
        return 'chi';
    }
    return 'move';
}
/*检查走法是否合法*/
Player.indexOfPs = function (e, a) {
    for (var m = 0; m < e.length; m++)
        if (e[m][0] == a[0] && e[m][1] == a[1])
            return !0;
    return !1
}
/*步进*/
Player.stepPlay = function (step, type, show) {
    var step = comm.Step2XY(step);
    var nowManKey = comm.map[step.src.y][step.src.x];
    var resultKey = comm.map[step.dst.y][step.dst.x];
    if (resultKey) {
        // state ^= STATE.EAT;
        var man = comm.mans[resultKey];
        man.isShow = !1;
        if (man.chess.parent) {
            man.chess.parent.removeChild(man.chess)
        }
    }
    var nowMan = comm.mans[nowManKey];
    if (nowMan) {
    delete comm.map[nowMan.y][nowMan.x];
    comm.map[step.dst.y][step.dst.x] = nowManKey;
    nowMan.x = step.dst.x;
    nowMan.y = step.dst.y;
    type ? nowMan.animate() : nowMan.move();
    hideLight();
    hidePane();
    if (type || show) {
        showPane(step.src.x, step.src.y);
        if (type) {
            setTimeout(function () {
                showLight(step.dst.x, step.dst.y);
            }, 200)
        } else {
            showLight(step.dst.x, step.dst.y);
            }
        }
    }
}
/*AI走子*/
Player.AIPlay = function () {
    waitServerPlay = true;
    console.log("AIPlay");
    if (mode==playmode.AIPLAY){
        vue.displayLine = 0;
        vue.showAnalyse = false;
    }
    sendMessage();
}
/*AI选中棋子*/
Player.AIclickMan = function (dst, type) {
    try {
        state ^= STATE.EAT;
        mankey = comm.map[dst.y][dst.x];
        var man = comm.mans[mankey];
        man.isShow = !1;
        if (man.chess) {
            if (type) {
                if (man.chess.parent) {
                    man.chess.parent.removeChild(man.chess)
                }
            } else {
                addRemoveOnDrop(man.chess);
            }
            nowMan = Player.getNowMan();
            if (nowMan) {
                delete comm.map[nowMan.y][nowMan.x];
                comm.map[dst.y][dst.x] = comm.nowManKey;
                showPane(nowMan.x, nowMan.y, dst.x, dst.y);
                nowMan.x = dst.x;
                nowMan.y = dst.y;

                type ? nowMan.move() : nowMan.animate();
            } else {
                comm.map[dst.y][dst.x] = comm.nowManKey;
            }


            ("j0" == mankey || "J0" == mankey) && comm.onGameEnd(),
                comm.nowManKey = !1;
        }
    } catch (e) {
        reportBugly(5)
        // console.log(e);
    }
}
/*AI点击棋盘*/
Player.AIclickPoint = function (dst, type) {
    try {
        if (comm.nowManKey) {
            man = Player.getNowMan();
            delete comm.map[man.y][man.x];
            comm.map[dst.y][dst.x] = man.key;
            showPane(man.x, man.y, dst.x, dst.y);
            man.x = dst.x;
            man.y = dst.y;
            type ? man.move() : man.animate();
            comm.nowManKey = !1;
        }
    } catch (e) {
        reportBugly(6)
        // console.log(e);
    }
}
/*服务器返回自动走法*/
Player.serverAIPlay = function (step) {
    if ((comm.isPlay && waitServerPlay) || (mode == playmode.ONLINE) || (mode == playmode.CHESSANALYSE)) {
        step = step || Player.aiPace;
        Player.aiPace = void 0;
        if (!step) return void (waitServerPlay = true);
        if (isVerticalReverse) {
            step = reverseStep(step);
        }
        move = comm.Step2XY(step);
        comm.nowManKey || Player.selected(move.src);
        Player.clickBoard(move.dst);
    }
}
/*检查当前step的上一步是不是和当前step选择的棋子是同一方的*/
Player.checkAIPlay = function (step) {
    if (movesIndex<1)return true;
    if (step){
        let lastMove = moves[moves.length-1];
        if (lastMove){
            let step2XY = comm.Step2XY(lastMove.step);
            let key = Player.getKey(step2XY.dst);
            console.log(JSON.stringify(key));
            if (isVerticalReverse) {
                step = reverseStep(step);
            }
            let nowStep2XY = comm.Step2XY(step);
            let nowKey = Player.getKey(nowStep2XY.src);
            console.log(JSON.stringify(nowKey));
            if (/[a-z]/.test(key)){
                if(/[A-Z]/.test(nowKey)){
                    return true;
                }
            }else if(/[A-Z]/.test(key)){
                if(/[a-z]/.test(nowKey)){
                    return true;
                }
            }
            return false;
        }
        return false;
    }else {
        return false;
    }
}
/***********************公共函数**************************/
/*吃子*/
Player.eatMan = function (point) {
    manKey = Player.getClickMan(point);
    man = comm.mans[manKey];
    if (Player.indexOfPs(Player.getNowMan().ps, [point.x, point.y])) {
        state = STATE.EAT;
        /*删除被吃棋子*/
        man.isShow = !1;
        eatKey = manKey;
        addRemoveOnDrop(man.chess);
        /*移动棋子*/
        var src = Player.getNowManPoint();
        var dst = point;
        Player.moveMan(src, dst);
        if ("j0" == manKey || "J0" == manKey) {
            comm.onGameEnd();
        }
    } else {
        hideDots();
        toastDisplay("对方下子");
    }
    Player.cancleSelected();
}
/*移动棋子*/
Player.moveMan = function (src, dst) {
    var flag = true;
    try {
        switch (Player.getMoveMode(src, dst)) {
            case Player.MoveTpye.ERROR:
                break;
            case Player.MoveTpye.IN_OUT:
                flag = Player.PointIn2Out(src, dst);
                break;
            case Player.MoveTpye.IN_IN:
                flag = Player.PointIn2In(src, dst);
                break;
            case Player.MoveTpye.OUT_IN:
                flag = Player.PointOut2In(src, dst)
                break;
            case Player.MoveTpye.OUT_OUT:
                break;
            default:
                break;
        }
    } catch (e) {
        flag = false;
        reportBugly(7)
        // console.log(e);
    }
    Player.cancleSelected();
    return
}
/*PointIn2Out*/
Player.PointIn2Out = function (src, dst) {
    var nowMan = Player.getMan(src);
    var maptemp = { "C": 0, "M": 1, "P": 2, "X": 3, "S": 4, "Z": 5, "c": 0, "m": 1, "p": 2, "x": 3, "s": 4, "z": 5 };
    row = maptemp[nowMan.pater];
    if (row > -1) {
        if (isVerticalReverse) {
            (nowMan.my == RED) ? (dst.y = boardset.boutside, col = 0) : (dst.y = boardset.routside, col = 1);
        } else {
            (nowMan.my == BLACK) ? (dst.y = boardset.boutside, col = 0) : (dst.y = boardset.routside, col = 1);
        }
        delete comm.map[src.y][src.x];
        var templist = [];
        templist = comm.sMapList[nowMan.pater];
        var oldchess = comm.sMap[col][row];
        comm.sMap[col][row] = nowMan.key;
        templist.push(nowMan.key);

        chessLayer.removeChild(chessnum[col * 6 + row]);
        templist.length ? drawNum(col, row, templist.length) : !1;

        nowMan.x = row * boardset.outsidescale;
        nowMan.y = dst.y;
        nowMan.animate();
        /*删除原来的棋子*/
        setTimeout(function () {
            removeChess(oldchess)
        }, 300);
    } else {
        toastDisplay("将帅不能移出棋盘");
        return false;
    }
    return true;
}
Player.PointIn2In = function (src, dst) {
    comm.nowManKey = comm.map[src.y][src.x];
    if (!comm.checkMans(comm.nowManKey, dst) && mode == playmode.EDITBOARD) {
        toastDisplay('棋子摆放位置不符合规范');
        return false;
    }
    if (mode == playmode.REPLAY) {
        if (comm.nodes.length>3400){
            toastDisplay('剩余步数为0');
            return false;
        }else if (comm.nodes.length>3200){
            toastDisplay('剩余步数为'+Math.ceil((3400-comm.nodes.length)/2));
        }
    }
    if (mode == playmode.EDITBOARD) {
        Player.AIclickPoint(dst);
    } else {
        if (Player.indexOfPs(Player.getNowMan().ps, [dst.x, dst.y])) {
            move = { src: src, dst: dst };
            step = comm.XY2Step(move);
            stepcn = comm.createMove(comm.map, step);
            Player.AIclickPoint(dst);
            Player.stepEnd(move);
        }
    }
    return true;
}
/*PointOutIn*/
Player.PointOut2In = function (src, dst) {
    src.y < 0 ? (col = 0) : (col = 1);
    row = parseInt(src.x / boardset.outsidescale);
    comm.nowManKey = comm.sMap[col][row];

    if (!comm.checkMans(comm.nowManKey, dst)) {
        toastDisplay('棋子摆放位置不符合规范');
        return false;
    }
    var nowMan = comm.mans[comm.nowManKey];
    delete comm.sMap[col][row];
    chessLayer.removeChild(chessnum[col * 6 + row]);

    var templist = [];
    templist = comm.sMapList[nowMan.pater];
    for (var i = 0; i < templist.length; i++) {
        if (templist[i] == nowMan.key) {
            delete templist[i];
            for (var j = i; j < templist.length - 1; j++) {
                templist[j] = templist[j + 1];
            }
            break;
        }
    }
    templist.length -= 1;
    templist.length ? (newchess = templist[0], createMan(newchess, nowMan.y, nowMan.x), comm.sMap[col][row] = newchess, drawNum(col, row, templist.length)) : !1;
    comm.map[dst.y][dst.x] = nowMan.key;
    nowMan.x = dst.x,
        nowMan.y = dst.y,
        nowMan.animate();
    return true;
}
/*获取鼠标点击的位置*/
Player.getClickPoint = function (e) {
    var a = 0;
    var m = Math.round((e.stageY - comm.pointStartY - SPACE_H / 2) / SPACE_H);
    (m < 0 || m > 9) ? (a = Math.round((e.stageX - comm.pointStartX - SPACE_W / 2) / (boardset.outsidescale * SPACE_W))) : (a = Math.round((e.stageX - comm.pointStartX - SPACE_W / 2) / SPACE_W));
    return { x: a, y: m }
}
/*选中棋子*/
Player.selected = function (point) {
    comm.nowManKey = Player.getClickMan(point);
    comm.soundplay("select");
    if (point.y < 0) {
        point.x = point.x * boardset.outsidescale;
        point.y = boardset.boutside;
    }
    if (point.y > 9) {
        point.x = point.x * boardset.outsidescale;
        point.y = boardset.routside;
    }
    showBorder(point.x, point.y);
    if (mode != playmode.EDITBOARD) {
        var nowMan = Player.getNowMan();
        hideDots();
        if (nowMan) {
            nowMan.ps = nowMan.bl();
            comm.dot.dots = nowMan.ps;
        }
        showDots();
    }
}
/*取消选择*/
Player.cancleSelected = function () {
    comm.nowManKey = !1;
    comm.dot.dots = [];
    hideDots();
    hideBorder();
}
/*交换棋子*/
Player.exchangMan = function (src, dst) {
    if (dst.y >= 0 && dst.y < 10) {
        if (!comm.checkMans(Player.getKey(src), dst)) {
            Player.cancleSelected();
            return;
        } else if (Player.getKey(src) == "J0" || Player.getKey(src) == "j0" || Player.getKey(dst) == "J0" || Player.getKey(dst) == "j0") {
            toastDisplay("将帅不能移出棋盘");
            Player.cancleSelected();
            return;
        } else if (Player.getMan(src).pater == Player.getMan(dst).pater) {
            toastDisplay("棋子相同");
            Player.cancleSelected();
            return;
        }
    }

    /*移出棋盘*/
    var point = { x: 1, y: -1 };
    Player.moveMan(dst, point);
    /*交换位置*/
    Player.moveMan(src, dst);
}
/*获取之前选中棋子*/
Player.getNowMan = function () {
    return comm.mans[comm.nowManKey];
}
/*获取选中棋子*/
Player.getMan = function (point) {
    var key = Player.getKey(point);
    return comm.mans[key];
}
/*获取选中棋子*/
Player.getKey = function (point) {
    var key;
    if (point.y < 0) {
        col = 0;
        row = parseInt(point.x / boardset.outsidescale);
        key = comm.sMap[col][row];
    } else if (point.y > 9) {
        col = 1;
        row = parseInt(point.x / boardset.outsidescale);
        key = comm.sMap[col][row];
    } else {
        key = comm.map[point.y][point.x];
    }
    return key;
}
/*获取之前选中棋子的XY坐标*/
Player.getNowManPoint = function () {
    var point = {};
    if (comm.nowManKey) {
        var man = Player.getNowMan();
        point.x = man.x;
        point.y = man.y;
    }
    return point;
}
/*获取鼠标选中的棋子*/
Player.getClickMan = function (a) {
    var m = a.x,
        o = a.y;
    if (mode == playmode.EDITBOARD) {
        if (o < 0) {
            return comm.sMap[0][m];
        } else if (o > 9) {
            return comm.sMap[1][m];
        } else {
            return 0 > m || m > 8 || 0 > o || o > 9 ? !1 : comm.map[o][m] && "0" != comm.map[o][m] ? comm.map[o][m] : !1;
        }
    } else {
        return 0 > m || m > 8 || 0 > o || o > 9 ? !1 : comm.map[o][m] && "0" != comm.map[o][m] ? comm.map[o][m] : !1;
    }
}
/*定义移动类型*/
Player.MoveTpye = {
    ERROR: 0,
    IN_OUT: 1,
    IN_IN: 2,
    OUT_IN: 3,
    OUT_OUT: 4
}
/*获取移动方式*/
Player.getMoveMode = function (o, e) {
    if (e.x < 0 || e.x > 8) {
        return Player.MoveTpye.ERROR;
    }

    if (o.y < 0 || o.y > 9) {
        if (e.y < 0 || e.y > 9) {
            return Player.MoveTpye.OUT_OUT;
        } else {
            return Player.MoveTpye.OUT_IN;
        }
    } else {
        if (e.y < 0 || e.y > 9) {
            return Player.MoveTpye.IN_OUT;
        } else {
            return Player.MoveTpye.IN_IN;
        }
    }
}
