Vue.component('my-dialog', {
    template: '<van-popup class="popup_dialog" v-model="dialogType.display" :overlay-style="{backgroundColor:\'rgba(0,0,0,.5)\'}" :close-on-click-overlay="!1">\n' +
        '            <div class="dialog_detail">\n' +
        '                <div class="dialog_lab" v-show="dialogType.lab">{{dialogType.lab}}</div>\n' +
        '                <div class="dialog_title2 ellipsized" v-show="dialogType.title2">{{dialogType.title2}}</div>\n' +
        '                <div class="dialog_title" v-show="dialogType.title">{{dialogType.title}}</div>\n' +
        '                <div class="btn_button" :class="{\'two_btn\':dialogType.button2_img}" v-show="dialogType.button1_img">\n' +
        '                    <div class="button_normal_bg" @click="dialogType.button1_function">\n' +
        '                        <img class="button_text" :src="dialogType.button1_img?(CDN_PATH + dialogType.button1_img):\'\'">\n' +
        '                        <span class="button_time" v-show="dialogType.time>=0">{{dialogType.time}}</span>\n' +
        '                    </div>\n' +
        '                </div>\n' +
        '                <div class="btn_button" :class="{\'two_btn\':dialogType.button2_img}" v-show="dialogType.button2_img">\n' +
        '                    <div class="button_normal_bg" @click="dialogType.button2_function">\n' +
        '                        <img class="button_text" :src="dialogType.button2_img?(CDN_PATH + dialogType.button2_img):\'\'">\n' +
        '                    </div>\n' +
        '                </div>\n' +
        '            </div>\n' +
        '        </van-popup>',
    props: {
        dialogType: Object,
    }
});
Vue.component('my-popup', {
    template: '<van-popup v-model="popupUnit.show" overlay-class="bg_rgba" :close-on-click-overlay="!1" class="my_toast">\n' +
        '            <van-loading size="24px" v-show="popupUnit.loading" style="display: inline-block"></van-loading>\n' +
        '            <div style="display: inline-block">{{popupUnit.text}}</div>\n' +
        '        </van-popup>',
    props: {
        popupUnit: Object,
    }
});
Vue.component('my-share', {
    template: '<van-action-sheet :style="{paddingBottom: fixBottom+\'px\'}" v-model="shareRemind" cancel-text="取消" style="backgroundColor: #ffffff" description="立即分享给好友" :options="options" @cancel="$emit(\'display-share\')" @click-overlay="$emit(\'display-share\')">' +
        '<van-grid :border="!1"><van-grid-item v-for="(item, index) in options" @click="onSelect(index)"><svg class="icon" style="fontSize:24px" aria-hidden="true"><use :xlink:href="\'#\'+item.icon"></use ></svg> <span style="fontSize:12px;color: #666666;marginTop:8px">{{ item.name }}</span></van-grid-item ></van-grid >' +
        '<van-divider v-if="moreShow" :style="{margin: 0}"></van-divider><van-grid :border="!1" v-if="moreShow"><van-grid-item v-for="(item, index) in options2" v-show="index!=4||moreShow==2" @click="onSelect2(item.type)"><div class="share_icon"><i class="iconfont" :class="item.icon"></i></div><span style="fontSize:12px;color: #666666;marginTop:8px">{{ item.name }}</span></van-grid-item ></van-grid >' +
        '</van-action-sheet>',
    props: {
        shareRemind: Boolean,
        moreShow: Number,
        speedValue: Number,
        pageShareType: String,
        shareChessid: String,
        sharePlayerid: String,
        sharePlayerType: String,
        shareLessonid: String,
        shareTeacherid: String,
        shareNumbers: String,
        shareFen: String,
        cateType: String,
        infoUid: String,
        title: String,
        role: String
    },
    data: function () {
        return {
            fixBottom: api.safeArea.bottom,
            options: [
                { index: 0, name: '微信', icon: 'iconweixin' },
                { index: 1, name: '朋友圈', icon: 'iconweixinpengyouquan' },
                { index: 2, name: 'QQ', icon: 'iconqq-icon' },
                { index: 3, name: 'QQ空间', icon: 'iconqqkongjian' },
            ],
            options2: [
                { index: 0, name: '倍速1.0X', icon: 'iconbeisu', type: 'speed' },
                { index: 1, name: '缓存', icon: 'iconxiazai1', type: 'download' },
                { index: 2, name: '播放设置', icon: 'iconshezhi', type: 'setting' },
                { index: 3, name: '课程详情', icon: 'iconxiangqing', type: 'detail' },
                { index: 4, name: '购买课程', icon: 'iconjiachang_goumaijihuo', type: 'vip' },
            ]
        }
    },
    watch: {
        shareRemind: function (val) {
            if (this.speedValue == 1 || this.speedValue == 2 || this.speedValue == 3) {
                this.options2[0].name = '倍速' + this.speedValue + '.0X';
            } else {
                this.options2[0].name = '倍速' + this.speedValue + 'X';
            }
        }
    },
    methods: {
        onSelect2: function (type) {
            if (type == 'speed') {
                this.$emit('display-speed');
            } else if (type == 'download') {
                this.$emit('display-download');
            } else if (type == 'setting') {
                this.$emit('display-setting');
            } else if (type == 'detail') {
                this.$emit('display-detail');
            } else if (type == 'vip') {
                this.$emit('display-vip');
            }
        },
        onSelect: function (index) {
            var _this = this;
            this.$emit('display-share');
            this.setPermission(function (param) {
                mySendMessage(mysetting.routes.getShare, {
                    type: _this.pageShareType,
                    chessid: (_this.pageShareType == 'upgrade_qlcp' || _this.pageShareType == 'upgrade_ai') ? null : (_this.shareChessid || null),
                    playerid: _this.pageShareType == 'player' ? _this.sharePlayerid : null,
                    playerType: _this.pageShareType == 'player' ? _this.sharePlayerType : null,
                    number: _this.pageShareType == 'association' ? _this.shareNumbers : null,
                    lessonid: _this.pageShareType == 'lesson' ? _this.shareLessonid : null,
                    teacherid: _this.pageShareType == 'teacher' ? _this.shareTeacherid : null,
                    fen: _this.pageShareType == 'analyse' ? _this.shareFen : null,
                    cateType: (_this.pageShareType == 'education' || _this.pageShareType == 'tree') ? _this.cateType : null,
                    infoUid: (_this.pageShareType == 'education' || _this.pageShareType == 'tree' || _this.pageShareType == 'self_page') ? _this.infoUid : null,
                    name: (_this.pageShareType == 'education' || _this.pageShareType == 'tree') ? _this.title : null,
                    role: _this.pageShareType == 'tree' ? _this.role : null,
                }, function (data) {
                    if (data.errno == 0) {
                        
                        if(window.location.href.indexOf('ending.html')!=-1){
                            document.title ='残局库'
                            data.data.shareInfo.title = data.data.shareInfo.title.replace('AI分析','使用残局库').replace('分析该局面','使用残局库')
                            data.data.shareInfo.link  = data.data.shareInfo.link.replace('analyse','ending')
                        }
                        if (param) {
                            api.download({
                                url: data.data.shareInfo.image,
                                report: false,
                                cache: true,
                                allowResume: false
                            }, function (ret, err) {
                                if (ret && ret.state == 1) {
                                    data.data.shareInfo.image = ret.savePath;//图片有问题
                                    _this.shareInfo(data, index);
                                } else {
                                    _this.shareInfo(data, index);
                                }
                            });
                        } else {
                            _this.shareInfo(data, index);
                        }
                    } else {
                        _this.$toast(data.message);
                    }
                });
            });

        },
        setPermission: function (cb) {
            var resultList = api.hasPermission({
                list: ['storage']
            });
            if (resultList[0].granted || api.systemType == 'ios') {
                cb(1);
            } else if (localStorage.getItem('notpermissionstorage') == 1) {
                cb(0);
            } else {
                api.requestPermission({
                    list: ['storage'],
                    code: 1
                }, function (ret, err) {
                    if (ret.code == 1) {
                        var plist = ret.list;
                        if (plist[0] && plist[0].name == 'storage') {
                            if (plist[0].granted) {
                                api.sendEvent({
                                    name: 'initOpen'
                                });
                                cb(1);
                            } else {
                                if (ret.never) {
                                    localStorage.setItem('notpermissionstorage', 1);
                                }
                                cb(0);
                            }
                        }
                    }
                });
            }
        },
        shareInfo: function (data, index) {
            if (index == 0) {
                var wx = api.require('wxPlus');
                wx.isInstalled(function (ret, err) {
                    if (!ret.installed) {
                        vue.$toast('当前设备未安装微信客户端~');
                    } else {
                        wx.shareWebpage({
                            scene: 'session',
                            title: data.data.shareInfo.title,
                            description: data.data.shareInfo.desc,
                            thumb: data.data.shareInfo.image,
                            contentUrl: data.data.shareInfo.link
                        }, function (ret, err) {
                            if (ret.status) {
                                // vue.$toast('分享成功');
                            }
                        });
                    }
                });
            } else if (index == 1) {
                var wx = api.require('wxPlus');
                wx.isInstalled(function (ret, err) {
                    if (!ret.installed) {
                        vue.$toast('当前设备未安装微信客户端~');
                    } else {
                        wx.shareWebpage({
                            scene: 'timeline',
                            title: data.data.shareInfo.title,
                            description: data.data.shareInfo.desc,
                            thumb: data.data.shareInfo.image,
                            contentUrl: data.data.shareInfo.link
                        }, function (ret, err) {
                            if (ret.status) {
                                // vue.$toast('分享成功');
                            }
                        })
                    }
                });
            } else if (index == 2) {
                var qq = api.require('QQPlus');
                qq.installed(function (ret, err) {
                    if (ret.status) {
                        qq.shareNews({
                            url: data.data.shareInfo.link,
                            title: data.data.shareInfo.title,
                            description: data.data.shareInfo.desc,
                            imgUrl: data.data.shareInfo.image,
                            type: 'QFriend'
                        }, function (ret, err) {
                            if (ret.status) {
                                // vue.$toast('分享成功');
                            }
                        });
                    } else {
                        vue.$toast('当前设备未安装QQ客户端~');
                    }
                });
            } else if (index == 3) {
                var qq = api.require('QQPlus');
                qq.installed(function (ret, err) {
                    if (ret.status) {
                        qq.shareNews({
                            url: data.data.shareInfo.link,
                            title: data.data.shareInfo.title,
                            description: data.data.shareInfo.desc,
                            imgUrl: data.data.shareInfo.image
                        }, function (ret, err) {
                            if (ret.status) {
                                // vue.$toast('分享成功');
                            }
                        })
                    } else {
                        vue.$toast('当前设备未安装QQ客户端~');
                    }
                });
            }
        }
    }
})
