/*
 * APICloud JavaScript Library
 * Copyright (c) 2014 apicloud.com
 */
(function (window) {
    var u = {};

    var db;
    var dbName = 'xiangqiweixuetang';
    var dbPath = 'fs://xiangqiweixuetang.db';
    var tableName = 'newdownload';

    // 引入db模块
    u.init = function () {
        if (db) {
            return;
        }
        db = api.require('db');
    };

    // 创建数据库及相关的数据表结构
    u.open = function () {
        u.init();
        var ret = db.openDatabaseSync({
            name: dbName,
            path: dbPath
        });

        if (ret.status) {

            //status(1:下载完成，0：下载中，-1：下载取消,-2:下载错误)
            var sss = db.executeSqlSync({
                name: dbName,
                sql: 'CREATE TABLE IF NOT EXISTS ' + tableName + '(id INTEGER PRIMARY KEY AUTOINCREMENT,uid INT(11),pid INT(10),ptitle VARCHAR(50),pimage VARCHAR(100),sid INT(10),stitle VARCHAR(50),videosize VARCHAR(10),percent INT(8),status INT(1),videourl VARCHAR(300), is_free VARCHAR(1), savePath VARCHAR(50),is_cancel INT(1),displayorder INT(11))'
            });

            //0.1.1更新displayorder字段
            var sqlResult = db.selectSqlSync({
                name: dbName,
                sql: 'select sql from sqlite_master where name= \"' + tableName + '\" AND type="table"'
            });
            if (sqlResult.status) {
                var sql = sqlResult['data'][0]['sql'];
                if (sql.indexOf('displayorder') == -1) {
                    db.executeSqlSync({
                        name: dbName,
                        sql: 'ALTER TABLE ' + tableName + ' ADD COLUMN displayorder INT(11) '
                    });
                }
            } else {
                db.executeSqlSync({
                    name: dbName,
                    sql: 'ALTER TABLE ' + tableName + ' ADD COLUMN displayorder INT(11) '
                });
            }

            //1.0.0更新download文件夹名字
            var fs = api.require("fs");
            var ret = fs.existSync({
                path: 'fs://download'
            });

            if (ret.exist && ret.directory) {
                var ret1 = fs.existSync({
                    path: 'fs://mydownloads'
                });
                if (!ret1.exist) {
                    var ret1 = fs.renameSync({
                        oldPath: 'fs://download',
                        newPath: 'fs://mydownloads'
                    });

                }

            }
        }
    }

    // 查询操作，查询table中全部数据，或按课程ID查询
    u.select = function (params, result, sort) {
        result = result || '*';
        params = params || {};
        sort = sort || '';
        u.init();
        var sql = 'SELECT ' + result + ' FROM ' + tableName + u.json_tran(params, 'select') + sort;
        var result = db.selectSqlSync({
            name: dbName,
            sql: sql
        });
        if (result.status) {
            return result.data;
        } else {
            return false;
        }
    }

    // 查询操作，查询table中全部数据 参数：uid
    u.selectAllGroup = function (params) {
        u.init();
        var data = [];
        var p = u.select(params, ' DISTINCT pid');

        if (p) {
            for (var i in p) {
                params.pid = p[i].pid;

                if (u.select(params, '*')) {
                    data[i] = u.select(params, '*', '  ORDER BY displayorder DESC, sid ASC')
                }
            }
            return data;
        } else {
            return false;
        }
    }

    // 删除单个
    u.delete = function (params) {
        u.init();
        var sql = 'DELETE FROM  ' + tableName + ' WHERE uid=' + params.uid;
        if (params.pid) {
            sql += ' AND pid=' + params.pid;
        }
        if (params.sid) {
            sql += ' AND sid=' + params.sid;
        }
        return db.executeSqlSync({
            name: dbName,
            sql: sql
        });
    }
    // 添加更新操作，如果存在则更新，否则添加
    u.update_uid = function (originUid, uid) {
        if (!originUid || !uid || originUid == uid) return false;
        u.init();
        var result = u.select({
            uid: originUid,
        }, '*');
        if (result) {
            if (result.length != 0) {
                var sql = u.json_tran({ uid: uid }, 'update') + ' WHERE uid=' + originUid;
                return db.executeSqlSync({
                    name: dbName,
                    sql: sql
                });
            }
        } else {
            return false;
        }

    }
    // 添加更新操作，如果存在则更新，否则添加
    u.insert_update = function (params) {
        u.init();
        var result = u.select({
            uid: params.uid,
            pid: params.pid,
            sid: params.sid
        }, '*');
        if (result) {
            if (result.length != 0) {
                var sql = u.json_tran(params, 'update') + ' WHERE uid=' + params.uid + ' AND id=' + result[0].id;
            } else {
                var sql = u.json_tran(params, 'insert');
            }
        } else {
            return false;
        }
        return db.executeSqlSync({
            name: dbName,
            sql: sql
        });
    }

    u.json_tran = function (json, type) {
        var sql = '';
        if (type == 'insert') {
            var key = '(';
            var value = '(';
            for (var k in json) {
                key += k + ',';
                value += '\"' + json[k] + '\",'
            }
            key = key.substring(0, key.length - 1);
            value = value.substring(0, value.length - 1);
            key += ')';
            value += ')';
            sql = 'INSERT INTO ' + tableName + key + 'VALUES' + value;
        } else if (type == 'update') {
            sql += 'UPDATE ' + tableName + ' SET ';
            for (var k in json) {
                sql += k + '=\"' + json[k] + '\",';
            }
            sql = sql.substring(0, sql.length - 1);
        } else if (type == 'select') {
            sql += ' WHERE  ';
            for (var k in json) {
                sql += k + '=' + json[k] + ' AND ';
            }
            sql = sql.substring(0, sql.length - 4);
        }
        return sql;
    }

    /*end*/
    window.$download = u;

})(window);
