var downing = [];
var downingID = 0;
function initDown(param) {
    for (var i = 0; i < param.length; i++) {
        if (param[i].is_cancel == 0) {
            downing.push(param[i]);
        }
    }
    beginDown();
}
function addDown(param) {
    for (var i = 0; i < param.length; i++) {
        if (JSON.stringify(downing).indexOf(JSON.stringify(param[i])) === -1) {
            param[i].is_cancel = 0;
            downing.push(param[i]);
        }
    }
    if (downingID == 0 && downing.length > 0) {
        beginDown();
    }
}
function beginDown() {
    if (downing && downing[0] && downing[0].status == 0) {
        var param = downing[0];
        downingID = param.sid;
        api.download({
            url: param.videourl,
            savePath: param.savePath.replace(/fs:\/\/download/, "fs://mydownloads"),
            report: true,
            encode: false,
            cache: true,
            allowResume: true
        }, function (ret, err) {
            switch (ret.state) {
                case 0:
                    if (downingID) {
                        param.percent = ret.percent;
                        $download.insert_update(param);
                        api.sendEvent({
                            name: 'lessonDowning',
                            extra: {
                                pid: param.pid,
                                sid: param.sid,
                                percent: param.percent
                            }
                        });
                    }
                    break;
                case 1:
                    if (downingID) {
                        param.percent = 100;
                        param.status = 1;
                        $download.insert_update(param);
                        downing.splice(0, 1);
                        downingID = 0;
                        beginDown();
                        api.sendEvent({
                            name: 'lessonDowned',
                            extra: {
                                pid: param.pid,
                                sid: param.sid,
                            }
                        });
                        api.toast({
                            msg: param.stitle + '下载完成！',
                            duration: 2000,
                            location: 'bottom',
                            global: true
                        });
                    }
                    break;
                case 2:
                    if (downingID) {
                        api.cancelDownload({
                            url: param.videourl
                        });
                        param.is_cancel = 1;
                        $download.insert_update(param);
                        downing.splice(0, 1);
                        downingID = 0;
                        beginDown();
                        api.sendEvent({
                            name: 'downFaild',
                        });
                        api.toast({
                            msg: param.stitle + '下载失败！请删除任务后重新添加下载！',
                            duration: 2000,
                            location: 'bottom',
                            global: true
                        });
                    }
                    break;
                default:
            }
        });
    }
}
function cancelDown(param) {
    for (var i = 0; i < param.length; i++) {
        if (param[i].sid == downingID) {
            api.cancelDownload({
                url: param[i].videourl
            });
            downingID = 0;
        }
        param[i].is_cancel = 1;
        $download.insert_update(param[i]);
        deleteID(param[i].sid);
    }
    if (downing.length > 0 && downingID == 0) {
        beginDown();
    }
}
function removeDown(param) {
    for (var i = 0; i < param.length; i++) {
        deleteID(param[i].sid);
        if ($download.delete(param[i]).status) {
            var fs = api.require('fs');
            if (param[i].status == 0) {
                if (param[i].sid == downingID) {
                    api.cancelDownload({
                        url: param[i].videourl
                    });
                }
                fs.removeSync({
                    path: 'fs://mydownloads/' + param[i].pid + '/' + param[i].pid + '_' + param[i].sid + '.mp4.tmp'
                });
                $download.delete(param[i]);
            } else if (param[i].status == 1) {
                fs.removeSync({
                    path: 'fs://mydownloads/' + param[i].pid + '/' + param[i].pid + '_' + param[i].sid + '.mp4'
                });
            }
        }
    }
    api.sendEvent({
        name: 'downRemoved'
    });
}
function deleteID(sid) {
    for (var i = 0; i < downing.length; i++) {
        if (downing[i] && downing[i].sid == sid) {
            downing.splice(i, 1);
        }
    }
}