/*发送消息函数*/
sendMessage = function (type, cb) {
    console.log("sendMessage  init.analyse.js");
    vue.AIAnalyseFlag=true;
    flagWaitAjax=false;
    isAnalyseChess=true;
    isShowEmpty=false;
    var a = {};
    a.type = mode == playmode.CHESSANALYSE ? 'analyse' : 'all';
    a.nocache = type || 0;
    a.movesIndex = movesIndex;
    a.params = {
        currentId: currentId,
        isStartLibrary: vue.startLibrary,
        isDepth: vue.depth,
        isRetry: vue.isRetry
    };
    if (movesIndex > 0) {
        a.board = comm.getBoard();
        if (movesIndex > 1) {
            a.prev_board = moves[movesIndex - 2].currentFen;
        } else {
            a.prev_board = comm.nodes[0].currentFen;
        }
        if (isVerticalReverse) {
            var temp_step = reverseStep(moves[movesIndex - 1].step);
        } else {
            var temp_step = moves[movesIndex - 1].step;
        }
        a.move_chess_data = comm.Step2FT(temp_step);
    } else {
        a.board = comm.nodes[0].currentFen;
        a.prev_board = null;
        a.move_chess_data = null;
    }
    console.log(JSON.stringify(analyseMachine));
    if (analyseMachine){
        if (vue.pageAnalyseType=="report"){
            analyseMachine={"0":{"level":"17","caltime":"0","kaiju":"3|5,5|1"},"1":{"level":"-1","caltime":"0","kaiju":"1|5,5|4"}}
        }else {
        analyseMachine={"0":{"level":"17","caltime":"0.5","kaiju":"3|5,5|1"},"1":{"level":"-1","caltime":"0.5","kaiju":"1|5,5|4"}}
        }
    }


    a.robot_setting = analyseMachine[0];
    a.robot_setting2 = analyseMachine[1];
    a.manMachine = vue.currentManMachine;
    a.isAiPlay = comm.getHold() == computerHold;

    a.r_autoset=r_autoset;
    a.b_autoset=b_autoset;

    console.log(JSON.stringify(analyseMachine));
    a.needKjk = true;
        var tempMove = getMovesList().slice(0, 20);
        a.treeType='all_s';
        a.totalFenBoard=getTotalFen();
        a.moves=tempMove;
    //设置用户数据库
    a.user_set_db=vue.startLibrary;
    mySendMessage(mysetting.routes.getData, a, function (data) {
        if (movesIndex == 0 && api.pageParam.step) {
            var step = api.pageParam.step;
            setTimeout(function () {
                isVerticalReverse ? step = reverseStep(step) : '';
                console.log("drawLine");
                drawLine(step, 3, api.pageParam.type);
            }, 100)
        }
        if (cb) {
            cb && cb(data);
            return;
        }
        if (data.errno != 0) {
            // waitServerPlay = false;
            // mode = playmode.ANALYSE;
            // vue.clickChart();
            // vue.mode = 0;
        }

    });
}
/*发送消息函数*/
ReCompute = function () {
    console.log("ReCompute");
    if(vue.depth == 17) vue.stopHighData();
    comm.nodes[currentId].computerDetail = [];
    cleanDetail();
    cleanLine();
    sendMessage(1);
}
/*初始化结构布局*/
initLayer = function (e) {
    recordEvt = e;
    if (chessid) {
        if (useChessData == 1) {
            var historyChess = JSON.parse(localStorage.getItem("historyChessdata") || "{}");
            if (historyChess && historyChess.chessid && historyChess.chessid[chessid]) {
                initHistoryChessdata(e, JSON.parse(historyChess.chessid[chessid]));
            } else {
                initServerchessdata(e, chessdata);
            }
        } else {
            initServerchessdata(e, chessdata);
        }
    } else {
        vue.mode = 0;
        mode = playmode.ANALYSE;
        isanalyse = 1;
        computerHold = 0;
        if (api.pageParam.fen) {
            comm.map = board2map(api.pageParam.fen);
            initMap = board2map(api.pageParam.fen);
            if (api.pageParam.fen.indexOf('w') == -1) {
                comm.isOffensive = 1;
            }
        } else {
            initMap = comm.clone(InitMap);
        }
        initialization(e);
        comm.isPlay = !0;
        if (api.pageParam.role == 2) {
            onReverse();
            vue.verticalreverseTog = true;
        }
        setTimeout(function () {
            vue.initEchart();
        });
        if (comm.getHold() == computerHold) {
            Player.AIPlay();
        } else {
            sendMessage();
        }
    }
}

function initServerchessdata(e, chessdata) {
    if (chessdata.fen && chessdata.moves.length > 0) {
        comm.map = board2map(chessdata.fen);
        initMap = board2map(chessdata.fen);
        initialization(e);
        waitServerPlay = true;
        mode = playmode.CHESSANALYSE;
        vue.mode = 1;
        vue.resizeS();
        vue.initEchart();
        if (chessdata.moves.length > 0) {
            var m = comm.parseMovesEx(chessdata.moves);
        }
        comm.parseNote(chessdata.notes);
        var firststepman = comm.map[m[0][0][0][1]][m[0][0][0][0]];
        comm.mans[firststepman].my == 1 ? comm.isOffensive = 0 : (comm.isOffensive = 1, toastDisplay("黑方先手"));
        comm.mans["J0"].y > 5 ? isVerticalReverse = 1 : isVerticalReverse = 0;
        setTimeout(function () {
            onAnalyseOriginal();
        }, 100);
    } else {
        vue.$toast('下棋回合数为0，不支持复盘！');
        setTimeout(function () {
            vue.closePage();
        }, 600);
    }
}

function initHistoryChessdata(e, historyChessdata) {
    if (historyChessdata.cMap && historyChessdata.canvasList && historyChessdata.reportResult && historyChessdata.moves.length > 0) {
        comm.map = historyChessdata.cMap;
        initMap = historyChessdata.cMap;
        vue.canvasList = historyChessdata.canvasList;
        vue.reportResult = historyChessdata.reportResult;
        waitServerPlay = true;
        mode = playmode.CHESSANALYSE;
        vue.mode = 1;
        vue.resizeS();
        vue.initEchart();
        initialization(e);
        var m = comm.parseMovesEx(comm.step2cidmoves(historyChessdata.moves));
        var firststepman = comm.map[m[0][0][0][1]][m[0][0][0][0]];
        comm.mans[firststepman].my == 1 ? comm.isOffensive = 0 : (comm.isOffensive = 1, toastDisplay("黑方先手"));
        comm.mans["J0"].y > 5 ? isVerticalReverse = 1 : isVerticalReverse = 0;
        var hisnotes = JSON.parse(historyChessdata.notes);
        if (hisnotes.length > 0) {
            comm.parseNote(hisnotes);
        }
        if (historyChessdata.thinkinfo.length > 0) {
            comm.parseThinkinfo(historyChessdata.thinkinfo);
        }
        setTimeout(function () {
            vue.refreshJushi(vue.reportResult.canIndex);
            vue.mode = 0;
            comm.searchNodes(0);
            if (myRole == 2) {
                setTimeout(function () {
                    onReverse();
                }, 150);
            }
            if (historyChessdata.movesIndex) {
                chessDetailTest(historyChessdata.movesIndex - 1);
            } else {
                chessDetailTest(-1);
            }
            waitServerPlay = true;
            onClickChart(vue.branchList[0].ID.length - 1, vue.branchList[0].ID[vue.branchList[0].ID.length - 1], 0);
        }, 100);

    } else {
        initServerchessdata(e, chessdata);
    }

}
