function sendMessage(index) {
    var a = {};
    a.type = vue.pageType;
    a.movesIndex = index || movesIndex;
    if (movesIndex > 0) {
        a.board = moves[movesIndex - 1].currentFen;
        if (movesIndex > 1) {
            a.prev_board = moves[movesIndex - 2].currentFen;
        } else {
            a.prev_board = comm.nodes[0].currentFen;
        }
        if (isVerticalReverse) {
            var temp_step = reverseStep(moves[movesIndex - 1].step);
        } else {
            var temp_step = moves[movesIndex - 1].step;
        }
        a.move_chess_data = comm.Step2FT(temp_step);
    } else {
        a.board = comm.nodes[0].currentFen;
        a.prev_board = null;
        a.move_chess_data = null;
    }
    a.robot_setting = { level: "17", caltime: "0", kaiju: "1|20,20" };
    a.params = { currentId: currentId };
    a.changeMove = vue.changeMove;
    comm.getHold() == computerHold ? vue.isAnalyse = true : vue.isAnalyse = false;
    if (vue.changeMove && vue.changeMove.length == 4) {
        var tempScore = comm.nodes[movesIndex - 3].score;
        if (tempScore != null) {
            if (comm.nodes[movesIndex - 3].currentFen.indexOf('w') != -1) {
                tempScore = -tempScore;
            }
            if (tempScore > 100) {
                a.changeMove = a.changeMove + '|2';
            } else {
                a.changeMove = false;
            }
            getBestMove(a);
        } else {
            mySendMessage(mysetting.routes.getScore, {
                board: comm.nodes[movesIndex - 3].currentFen
            }, function (data) {
                if (data.errno == 0) {
                    tempScore = data.data.score;
                    if (comm.nodes[movesIndex - 3].currentFen.indexOf('w') != -1) {
                        tempScore = -tempScore;
                    }
                    if (tempScore > 100) {
                        a.changeMove = a.changeMove + '|2';
                    } else {
                        a.changeMove = false;
                    }
                    getBestMove(a);
                } else {
                    a.changeMove = a.changeMove + '|1';
                    getBestMove(a);
                }
            });
        }
    } else {
        getBestMove(a);
    }
}
function getBestMove(a) {
    mySendMessage(mysetting.routes.getBestMove, a, function (data) {
        if (data.errno != 0) {
            toastDisplay(data.message);
            waitServerPlay = false;
        } else {
            vue.changeMove = false;
            if (movesIndex > 0) {
                comm.nodes[movesIndex].action = data.data.action;
                comm.nodes[movesIndex].extra = data.data.extra;
                var step_idx_begin_cycle = get_step_idx_begin_cycle(moves)
                var space_count = moves.length - step_idx_begin_cycle;
                var move_chess_user = comm.isOffensive ? (comm.getHold() > 0 ? 0 : 1) : (comm.getHold() > 0 ? 1 : 0);
                if (space_count == 1) {
                    var move_foul_for_cycle = [{ type: 0, fen: 0 }, { type: 0, fen: 0 }]

                } else if (space_count >= 7) {
                    var move_foul_for_cycle = get_move_foul_for_cycle(moves.slice(step_idx_begin_cycle, step_idx_begin_cycle + 4));
                }
                var move_foul_type2 = move_foul_for_cycle[step_idx_begin_cycle % 2 ? 1 - move_chess_user : move_chess_user].type;
                var returnMessage = '';
                if (move_foul_type2 != move_foul_type.move_foul_type_null) {
                    var countPan = {
                        cycle: 14,
                        count: Math.ceil(space_count / 2)
                    }
                    if (move_foul_for_cycle[2].result != 3) {//不是和棋
                        if (countPan.count >= 7) {//第7个回合直接判负
                            comm.onGameEnd('qigui', move_foul_for_cycle[2].reason + '判负', comm.getHold() > 0 ? 1 : 2);
                        } else if (comm.getHold() == computerHold) {
                            returnMessage = '您已' + move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判负';
                            vue.changeMove = comm.nodes[movesIndex - 2].step + '|1';
                            vue.$toast(returnMessage);
                        } else if (computerHold == 0) {
                            returnMessage = move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判负';
                            vue.changeMove = comm.nodes[movesIndex - 2].step + '|1';
                            vue.$toast(returnMessage);
                        } else if (comm.getHold() != computerHold) {
                            vue.changeMove = comm.nodes[movesIndex - 2].step + '|1';
                        }
                    } else {
                        if (move_foul_for_cycle[move_chess_user].type == move_foul_type.move_foul_type_cycle_round) {
                            if (countPan.count >= 7 && space_count >= countPan.cycle) {//第7个回合结束判和
                                comm.onGameEnd('qigui', move_foul_for_cycle[2].reason + '判和', 3);
                            } else if (comm.getHold() == computerHold) {
                                returnMessage = '您已' + move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判和';
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                                vue.$toast(returnMessage);
                            } else if (computerHold == 0) {
                                returnMessage = move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判和';
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                                vue.$toast(returnMessage);
                            } else if (comm.getHold() != computerHold) {
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                            }
                        } else {
                            if (countPan.count >= 7 && space_count >= countPan.cycle) {//第7个回合结束判和
                                comm.onGameEnd('qigui', move_foul_for_cycle[2].reason + '判和', 3);
                            } else if (comm.getHold() == computerHold) {
                                returnMessage = '您已' + move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判和';
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                                vue.$toast(returnMessage);
                            } else if (computerHold == 0) {
                                returnMessage = move_foul_for_cycle[2].reason + countPan.count + '次，第7次将被判和';
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                                vue.$toast(returnMessage);
                            } else if (comm.getHold() != computerHold) {
                                vue.changeMove = comm.nodes[movesIndex - 2].step;
                            }
                        }
                    }
                }
                if (is_60round(moves)) {
                    comm.onGameEnd('qigui', '60回合自然限招判和', 3);
                }
            }
        }
    });
}
function initLayer(e) {
    mode = playmode.AIPLAY;
    computer = vue.radio1;
    computerHold = BLACK;
    initMap = board2map(api.pageParam.fen);
    initialization(e);
    comm.isPlay = !0;
    sendMessage()
}
function get_step_idx_begin_cycle(moves) {
    var move_chess_data_record = [];
    var is_cycle = moves.length >= 4
    if (!is_cycle)
        return moves.length - 1
    is_cycle = false
    for (var i = 0; i < moves.length; i++) {
        move_chess_data_record[i] = moves[i].step;
    }
    var last_move1 = []
    var step_idx_begin_incycle1 = null
    for (var i = move_chess_data_record.length - 1; i >= 0; i -= 4) {
        var move = [move_chess_data_record[i], move_chess_data_record[i - 1], move_chess_data_record[i - 2], move_chess_data_record[i - 3]]
        if (last_move1.length == 0) {
            last_move1 = move
        }
        else {
            if (move[0] == last_move1[0] && move[1] == last_move1[1] && move[2] == last_move1[2] && move[3] == last_move1[3]) {
                last_move1 = move
                is_cycle = true
                if (i == 0) {
                    return 0;
                }
            }
            else {
                if (is_cycle) {
                    if (move[0] != last_move1[0]) {
                        step_idx_begin_incycle1 = i + 1;
                        break;
                    } else if (move[1] != last_move1[1]) {
                        step_idx_begin_incycle1 = i;
                        break;
                    } else if (move[2] != last_move1[2]) {
                        step_idx_begin_incycle1 = i - 1;
                        break;
                    } else if (move[3] != last_move1[3]) {
                        step_idx_begin_incycle1 = i - 2;
                        break;
                    }
                } else {
                    step_idx_begin_incycle1 = i + 4
                    break
                }

            }
        }
    }
    if (!is_cycle) {
        return move_chess_data_record.length - 1
    } else {
        return step_idx_begin_incycle1
    }
}
function get_move_foul_for_cycle(move_chess_data_array) {
    var actionList = [];
    var extra = [];
    for (var i = 0; i < move_chess_data_array.length; i++) {
        var action = move_chess_data_array[i].action
        if (action & actions.action_jiang) {
            actionList.push(actions.action_jiang)
        } else if (action & actions.action_sha) {
            actionList.push(actions.action_sha)
        } else if (action & actions.action_zhuo) {
            extra.push(move_chess_data_array[i].extra)
            actionList.push(actions.action_zhuo)
        } else {
            actionList.push(actions.action_null)
            extra.push([])
        }
    }
    var foul_value1 = { type: 0, fen: 0, reason: null };
    var foul_value2 = { type: 0, fen: 0, reason: null };
    if (actionList[0] == actions.action_null || actionList[2] == actions.action_null) {
        foul_value1.fen = 0;
        foul_value1.type = 0;
        foul_value1.reason = null;
    } else {
        if ((actionList[0] == actionList[2]) && (actionList[0] + actionList[2] == 4)) {//长将
            foul_value1.type = move_foul_type.move_foul_type_cycle_jiangjiang;
            foul_value1.fen = foule_fen.jiang * 2;
            foul_value1.reason = '长将';
        } else if (actionList[0] + actionList[2] == 6) {//一将一杀
            foul_value1.type = move_foul_type.move_foul_type_cycle_jiangsha;
            foul_value1.fen = foule_fen.jiang + foule_fen.sha;
            foul_value1.reason = '一将一杀';
        } else if ((actionList[0] == actionList[2]) && (actionList[0] + actionList[2] == 8)) {//两杀
            foul_value1.type = move_foul_type.move_foul_type_cycle_shasha;
            foul_value1.fen = foule_fen.sha * 2;
            foul_value1.reason = '长杀';
        } else if (actionList[0] + actionList[2] == 32) {//两捉
            foul_value1.type = move_foul_type.move_foul_type_cycle_zhuozhuo;
            foul_value1.fen = foule_fen.zhuo * 2;
            foul_value1.reason = '长捉';
        } else if (actionList[0] + actionList[2] == 18) {//一将一捉
            foul_value1.type = move_foul_type.move_foul_type_cycle_jiangzhuo;
            foul_value1.fen = foule_fen.zhuo + foule_fen.jiang;
            foul_value1.reason = '一将一捉';
        } else if (actionList[0] + actionList[2] == 20) {//一杀一捉
            foul_value1.type = move_foul_type.move_foul_type_cycle_jiangzhuo;
            foul_value1.fen = foule_fen.zhuo + foule_fen.sha;
            foul_value1.reason = '一杀一捉';
        } else {
            foul_value1.type = 0;
            foul_value1.fen = 0;
            foul_value1.reason = null;
        }

    }
    if (actionList[1] == actions.action_null || actionList[3] == actions.action_null) {
        foul_value2.fen = 0;
        foul_value2.type = 0;
        foul_value2.reason = null;
    } else {
        if ((actionList[1] == actionList[3]) && (actionList[1] + actionList[3] == 4)) {//长将
            foul_value2.type = move_foul_type.move_foul_type_cycle_jiangjiang;
            foul_value2.fen = foule_fen.jiang * 2;
            foul_value2.reason = '长将';
        } else if (actionList[1] + actionList[3] == 6) {//一将一杀
            foul_value2.type = move_foul_type.move_foul_type_cycle_jiangsha;
            foul_value2.fen = foule_fen.jiang + foule_fen.sha;
            foul_value2.reason = '一将一杀';
        } else if ((actionList[1] == actionList[3]) && (actionList[1] + actionList[3] == 8)) {//两杀
            foul_value2.type = move_foul_type.move_foul_type_cycle_shasha;
            foul_value2.fen = foule_fen.sha * 2;
            foul_value2.reason = '长杀';
        } else if (actionList[1] + actionList[3] == 32) {//两捉
            foul_value2.type = move_foul_type.move_foul_type_cycle_zhuozhuo;
            foul_value2.fen = foule_fen.zhuo * 2;
            foul_value2.reason = '长捉';
        } else if (actionList[1] + actionList[3] == 18) {//一将一捉
            foul_value2.type = move_foul_type.move_foul_type_cycle_jiangzhuo;
            foul_value2.fen = foule_fen.zhuo + foule_fen.jiang;
            foul_value2.reason = '一将一捉';
        } else if (actionList[1] + actionList[3] == 20) {//一杀一捉
            foul_value2.type = move_foul_type.move_foul_type_cycle_jiangzhuo;
            foul_value2.fen = foule_fen.zhuo + foule_fen.sha;
            foul_value2.reason = '一杀一捉';
        } else {
            foul_value2.type = 0;
            foul_value2.fen = 0;
            foul_value2.reason = null;
        }
    }
    var foul_value = [foul_value1, foul_value2];
    if (foul_value[0].fen > foul_value[1].fen) {
        foul_value.push({ result: 2, reason: foul_value[0].reason })
        foul_value[1].type = 0;
        foul_value[1].fen = 0;
        foul_value[1].reason = null;

    } else if (foul_value[0].fen < foul_value[1].fen) {
        foul_value.push({ result: 1, reason: foul_value[1].reason })
        foul_value[0].type = 0;
        foul_value[0].fen = 0;
        foul_value[0].reason = null;
    } else {
        if (foul_value1.fen == 0) {
            foul_value.push({ result: 3, reason: '循环局面' });
            foul_value[0].type = move_foul_type.move_foul_type_cycle_round;
            foul_value[1].type = move_foul_type.move_foul_type_cycle_round;
        } else {
            var reason = null;
            if (!!foul_value2.reason && !!foul_value1.reason) {
                reason = foul_value1.reason + "VS" + foul_value2.reason;
            }
            foul_value.push({ result: 3, reason: reason })
        }
    }
    return foul_value;
}
function is_60round(moves) {
    var step_count = 0
    for (var i = moves.length - 1; i >= 0; i--) {
        var move_chess_data = moves[i];
        if (move_chess_data.action & actions.action_jiang)
            continue
        if (move_chess_data.action & actions.action_chi)
            break
        step_count++
        if (step_count == 120)
            break
    }

    return step_count == 120
}
