apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin, mixin_chess],
        data: {
            pageType: 'AI',
            pageShareType: 'ai_index',
            pageIndex: -1,
            isPassNum: false,
            roomList: [], //房间列表
            upgrade_result: { exceed: {}, strength: {}, city: {}, province: {}, country: {} },//升级了
            showUpgrade: false,
            click_start: false,//点击了匹配按钮
            popupRule: false,//计时规则提示
            noPrompt: false,//不再提醒
            popupOver: false,//游戏结束的弹窗
            player_status: [{
                total_time: 0,
                display: false,
                currentRate: 100,
            }, {
                total_time: 0,
                display: false,
                currentRate: 100
            }],
            player_times: [{
                gametime: 0,
                steptime: 0,
            },
            {
                gametime: 0,
                steptime: 0,
            }
            ],
            num: '',
            can: '',
            time_rule: {},
            isLoading: false,
        },
        created: function () {
            var _this = this;
            this.num = api.pageParam.num;
            this.resizeS();
            window.onresize = function () {
                _this.resizeS();
            }
        },
        watch: {
            popupOver: function () {
                if (this.popupOver) {
                    this.shareChessid = this.qlcp_result.chessid;
                } else {
                    this.shareChessid = '';
                }
            },
        },
        methods: {
            initData: function () {
                var time_rule = this.commonRule.integral[0];
                time_rule.firststep = time_rule.firststep.split(",");
                this.time_rule = time_rule;
                this.player_status = [{
                    total_time: time_rule.firststep[1],
                    display: false,
                    currentRate: 100,
                }, {
                    total_time: time_rule.firststep[1],
                    display: false,
                    currentRate: 100
                }];
                this.player_times = [{
                    gametime: time_rule.gametime,
                    steptime: time_rule.firststep[0],
                },
                {
                    gametime: time_rule.gametime,
                    steptime: time_rule.firststep[0],
                }];
                this.getPlayData();
                this.init();
            },
            continue_ai: function (next) {
                this.popupOver = false;
                if (next >= 1) {
                    var num = next;
                    mySendMessage(mysetting.routes.inGuanka, {
                        num: num
                    }, function (data) {
                        if (data.errno && data.errno != 0) {
                            vue.$dialog.alert({
                                title: '提醒',
                                message: data.message,
                                confirmButtonColor: '#3388ff'
                            }).then(function () {
                                vue.closePage();
                            })
                        } else {
                            vue.isPassNum = true;
                        }
                    });
                } else {
                    this.rebackHall();
                }
            },
            returnBack: function () {
                if (this.pageIndex == 0) {
                    this.closePage();
                }
                if (this.pageIndex == 1 || this.pageIndex == 3) {
                    onEscape();
                }
                if (this.pageIndex == 4) {
                    this.rebackHall();
                }
            },
            clickButton: function (name, isactive) {
                if (name == 'leave' && isactive) {
                    onEscape();
                }
                if (name == 'huiqi' && isactive) {
                    onRegret();
                }
                if (name == 'renshu' && isactive) {
                    onGiveUp();
                }
                if (name == 'qiuhe' && isactive) {
                    onVote();
                }
                if (name == 'setting') {
                    this.popupSetting = true;
                }
            }, //点击左侧隐藏按钮（退出、认输、悔棋、求和、设置）
            startqlcp: function () {
                this.showUpgrade = false;
                this.popupOver = false;
                movesIndex = 0;
                this.click_start = true;
                if (this.fileloaded) {
                    onClickStart();
                } else {
                    setTimeout(function () {
                        if (!vue.fileloaded) {
                            vue.getUserInfo();
                            vue.getCommonData();
                        }
                    }, 2000)
                }
            }, //点击开始棋力测评
            ruleHide: function () {
                if (this.noPrompt) {
                    localStorage.setItem('ruleAIHide', '1');
                }
                this.popupRule = false;
            }, //进入对局的计时规则提示
            scenePlay: function (s_c_body, status) {
                var _this = this;
                isVerticalReverse = 0;
                this.isplaying = true;
                this.playersInfo = s_c_body.players;
                this.dataX = [0];
                this.dataY = [0];
                for (var i = 0; i < s_c_body.scores.length; i++) {
                    this.dataX[i] = i;
                    this.dataY[i] = turnScore(s_c_body.scores[i]);
                    if (i == s_c_body.scores.length - 1 && this.myChart2) {
                        this.changeToolTip(0, this.dataY.length - 1);
                    }
                }
                this.time_rule.gametime=s_c_body.player_times[0].gametime
                if (this.playersInfo[0].uid == this.uid) {
                    this.role = this.playersInfo[0].role;
                    this.playersInfo = this.exchangeAB(this.playersInfo);
                    this.player_times = this.exchangeAB(s_c_body.player_times);
                    this.chairId = 0;
                    this.optionInfo[1].times = s_c_body.vote_undo_last_count[0];
                    this.optionInfo[3].times = s_c_body.vote_peace_last_count[0];
                    this.pageIndex = 1;
                } else if (this.playersInfo[1].uid == this.uid) {
                    this.role = this.playersInfo[1].role;
                    this.chairId = 1;
                    isVerticalReverse = 1;
                    this.player_times = s_c_body.player_times;
                    this.optionInfo[1].times = s_c_body.vote_undo_last_count[1];
                    this.optionInfo[3].times = s_c_body.vote_peace_last_count[1];
                    this.pageIndex = 1;
                } else {
                    this.role = 3;
                    this.playersInfo = this.exchangeAB(this.playersInfo);
                    this.chairId = null;
                    this.player_times = this.exchangeAB(s_c_body.player_times);
                    this.optionInfo[1].times = s_c_body.vote_undo_last_count[0];
                    this.optionInfo[3].times = s_c_body.vote_peace_last_count[0];
                    this.pageIndex = 3;
                    if (this.pangguanInfos == 1) {
                        setTimeout(function () {
                            _this.initChart2();
                        }, 100);
                    }
                }
                this.player_status[0].total_time = this.player_times[0].steptimeTotal;
                this.player_status[1].total_time = this.player_times[1].steptimeTotal;
                this.current_user = s_c_body.current_user;
                initMap = board2map(s_c_body.chessid_map);
                movesIndex = s_c_body.move_chess_step;
                if (status == 1) {
                    isVerticalReverse ? isVerticalReverse = 0 : isVerticalReverse = 1;
                    initMap = arrReverse(initMap);
                    this.playersInfo = this.exchangeAB(this.playersInfo);
                    this.player_times = this.exchangeAB(this.player_times);
                    this.player_status = this.exchangeAB(this.player_status);
                }
                if (s_c_body.prevMove.from_pos) {
                    this.move_step = s_c_body.prevMove.from_pos.x + '' + s_c_body.prevMove.from_pos.y + '' + s_c_body.prevMove.to_pos.x + '' + s_c_body.prevMove.to_pos.y;
                }
                this.player_status[0].display = false;
                this.player_status[1].display = false;
                if (isVerticalReverse == 1) {
                    this.move_step = reverseStep(this.move_step);
                    if (s_c_body.current_user != 0) {
                        this.player_status[1].display = true;
                        this.player_status[1].currentRate = this.player_times[1].steptime / this.player_status[1].total_time * 100;
                    } else {
                        this.player_status[0].display = true;
                        this.player_status[0].currentRate = this.player_times[0].steptime / this.player_status[0].total_time * 100;
                    }
                } else {
                    if (s_c_body.current_user == 0) {
                        this.player_status[1].display = true;
                        this.player_status[1].currentRate = this.player_times[1].steptime / this.player_status[1].total_time * 100;
                    } else {
                        this.player_status[0].display = true;
                        this.player_status[0].currentRate = this.player_times[0].steptime / this.player_status[0].total_time * 100;
                    }

                }
                this.iscontinue = true;
                this.pangguanList = s_c_body.observes;
                this.pangguanPerson = s_c_body.observesLength;
                this.initMove = s_c_body.prevMove;
                this.messageContent = s_c_body.messageContent ? s_c_body.messageContent : [];
                //记录本房间号
                this.roomID = s_c_body.roomID;
                //判断是否收藏
                this.favorChess = s_c_body.isCollect;
                if (this.fileloaded) {
                    if (this.iscontinue) {
                        if (this.role == 1 || this.role == 2) {
                            this.pageIndex = 1;
                            this.iscontinue = false;
                        } else {
                            this.pageIndex = 3;
                            this.iscontinue = false;
                        }
                        setTimeout(function () {
                            onGameBegin();
                        }, 10);
                    }
                } else {
                    setTimeout(function () {
                        if (!vue.fileloaded) {
                            vue.getUserInfo();
                            vue.getCommonData();
                        }
                    }, 2000)
                }
            },//所有界面的渲染入口
            getRoomList: function () {
                var _this = this;
                mySendMessage(mysetting.routes.getTableList, {
                    type: 2
                }, function (data) {
                    _this.isLoading = false;
                    if (data.errno == 0) {
                        _this.roomList = data.data;
                    } else {
                        _this.$toast(data.message);
                    }
                });
            },
            rebackHall: function () {
                if (this.isPassNum) {
                    this.closePage();
                } else {
                    this.pageIndex = 0;
                    this.getRoomList();
                    this.resetValue();
                }
            },
            resetValue: function () {
                this.dialogType = dialog_default;
                // this.playersInfo = [{}, this.memberinfo];
                if (this.pageIndex == 1) {
                    this.playersInfo = [{}, this.memberinfo];
                } else if (this.pageIndex == 0) {
                    this.playersInfo = [{}, {}];
                }
                this.player_times = [{}, {}];
                this.optionInfo = optionInfo;
                this.popupRule = false;
                this.redBlack = false;
                this.popupAnalyse = false;
                this.popupButtons = false;
                this.popupSetting = false;
                this.popupPangguan = false;
                this.pangguanList = [];
                this.favorChess = false;
                this.popupInform = false;
                this.popupMessage = 0;
                this.popupGrade = false;
                this.popupGrade2 = false;
                this.shareRemind = false;
                this.imgText = 'text';
                this.message = [];
                this.messageContent = [];
                this.inputValue = '';
                this.popup_unit.show = false;
                this.isFullScreen = false;
                this.dataX = [0];
                this.dataY = [0];
                this.myChart = '';
                this.myChart2 = '';
                this.pangguanInfos = 0;
                this.player_status = [{
                    total_time: 1200,
                    display: false,
                    currentRate: 100,
                }, {
                    total_time: 1200,
                    display: false,
                    currentRate: 100
                }];
                if (comm.nodes) {
                    comm.nodes.length = 0;
                    movesIndex = 0;
                    currentId = 0;
                }
                this.chairId = null;
                this.current_user = null;
                waitServerPlay = false;
                this.chess_move_action = chess_move_action;
                this.initMove = {};
                this.roomID = '';
                if (!!qlcp_timeer) {
                    clearInterval(qlcp_timeer);
                    qlcp_timeer = null;
                }
                this.isplaying = false;
                this.move_step = '';
            },
            qlcp_lookon: function (roomID, status) {
                var _this = this;
                if (roomID) {
                    mySendMessage(mysetting.routes.joinRoom, { roomID: roomID }, function (data) {
                        _this.$toast.clear();
                        if (data.errno == 0) {
                            if (data.data.isplaying) {
                                if (data.data.roomType == 'hydz' || data.data.roomType == 'QS') {
                                    _this.openPage('play_chess/create_room');
                                } else {
                                    var s_c_body = data.data.playData;
                                    _this.scenePlay(s_c_body, status);
                                    _this.pageIndex = 3;
                                    if (vue.pangguanInfos == 1) {
                                        setTimeout(function () {
                                            _this.initChart2();
                                        }, 100);
                                    }
                                }
                            }
                        } else {
                            _this.$dialog.alert({
                                title: '提醒',
                                message: data.message,
                                confirmButtonColor: '#3388ff'
                            }).then(function () {
                                _this.rebackHall();
                            });
                        }
                    });
                }
            },//进入旁观
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    this.fileloaded = true;
                    this.qipanLoading = false;
                    this.defaultImg = default_img;
                    initLayer(evt);
                    if (api.pageParam.showLoading) {
                        this.$toast.clear();
                    }
                    if (this.click_start && !this.iscontinue) {
                        onClickStart();
                    }
                    if (this.iscontinue) {
                        if (this.roomID != '' && this.pageIndex == -1) {
                            this.qlcp_lookon(this.roomID)
                        } else {
                            this.iscontinue = false;
                            onGameBegin();
                        }
                    }
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            },
        },
    });
}