var mixin_analyse = {
    data: {
        dataX: [],
        dataY: [],
        myChart: '',
        seriesIndex: 0,
        branchList: [],
        analyseType: '大师开局',
        analyseIndex: 0,
        openList: [],
        middleList: [],
        endList: [],
        mode: 1,
    },
    methods: {
        initEchart: function () {
            var _this = this;
            _this.myChart = echarts.init(document.getElementById('situation_map'));
            option = {
                tooltip: {
                    trigger: 'axis',
                    padding: [0, 5],
                    borderWidth: 0,
                    backgroundColor: 'rgba(255,0,0,.8)',
                    textStyle: {
                        color: '#ffffff'
                    },
                    axisPointer: {
                        axis: 'x',
                        animation: false,
                        type: 'line',
                        lineStyle: {
                            color: '#ffffff',
                            type: 'solid',
                            fontSize: 10,
                            width: 1
                        }
                    },
                    triggerOn: 'none',
                    confine: true,
                    extraCssText: 'z-index: 999',
                    alwaysShowContent: true,
                    position: function (point, params, dom, rect, size) {
                        // 固定在顶部
                        var wid = size.viewSize[0] * 0.92 - size.contentSize[0];
                        if (point[0] > wid) {
                            return [point[0] - size.contentSize[0] - 5, 10];
                        } else {
                            return [point[0] + 5, 10];
                        }
                    },
                    formatter: function (params) {
                        var option = _this.myChart.getOption();
                        var score = Math.abs(comm.nodes[currentId].score);
                        var temp = 0;
                        var temp2 = '';
                        var temp_val = option.series[_this.getSeries(currentId)].data[params[0].dataIndex];
                        if (temp_val > 0) {
                            // temp = Math.round(10 * Math.pow(5, temp_val / 10000));
                            temp = score;
                            if (temp > 0 && temp <= 100) {
                                temp2 = '红略优';
                            } else if (temp > 100 && temp <= 300) {
                                temp2 = '红优';
                            } else if (temp > 300 && temp <= 600) {
                                temp2 = '红大优';
                            } else if (temp > 600 && temp <= 29000) {
                                temp2 = '红胜势';
                            } else if (temp > 29000 && temp <= 29999) {
                                temp2 = '红杀棋';
                            } else {
                                temp2 = '红胜';
                            }
                        } else if (temp_val == 0) {
                            temp = 0;
                            temp2 = '均势';
                        } else {
                            // temp = Math.round(10 * Math.pow(5, (-temp_val) / 10000));
                            temp = score;
                            if (temp > 0 && temp <= 100) {
                                temp2 = '黑略优';
                            } else if (temp > 100 && temp <= 300) {
                                temp2 = '黑优';
                            } else if (temp > 300 && temp <= 600) {
                                temp2 = '黑大优';
                            } else if (temp > 600 && temp <= 29000) {
                                temp2 = '黑胜势';
                            } else if (temp > 29000 && temp <= 29999) {
                                temp2 = '黑杀棋';
                            } else {
                                temp2 = '黑胜';
                            }
                        }
                        return Math.ceil(params[0].dataIndex / 2) + '-' + temp2 + '(' + temp + ')';
                    },
                },
                xAxis: {
                    type: 'category',
                    data: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10],
                    boundaryGap: false,
                    axisTick: false,
                    splitLine: {
                        show: true,
                        interval: 9,
                        lineStyle: {
                            color: '#dcc5b3',
                            opacity: 0.2
                        }
                    },
                    axisLine: {
                        lineStyle: {
                            color: '#dcc5b3'
                        }
                    },
                    axisLabel: {
                        interval: function (index, value) {
                            if (vue.dataX.length <= 46) {
                                if (index % 2 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 91) {
                                if (index % 4 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 136) {
                                if (index % 6 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 181) {
                                if (index % 8 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 226) {
                                if (index % 10 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else {
                                if (index % 20 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            }
                        },
                        color: '#dcc5b3',
                        fontSize: 10,
                        margin: 3,
                        formatter: function (value) {
                            return Math.ceil(value / 2)
                        }
                    },
                },
                yAxis: {
                    type: 'value',
                    splitNumber: 4,
                    splitLine: {
                        lineStyle: {
                            color: '#dcc5b3',
                            opacity: 0.2
                        }
                    },
                    axisTick: false,
                    axisLine: {
                        lineStyle: {
                            color: '#dcc5b3'
                        }
                    },
                    axisLabel: {
                        color: '#dcc5b3',
                        margin: 3,
                        padding: [-10, 0, 0, 0],
                        fontSize: 10,
                        inside: true,
                        formatter: function (value, index) {
                            var temp = Math.abs(value);
                            if (value > 0) {
                                temp = 10 * Math.round(Math.pow(5, value / 10000));
                            } else if (value == 0) {
                                temp = 0;
                            } else {
                                temp = '-' + 10 * Math.round(Math.pow(5, -value / 10000));
                            }
                            return temp;
                        }
                    }
                },
                series: [],
                grid: {
                    left: '3%',
                    right: '3%',
                    bottom: '15px',
                    top: '12px',
                },
            };
            this.myChart.setOption(option, true);
            this.clickChart();
        },
        changeToolTip: function (seriesIndex, dataIndex) {
            var _this = this;
            this.seriesIndex = seriesIndex;
            setTimeout(function () {
                if (_this.myChart) {
                    _this.myChart.dispatchAction({
                        type: 'showTip',
                        seriesIndex: seriesIndex,
                        dataIndex: dataIndex
                    });
                replayBtnUpdate();
                if (((comm.getHold() == BLACK && b_autoset) || (comm.getHold() == RED && r_autoset)) && movesIndex == moves.length) {
                    waitServerPlay = true;
                    }
                }
            }, 1);
        },
        clickChart: function () { //点击折线图的任意位置
            var _this = this;
            if (this.myChart) {
                this.myChart.getZr().on('mousemove', function (params) { //点击操作
                    if (_this.mode == 1) {
                        _this.$toast('局势图加载中，请稍后');
                        return;
                    }
                    var pointInPixel = [params.offsetX, params.offsetY];
                    if (_this.myChart.containPixel('grid', pointInPixel)) {
                        var xIndex=movesIndex;
                        if (_this.myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel)){
                            xIndex = _this.myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel)[0]; //X轴序号
                        }
                        //获得图表中我们想要的数据
                        // if (params.target && params.target.parent && params.target.parent._seriesModel && params.target.parent._seriesModel.seriesIndex != _this.seriesIndex) {
                        //     onClickChart(xIndex, _this.branchList[params.target.parent._seriesModel.seriesIndex].ID[xIndex]);
                        // } else {
                        if (movesIndex == xIndex) return;
                        var op = _this.myChart.getOption();
                        if (xIndex > op.series[_this.seriesIndex].data.length - 1) {
                            //切换到另外的分支
                            var flag = false;
                            for (var i = 0; i < _this.branchList.length; i++) {
                                for (var j = 0; j < _this.branchList[i].ID.length; j++) {
                                    if (_this.branchList[i].X[j] && _this.branchList[i].X[j] == xIndex) {
                                        onClickChart(xIndex, _this.branchList[i].ID[j]);
                                        flag = true;
                                        break;
                                    }
                                }
                                if (flag) break;
                            }
                        } else {
                            onClickChart(xIndex);
                        }
                        // }
                    }
                });
            }
        },
        refreshJushi: function (canIndex) { //刷新折线图
            if (!this.myChart) return;
            var _this = this;
            var option = this.myChart.getOption();
            var tempList = comm.getBranch(0);
            if (tempList.length < this.branchList.length) {
                option.series = [];
            }
            this.branchList = tempList;
            for (var i = 0; i < tempList.length; i++) {
                if (i == 0) {
                    if (tempList[i].X.length <= 10) {
                        option.xAxis[0].data = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
                        this.dataX = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
                    } else {
                        option.xAxis[0].data = tempList[i].X;
                        this.dataX = tempList[i].X;
                    }
                } else {
                    if (tempList[i].X.length > this.dataX.length) {
                        option.xAxis[0].data = tempList[i].X;
                        this.dataX = tempList[i].X;
                    }
                }
                (function (i) {
                    var ser = {
                        type: 'line',
                        data: tempList[i].Y,
                        lineStyle: {
                            color: '#dcc5b3',
                            width: 1
                        },
                        itemStyle: {
                            color: '#ffffff',
                        },
                        symbol: 'circle',
                        symbolSize: function (value, params) {
                            if (comm.nodes[_this.branchList[i].ID[params.dataIndex]].child.length > 1) {
                                return 6;
                            } else {
                                return 0;
                            }
                        },
                        emphasis: { // hover状态折线显示
                            scale: false,
                            lineStyle: {
                                color: '#dcc5b3',
                                width: 1
                            }
                        },
                        markPoint: {
                            symbol: 'pin',
                            symbolSize: 18,
                            label: {
                                color: '#ffffff',
                                fontSize: 10,
                            },
                            itemStyle: {
                                color: '#2ba346'
                            },
                            data: [],
                            animation: false,
                        },
                        markLine: {
                            // silent: true,
                            symbol: 'none',
                            lineStyle: {
                                type: 'solid',
                                color: '#dcc5b3'
                            },
                            data: [],
                            animation: false,
                        },
                    };
                    if (i == 0) {
                        ser.markPoint.data.push({
                            symbol: 'roundRect',
                            symbolSize: 0,
                            animation: false,
                            coord: [20, vue.myChart.getModel().getComponent('yAxis').axis.scale._extent[1]],
                            label: {
                                position: 'right',
                                offset: [2, 15],
                                formatter: function () {
                                    return '10(中局)'
                                },
                                color: '#ffffff',
                                backgroundColor: '#644227',
                                padding: 4,
                                borderRadius: 4,
                                fontSize: 10
                            },
                        });
                        ser.markLine.data.push({
                            xAxis: 20,
                            label: {
                                show: false
                            }
                        });
                        if (canIndex) {
                            ser.markPoint.data.push({
                                symbol: 'roundRect',
                                symbolSize: 0,
                                animation: false,
                                coord: [canIndex, vue.myChart.getModel().getComponent('yAxis').axis.scale._extent[1]],
                                label: {
                                    position: 'right',
                                    offset: [2, 15],
                                    formatter: function () {
                                        return '(' + parseInt(canIndex / 2) + '残局)'
                                    },
                                    color: '#ffffff',
                                    backgroundColor: '#644227',
                                    padding: 4,
                                    borderRadius: 4,
                                    fontSize: 10
                                },
                            });
                            ser.markLine.data.push({
                                xAxis: canIndex,
                                label: {
                                    show: false
                                }
                            });
                        }
                    }
                    for (var j = 1; j < _this.branchList[i].ID.length; j++) {
                        var temp_child = comm.nodes[comm.nodes[_this.branchList[i].ID[j]].pater].child;
                        if (temp_child.length > 1) {
                            for (var k = 0; k < temp_child.length; k++) {
                                if (temp_child[k] == _this.branchList[i].ID[j]) {
                                    ser.markPoint.data.push({
                                        coord: [j, tempList[i].Y[j]],
                                        value: k + 1,
                                    });
                                }
                            }
                        }
                    }
                    option.series[i] = ser;
                })(i);
            }
            var tempId = this.getSeries(currentId);
            option.series[tempId].lineStyle.color = '#ffffff';
            option.series[tempId].emphasis.lineStyle.color = '#ffffff';
            option.series[tempId].lineStyle.width = 2;
            option.series[tempId].emphasis.lineStyle.width = 2;
            // this.clickChart(); //当折线图刷新出来后，允许用户的点击操作
            for (var j = 0; j < tempList[tempId].ID.length; j++) {
                if (tempList[tempId].ID[j] == currentId) {
                    this.changeToolTip(tempId, j); //修改当前位置
                    if (comm.getHold() == RED) {
                        option.tooltip[0].backgroundColor = 'rgba(255,0,0,.8)';
                    } else {
                        option.tooltip[0].backgroundColor = 'rgba(0,0,0,.8)';
                    }
                    break;
                }
            }
            if (vue.pageTypeForAnalyse){
                if ( vue.tabActive===1){
                    this.myChart.setOption(option, true);
                }
            }else {
                this.myChart.setOption(option, true);
            }
        },
        refreshJushi2: function (i, score, list) { //刷新折线图
            var _this = this;
            var option = this.myChart.getOption();
            var tempList = this.branchList;
            if (i == 0) {
                option.xAxis[0].data = tempList[i].X;
                this.dataX = tempList[i].X;
            } else {
                if (tempList[i].X.length > this.dataX.length) {
                    option.xAxis[0].data = tempList[i].X;
                    this.dataX = tempList[i].X;
                }
            }
            if (!option.series[i] || option.series[0].data.length == 0) {
                this.dataY[i] = [];
                if (list) {
                    this.dataY[i] = list;
                } else {
                    this.dataY[i][0] = score;
                }
                var ser = {
                    type: 'line',
                    data: _this.dataY[i],
                    lineStyle: {
                        color: '#ffffff',
                        width: 2
                    },
                    itemStyle: {
                        color: '#ffffff',
                    },
                    symbol: 'circle',
                    symbolSize: function (value, params) {
                        if (comm.nodes[_this.branchList[i].ID[params.dataIndex]].child.length > 1) {
                            return 6;
                        } else {
                            return 0;
                        }
                    },
                    emphasis: { // hover状态折线显示
                        scale: false,
                        lineStyle: {
                            color: '#ffffff',
                            width: 2
                        }
                    },
                    markPoint: {
                        symbol: 'pin',
                        symbolSize: 18,
                        label: {
                            color: '#ffffff',
                            fontSize: 10,
                        },
                        itemStyle: {
                            color: '#2ba346'
                        },
                        data: [],
                        animation: false,
                    },
                    markLine: {
                        // silent: true,
                        symbol: 'none',
                        lineStyle: {
                            type: 'solid',
                            color: '#dcc5b3'
                        },
                        data: [],
                        animation: false,
                    },
                };
                option.series[i] = ser;
            } else {
                this.dataY[i].push(score);
                option.series[i].data = this.dataY[i];
                var temp_child = comm.nodes[comm.getCurrentNode().pater].child;
                if (temp_child.length > 1) {
                    for (var k = 0; k < temp_child.length; k++) {
                        if (temp_child[k] == comm.getCurrentNode().id) {
                            option.series[i].markPoint.data.push({
                                coord: [_this.dataY[i].length - 1, score],
                                value: k + 1,
                            });
                        }
                    }
                }
            }
            for (var j = 0; j < option.series.length; j++) {
                if (i == j) {
                    if (score > 0) {
                        option.tooltip[0].backgroundColor = 'rgba(255,0,0,.8)';
                    } else if (score == 0) {
                        option.tooltip[0].backgroundColor = 'rgba(43,163,70,.8)';
                    } else {
                        option.tooltip[0].backgroundColor = 'rgba(0,0,0,.8)';
                    }
                    option.series[i].lineStyle.color = '#ffffff';
                    option.series[i].emphasis.lineStyle.color = '#ffffff';
                    option.series[i].lineStyle.width = 2;
                    option.series[i].emphasis.lineStyle.width = 2;
                } else {
                    option.series[j].lineStyle.color = '#dcc5b3';
                    option.series[j].emphasis.lineStyle.color = '#dcc5b3';
                    option.series[j].lineStyle.width = 1;
                    option.series[j].emphasis.lineStyle.width = 1;
                }
            }
            this.changeToolTip(i, this.dataY[i].length - 1);
            this.myChart.setOption(option, true);
        },
        getSeries: function (id) { //获取当前的折线index
            var currentSeries = 0;
            var flag = false;
            for (var i = 0; i < this.branchList.length; i++) {
                for (var j = 0; j < this.branchList[i].ID.length; j++) {
                    if (this.branchList[i].ID[j] == id) {
                        currentSeries = i;
                        flag = true;
                        break;
                    }
                }
                if (flag) break;
            }
            return currentSeries;
        },
    }
}
