apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            tabActive: 0,
            list: [
                { name: '我的棋社', roomList: [] },
                { name: '热门棋社', roomList: [] },
                { name: '地方棋社', roomList: [] },
                { name: '布局棋社', roomList: [] },
            ],
            finished: [false, false, false, false],
            loading: [false, false, false, false],
            isLoading: [false, false, false, false],
            pageIndex: [1, 1, 1, 1],
            show: false,
            valueName: '',
            valueNotice: '',
            show2: false,
            valueNumber: '',
            activeNames: [],
            proList: [],
            layList: [],
            showPopup: false,
            popupList: [],
            allCateList: [],
            popupType: '',
            levelTitle: '',
            levelIndex: 0,
            showAction: false,
            actions: [
                { name: '退出该棋社' }
            ],
            tempNum: [],
            myProvince: '',
        },
        created: function () {
            this.getCategoryList();
        },
        methods: {
            onSelect: function (action, index) {
                var _this = this;
                mySendMessage(mysetting.routes.outAssociation, {
                    numbers: _this.tempNum[0],
                }, function (data) {
                    if (data.errno == 0) {
                        _this.list[0].roomList.splice(_this.tempNum[1], 1);
                    }
                    _this.showAction = false;
                    _this.$toast(data.message);
                })
            },
            editList: function (num, index) {
                this.showAction = true;
                this.tempNum[0] = num;
                this.tempNum[1] = index;
            },
            toDetail: function (number) {
                this.openPage('play_chess/association_detail', { number: number })
            },
            createRoom: function () {
                var _this = this;
                this.$dialog.confirm({
                    message: '您即将创建棋社，棋社10天内不使用将被清除',
                    confirmButtonText: '创建',
                    confirmButtonColor: '#3388ff',
                    cancelButtonColor: '#666666'
                }).then(function () {
                    _this.show = true;
                }).catch(function () {

                })
            },
            joinRoom: function () {
                var _this = this;
                mySendMessage(mysetting.routes.joinAssociation, {
                    numbers: _this.valueNumber,
                }, function (data) {
                    if (data.errno == 0) {
                        _this.$toast(data.message);
                        _this.toDetail(_this.valueNumber)
                    } else {
                        _this.valueNumber = '';
                        _this.$toast(data.message);
                    }
                })
            },
            settingNotice: function () {
                var _this = this;
                mySendMessage(mysetting.routes.createAssociation, {
                    name: _this.valueName,
                    notice: _this.valueNotice
                }, function (data) {
                    if (data.errno == 0) {
                        _this.$toast(data.message);
                        _this.toDetail(data.data.numbers)
                    } else {
                        _this.valueName = '';
                        _this.valueNotice = '';
                        _this.$toast(data.message);
                    }
                })
            },
            onRefresh: function (index) {
                var _this = this;
                this.finished[index] = true;
                this.pageIndex[index] = 1;
                if (index == 2) {
                    this.proList[this.memberinfo.resideprovince] = '';
                    this.getList(2, this.memberinfo.resideprovince);
                } else {
                    setTimeout(function () {
                        _this.getList(index);
                    }, 300);
                }
            },
            clickList: function (item) {
                if (!item.hasChild) return;
                this.showPopup = true;
                this.popupList = [];
                this.levelIndex++;
                this.popupType = 'cate';
                this.levelTitle = item.name;
                this.getCategoryList('r', item.id);
            },
            getCategoryList: function (role, pid) {
                var _this = this;
                mySendMessage(mysetting.routes.getAssociationKjCategories, {
                    pid: pid || 0,
                }, function (data) {
                    if (data.errno == 0) {
                        if (!_this.showPopup) {
                            for (var i = 0; i < data.data.length; i++) {
                                _this.layList.push(data.data[i])
                            }
                        } else {
                            for (var i = 0; i < data.data.length; i++) {
                                _this.popupList.push(data.data[i]);
                            }
                            _this.allCateList[_this.levelIndex] = {};
                            _this.allCateList[_this.levelIndex].title = _this.levelTitle;
                            _this.allCateList[_this.levelIndex].list = _this.popupList;
                        }
                    }
                })
            },
            backLevel: function (isClosed) {
                this.levelIndex--;
                this.popupList = [];
                if (this.levelIndex == 0 || isClosed) {
                    this.showPopup = false;
                    this.levelTitle = '';
                    this.allCateList.length = 0;
                } else {
                    this.allCateList.length = this.allCateList.length - 1;
                    this.levelTitle = this.allCateList[this.levelIndex].title;
                    this.popupList = this.allCateList[this.levelIndex].list;
                }
            },
            getList: function (index, province) {
                var vm = this;
                var op = '';
                index == 0 ? op = 'my' : (index == 1 ? op = 'hot' : (index == 2 ? op = 'location' : op = 'layout'));
                if (index != 2 || (index == 2 && province && !vm.proList[province])) {
                    mySendMessage(mysetting.routes.getAssociations, {
                        page: vm.pageIndex[index],
                        op: op,
                        province: province || null,
                        psize: province ? 50 : 10
                    }, function (data) {
                        if (data.errno == 0) {
                            if (vm.pageIndex[index] == 1) {
                                vm.list[index].roomList = [];
                            }
                            if (province) {
                                vm.proList[province] = [];
                                for (var i = 0; i < data.data.length; i++) {
                                    vm.proList[province].push(data.data[i]);
                                    if (data.data[i].extra == vm.memberinfo.residecity) {
                                        vm.myProvince = data.data[i];
                                    }
                                }
                                vm.$set(vm.loading, index, false);
                                vm.$set(vm.isLoading, index, false);
                                vm.$set(vm.finished, index, true);
                            } else {
                                for (var i = 0; i < data.data.length; i++) {
                                    vm.list[index].roomList.push(data.data[i]);
                                }
                                vm.$set(vm.loading, index, false);
                                vm.$set(vm.isLoading, index, false);
                                vm.$set(vm.finished, index, false);
                                vm.pageIndex[index]++;
                            }
                        } else {
                            vm.$set(vm.loading, index, false);
                            vm.$set(vm.isLoading, index, false);
                            vm.$set(vm.finished, index, true);
                        }
                    });
                }
            }
        },
    });

}
