apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            pageShareType: 'association',
            list: [],
            finished: false,
            loading: false,
            isLoading: false,
            pageIndex: 1,
            initInfo: {},
            show: false,
            show4: false,
            valueName: '',
            valueNotice: '',
            valuePassword2: '',
            currentInfo: {},
            numbers: '',
            myInterval: ''
        },
        created: function () {
            this.numbers = api.pageParam.number;
            this.shareNumbers = this.numbers;
            this.initData();
            this.getTablesState();
            var jsfun = 'vue.onRefresh(0);';
            api.execScript({
                name: 'play_chess/association',
                frameName: 'play_chess/association',
                script: jsfun
            });
        },
        methods: {
            closeInter: function () {
                if (this.myInterval) {
                    clearInterval(this.myInterval);
                    this.myInterval = ''
                }
            },
            getTablesState: function () {
                var _this = this;
                _this.initState();
                this.myInterval = setInterval(function () {
                    _this.initData();
                    _this.initState();
                }, 3000);
            },
            initState: function () {
                var _this = this;
                if (_this.list.length > 0) {
                    var uids = [];
                    for (var i = 0; i < _this.list.length; i++) {
                        uids.push(i)
                    }
                    mySendMessage(mysetting.routes.getAssociation, {
                        numbers: _this.numbers,
                        op: 'getTableStatus',
                        tableIndexs: uids
                    }, function (data) {
                        if (data.errno == 0) {
                            for (var j = 0; j < _this.list.length; j++) {
                                _this.$set(_this.list, j, data.data[j]);
                            }
                        }
                    })
                }
            },
            joinRoom: function () {
                var _this = this;
                mySendMessage(mysetting.routes.joinAssociation, {
                    numbers: _this.numbers,
                }, function (data) {
                    if (data.errno == 0) {
                        _this.initInfo.userStatus = 1;
                    }
                    _this.$toast(data.message);
                })
            },
            initData: function () {
                var _this = this;
                mySendMessage(mysetting.routes.getAssociation, {
                    op: 'init',
                    numbers: _this.numbers
                }, function (data) {
                    if (data.errno == 0) {
                        _this.initInfo = data.data;
                        _this.valueName = data.data.name;
                        _this.valueNotice = data.data.notice;
                    } else {
                        _this.$dialog.alert({
                            title: '提示',
                            message: data.message,
                            confirmButtonColor: '#3388ff'
                        }).then(function () {
                            _this.closePage();
                        })
                    }
                });
            },
            beginGame: function (item, index, role) {
                var _this = this;
                if (item.playing.roomID) {
                    if (item.playing.players[role - 1] && !item.playing.players[role % 2]) {
                        _this.showInfo(item.playing.players[role - 1].uid);
                    } else {
                        if (item.tableInfo.password && this.initInfo.userStatus != 2 && this.initInfo.userStatus != 3 && (!item.playing.players[0] || !item.playing.players[1])) {
                            this.currentInfo.item = item;
                            this.currentInfo.index = index;
                            this.currentInfo.role = role;
                            this.show4 = true;
                        } else {
                            _this.openPage('play_chess/create_room', { roomID: item.playing.roomID, role: role ? 1 : '' });
                        }
                    }
                } else {
                    if (item.tableInfo.password && this.initInfo.userStatus != 2 && this.initInfo.userStatus != 3) {
                        this.currentInfo.item = item;
                        this.currentInfo.index = index;
                        this.currentInfo.role = role;
                        this.show4 = true;
                    } else {
                        mySendMessage(mysetting.routes.createHydzRoom, {
                            numbers: _this.numbers,
                            role: role || 1,
                            tableIndex: index,
                            type: 'QS'
                        }, function (data) {
                            if (data.errno == 0) {
                                _this.openPage('play_chess/create_room', { roomID: data.data.roomID });
                            } else {
                                _this.$toast(data.message);
                            }
                        });
                    }
                }
            },
            checkPassword: function () {
                var _this = this;
                if (_this.currentInfo.item.playing.roomID) {
                    mySendMessage(mysetting.routes.joinRoom, {
                        roomID: _this.currentInfo.item.playing.roomID,
                        password: _this.valuePassword2
                    }, function (data) {
                        if (data.errno == 0) {
                            _this.openPage('play_chess/create_room');
                        } else {
                            _this.$toast(data.message);
                        }
                    });
                } else {
                    mySendMessage(mysetting.routes.createHydzRoom, {
                        numbers: _this.numbers,
                        role: _this.currentInfo.role || 1,
                        tableIndex: _this.currentInfo.index,
                        type: 'QS',
                        password: _this.valuePassword2
                    }, function (data) {
                        _this.valuePassword2 = '';
                        if (data.errno == 0) {
                            _this.openPage('play_chess/create_room', { roomID: data.data.roomID, byCreator: 1 });
                        } else {
                            _this.$toast(data.message);
                        }
                    });
                }
            },
            kickUser: function (index, uid, i) {
                var _this = this;
                mySendMessage(mysetting.routes.kickRoomByManager, {
                    numbers: this.numbers,
                    tableIndex: index,
                    kickUid: uid
                }, function (data) {
                    if (data.errno == 0) {
                        _this.$set(_this.list[index].playing.players, i, null);
                    } else {
                        _this.$toast(data.message);
                    }
                });
            },
            settingNotice: function () {
                var _this = this;
                mySendMessage(mysetting.routes.updateAssociation, {
                    numbers: this.numbers,
                    op: 'edit',
                    name: _this.valueName,
                    notice: _this.valueNotice
                }, function (data) {
                    _this.initInfo.name = _this.valueName;
                    _this.initInfo.notice = _this.valueNotice;
                    _this.$toast(data.message);
                })
            },
            getList: function () {
                var vm = this;
                mySendMessage(mysetting.routes.getAssociation, {
                    op: 'getTables',
                    page: vm.pageIndex,
                    numbers: vm.numbers
                }, function (data) {
                    if (data.errno == 0) {
                        if (vm.pageIndex == 1) {
                            vm.list = [];
                        }
                        for (var i = 0; i < data.data.length; i++) {
                            vm.list.push(data.data[i]);
                        }
                        vm.loading = false;
                        vm.isLoading = false;
                        vm.finished = false;
                        vm.pageIndex++;
                    } else {
                        vm.loading = false;
                        vm.isLoading = false;
                        vm.finished = true;
                    }
                });
            }
        },
    });

}