var mixin_collect = {
    data: {
        catList: [],
        showCreate: false,
        valueName: '',
        showEdit: false,
        tempIndex: '',
        allActive: false,
        popupCollect: false,
    },
    created: function () {
        this.getCatList();
    },
    methods: {
        getCatList: function () {
            mySendMessage(mysetting.routes.dealCat, {
                type: 'getList',
            }, function (data) {
                if (data.errno == 0) {
                    vue.catList = data.data;
                } else {
                    vue.$toast(data.message);
                }
            });
        },
        newCat: function () {
            if (!this.valueName) {
                this.$toast('请输入目录名');
                return;
            }
            if (this.valueName.length > 20) {
                this.$toast('目录名最多支持20个字符');
                return;
            }
            mySendMessage(mysetting.routes.dealCat, {
                type: 'add',
                name: this.valueName
            }, function (data) {
                if (data.errno == 0) {
                    vue.valueName = '';
                    vue.$toast(data.message);
                    vue.getCatList();
                } else {
                    vue.$toast(data.message);
                }
            });
        },
        editCat: function () {
            if (!this.valueName) {
                this.$toast('请输入目录名');
                return;
            }
            if (this.valueName.length > 20) {
                this.$toast('目录名最多支持20个字符');
                return;
            }
            mySendMessage(mysetting.routes.dealCat, {
                type: 'update',
                id: this.catList[this.tempIndex].id,
                name: this.valueName
            }, function (data) {
                if (data.errno == 0) {
                    vue.valueName = '';
                    vue.$toast(data.message);
                    vue.getCatList();
                } else {
                    vue.$toast(data.message);
                }
            });
        },
        editCreate: function (item, index) {
            this.valueName = item.name;
            this.tempIndex = index;
            this.showEdit = true;
        },
        deleteCreate: function (item, index) {
            this.$dialog.confirm({
                message: '是否删除该目录？删除该目录下的棋谱收藏也即将删除',
                confirmButtonText: '删除'
            }).then(function () {
                mySendMessage(mysetting.routes.dealCat, {
                    type: 'delete',
                    id: item.id
                }, function (data) {
                    if (data.errno == 0) {
                        vue.catList.splice(index, 1);
                        vue.$toast(data.message);
                    } else {
                        vue.$toast(data.message);
                    }
                });
            }).catch(function () {

            })
        },
    }
}
