apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin, mixin_collect],
        data: {
            pageIndex: [1, 1],
            list: [[], []],
            loading: [false, false],
            finished: [false, false],
            isEdit: [false, false],
            keyword: '',
            active: 0,
            qipanLoading: true,
            screenWidth: document.body.clientWidth > 768 ? 768 : document.body.clientWidth,
            isCate: api.pageParam.cateId
        },
        created: function () {
            if (!this.isCate) {
                this.init();
            }
        },
        watch: {
            allActive: function (val, oldVal) {
                for (var i = 0; i < this.list[0].length; i++) {
                    if (val) {
                        this.$set(this.list[0][i], 'isActive', true);
                    } else {
                        this.$set(this.list[0][i], 'isActive', false);
                    }
                }
            }
        },
        methods: {
            clickItem: function (item, index) {
                if (this.isEdit[0]) {
                    this.$set(this.list[0][index], 'isActive', !item.isActive);
                } else {
                    this.openPage('chess/chess', { chessid: item.chessid })
                }
            },
            deleteSelect: function () {
                var tempList = [];
                for (var i = 0; i < this.list[0].length; i++) {
                    if (this.list[0][i].isActive) {
                        tempList.push(this.list[0][i].chessid);
                    }
                }
                if (tempList.length != 0) {
                    this.$dialog.confirm({
                        message: '是否删除选中棋谱？',
                        confirmButtonText: '删除'
                    }).then(function () {
                        mySendMessage(mysetting.routes.updateCollect, {
                            collectType: 'cancel',
                            type: 'chess',
                            id: tempList
                        }, function (ret) {
                            if (ret.errno == 0) {
                                vue.popupCollect = false;
                                vue.isEdit[0] = false;
                                vue.finished[0] = true;
                                vue.pageIndex[0] = 1;
                                vue.getList(0);
                                vue.$toast('取消收藏成功');
                            } else {
                                vue.$toast('取消收藏失败');
                            }
                        });
                    }).catch(function () {

                    })
                } else {
                    this.$toast('请选择棋谱');
                }
            },
            collectTo: function (id) {
                var tempList = [];
                for (var i = 0; i < this.list[0].length; i++) {
                    if (this.list[0][i].isActive) {
                        tempList.push(this.list[0][i].chessid);
                    }
                }
                if (id != -1) {
                    mySendMessage(mysetting.routes.updateCollect, {
                        type: 'chess',
                        id: tempList,
                        collectType: 'add',
                        catid: id
                    }, function (data) {
                        if (data.errno == 0) {
                            vue.popupCollect = false;
                            vue.isEdit[0] = false;
                            vue.finished[0] = true;
                            vue.pageIndex[0] = 1;
                            vue.getList(0);
                            vue.getCatList();
                            vue.$toast('棋谱移动成功');
                        } else {
                            vue.$toast(data.message);
                        }
                    });
                } else {
                    if (tempList.length != 0) {
                        this.popupCollect = true;
                    } else {
                        this.$toast('请选择棋谱');
                    }
                }
            },
            deleteCanvas: function (item, index) {
                mySendMessage(mysetting.routes.updateCollect, {
                    type: 'fen',
                    fen: item.fen,
                    collectType: 'cancel'
                }, function (data) {
                    if (data.errno == 0) {
                        vue.list[1].splice(index, 1);
                        vue.$toast('删除成功');
                    } else {
                        vue.$toast(data.message);
                    }
                });
            },
            toSearchs: function () {
                if (this.active != 0) {
                    this.$toast('暂不支持局面搜索');
                    return;
                }
                this.finished[0] = true;
                this.pageIndex[0] = 1;
                this.getList(0);
            },
            getList: function (index) {
                var _this = this;
                if (index) {
                    var obj = {
                        type: 'fen',
                        page: this.pageIndex[index],
                        psize: 8
                    }
                } else {
                    var obj = {
                        page: this.pageIndex[index],
                        title: this.keyword,
                        catid: this.isCate || 0
                    }
                }
                if (this.pageIndex[index] == 1) {
                    this.$set(this.list, index, []);
                }
                mySendMessage(mysetting.routes.getCollects, obj, function (ret) {
                    if (ret.errno == 0) {
                        for (var i = 0; i < ret.data.length; i++) {
                            if (index) {
                                var item = ret.data[i];
                                if (item.reverse) {
                                    initialization(_this.target, 'tempCanvas', arrReverse(board2map(item.fen, 1)), '', 1);
                                } else {
                                    initialization(_this.target, 'tempCanvas', board2map(item.fen, 1), '', '');
                                }
                                _this.$refs['tempCanvas'].width = 72 * 5;
                                _this.$refs['tempCanvas'].height = 83 * 5;
                                stage2.scaleX = stage2.scaleY = 0.5;
                                stage2.update();
                                ret.data[i].src = stage2.toDataURL();
                            } else {
                                _this.allActive = false;
                            }
                            ret.data[i].isActive = false;
                            _this.list[index].push(ret.data[i]);
                        }
                        _this.$set(_this.loading, index, false);
                        _this.$set(_this.finished, index, false);
                        _this.pageIndex[index]++;
                    } else {
                        _this.$set(_this.loading, index, false);
                        _this.$set(_this.finished, index, true);
                    }
                });
            },
            init: function () {
                var loader = new createjs.LoadQueue(false);
                // loader.installPlugin(createjs.Sound);
                loader.on("fileload", this.handleFileLoad);
                loader.on("error", this.handleError);
                loader.on("complete", this.handleComplete);
                loader.loadFile({ src: "../../script/util/ZobristTable.js" });
                loader.loadFile({ src: "../../script/lib/echarts.min.js?version=512" });
                loader.loadFile({ src: "../../script/lib/easeljs.min.js", id: 'Easeljs' });
                loader.loadFile({ src: "../../script/lib/tweenjs.min.js" });
                loader.loadFile({ src: "../../script/lib/MovieClip.js" });
                // loader.loadFile({ src: "../../script/lib/soundjs.min.js" });
                loader.loadFile({ src: "../../script/Model.js?version=610" });
                loader.loadFile({ src: "../../script/View.js?version=610" });
                loader.loadFile({ src: "../../script/Control.js" });
                loader.loadFile({ src: "../../script/Control_chess.js?version=610" });
                loader.loadFile({ src: "../../script/Player.js?version=610" });
                loader.loadFile({ src: "../../script/Chess.js?version=610" });
                loader.loadFile({ src: "../../script/lib/gameRes.js" });
                loader.loadManifest([
                    { src: "../../assets/images/board.png", id: "Board", loadTimeout: 20000 },
                    { src: "../../assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                    { src: "../../assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 },
                    { src: "../../assets/images/tips.png", id: "Loading", loadTimeout: 20000 },
                ]);
            }, //初始化页面吗，加载资源
            handleError: function (evt) {
                this.$toast('chess preload error');
            },
            handleFileLoad: function (evt) {
                if (evt.item.type == "image") {
                    images[evt.item.id] = evt.result;
                }
                if (evt.item.id == 'Easeljs') {
                    chessList = new createjs.SpriteSheet(CHESS_SLIM);
                    effectList = new createjs.SpriteSheet(F_ATLAS);
                }
            },
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    target = evt;
                    this.qipanLoading = false;
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            }
        },
    });
}