apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin, mixin_chess],
        data: {
            pageIndex: 0,
            pageType: 'hydz',
            pageShareType: 'hydz',
            gameBegin: false,
            isCreator: true,
            isBuju: false,
            isFull: true,
            popupOver: false,//游戏结束的弹窗
            activeRule: {
                show: false,
                active: 0,
                time_rule: [],
                rule_value: []
            },
            readyBegin: {
                show: false,
                gameTime: 0,
                stepTime: 0,
                addSecond: 0,
                readTime: 0,
                myWay: '执红',
            },
            player_status: [{
                total_time: 1200,
                display: false,
                currentRate: 100,
            }, {
                total_time: 1200,
                display: false,
                currentRate: 100
            }],
            player_times: [{
                gametime: 1200,
                steptime: 60,
            },
            {
                gametime: 1200,
                steptime: 60,
            }
            ],
            showPopover: [false, false, false, false, false, false],
            roleStatus:0,
            displayLine:true,
        },
        created: function () {
            var _this = this;
            this.resizeS();
            window.onresize = function () {
                _this.resizeS();
            }
        },
        watch: {
            popupOver: function () {
                if (this.popupOver) {
                    this.shareChessid = this.qlcp_result.chessid;
                } else {
                    this.shareChessid = '';
                }
            },
        },
        methods: {
            initData: function () {
                var rule_setting = this.commonRule.friends;
                rule_setting.jingdian.gametime = this.changeToList(rule_setting.jingdian.gametime, 'gametime');
                rule_setting.jingdian.steptime = this.changeToList(rule_setting.jingdian.steptime, 'steptime');
                rule_setting.jingdian.readtime = this.changeToList(rule_setting.jingdian.readtime, 'readtime');
                rule_setting.add.gametime = this.changeToList(rule_setting.add.gametime, 'gametime');
                rule_setting.add.steptime = this.changeToList(rule_setting.add.steptime, 'steptime');
                rule_setting.add.addsecond = this.changeToList(rule_setting.add.addsecond, 'addsecond');
                rule_setting.jingdian.myWay = [{ text: '执红', type: 'myWay' }, { text: '执黑', type: 'myWay' }];
                rule_setting.add.myWay = [{ text: '执红', type: 'myWay' }, { text: '执黑', type: 'myWay' }];
                this.activeRule = {
                    show: false,
                    active: 0,
                    time_rule: [rule_setting.jingdian, rule_setting.add],
                    rule_value: [{
                        gameTime: rule_setting.jingdian.gametime[0].value,
                        stepTime: rule_setting.jingdian.steptime[0].value,
                        readTime: rule_setting.jingdian.readtime[0].value,
                        myWay: '执红',
                    }, {
                        gameTime: rule_setting.add.gametime[0].value,
                        stepTime: rule_setting.add.steptime[0].value,
                        addSecond: rule_setting.add.addsecond[0].value,
                        myWay: '执红',
                    }]
                };
                this.getPlayData();
                this.init();
            },
            changeToList: function (data, type) {
                var list = [];
                for (var i = 0; i < data.length; i++) {
                    var temp = data[i];
                    data[i] = new Object();
                    var te = this.$options.filters['formatTime'];
                    data[i].text = te(temp);
                    data[i].value = temp;
                    data[i].type = type;
                    list[i] = data[i];
                }
                return list;
            },
            toAnalyse: function (chessid, reduid) {
                var _this = this;
                _this.openPage('chess/chess', { chessid: chessid, role: (reduid == uid ? 1 : 2) })
            },
            returnBack: function () {
                if (this.pageIndex == 0 || this.pageIndex == 1 || this.pageIndex == 3) {
                    onEscape();
                }
            },
            editChess: function () {
                this.pageIndex = 5;
                document.getElementById("chess").height = CANVAS_EDIT_H;
                comm.map = initMap;
                onEditboard();
            },
            editOver: function () {
                if (comm.checkJiang() == !1) {
                    showTip("gameError");
                    toastDisplay('开局不能将');
                } else {
                    var _this = this;
                    var currentFen = comm.getBoard();
                    mySendMessage(mysetting.routes.updateRoom, {
                        initMap: currentFen
                    }, function (data) {
                        if (data.errno == 0) {
                            _this.pageIndex = 0;
                            waitServerPlay = true;
                            document.getElementById("chess").height = "830";
                            comm.cMap = comm.arr2Clone(comm.map);
                            initMap = comm.arr2Clone(comm.map);
                            cleanChess();
                            cleanChessEx();
                            mode = playmode.ONLINE;
                            resizeBoard();
                            hideBorder();
                            comm.initChessBymap(initMap);
                        } else {
                            _this.$toast(data.message);
                        }
                    })
                }
            },
            onSelect: function (action) {
                if (action.type == 'gametime') {
                    this.activeRule.rule_value[this.activeRule.active].gameTime = action.value;
                } else if (action.type == 'steptime') {
                    this.activeRule.rule_value[this.activeRule.active].stepTime = action.value;
                } else if (action.type == 'readtime') {
                    this.activeRule.rule_value[this.activeRule.active].readTime = action.value;
                } else if (action.type == 'addsecond') {
                    this.activeRule.rule_value[this.activeRule.active].addSecond = action.value;
                } else if (action.type == 'myWay') {
                    this.activeRule.rule_value[this.activeRule.active].myWay = action.text;
                }
            },
            finishSetting: function () {
                var _this = this;
                this.activeRule.show = false;
                var tempRule = {};
                tempRule.addsecond = 0;
                tempRule.readtime = 0;
                tempRule.firststep = [3, 30];
                var tempRole = 1;
                if (this.activeRule.active == 0) {
                    tempRule.gametime = this.readyBegin.gameTime = this.activeRule.rule_value[0].gameTime;
                    tempRule.steptime = this.readyBegin.stepTime = this.activeRule.rule_value[0].stepTime;
                    tempRule.readtime = this.readyBegin.readTime = this.activeRule.rule_value[0].readTime;
                    this.readyBegin.myWay = this.activeRule.rule_value[0].myWay;
                    if (this.readyBegin.myWay == '执红') {
                        tempRole = 1;
                    } else {
                        tempRole = 2;
                    }
                } else {
                    tempRule.gametime = this.readyBegin.gameTime = this.activeRule.rule_value[1].gameTime;
                    tempRule.steptime = this.readyBegin.stepTime = this.activeRule.rule_value[1].stepTime;
                    tempRule.addsecond = this.readyBegin.addSecond = this.activeRule.rule_value[1].addSecond;
                    this.readyBegin.myWay = this.activeRule.rule_value[1].myWay;
                    if (this.readyBegin.myWay == '执红') {
                        tempRole = 1;
                    } else {
                        tempRole = 2;
                    }
                }
                if (this.pageType == 'QS') {
                    mySendMessage(mysetting.routes.createHydzRoom, {
                        timeRule: tempRule,
                    }, function (data) {
                        if (data.errno != 0) {
                            _this.$toast(data.message);
                        }
                    });
                } else {
                    tempRole == 1 ? isVerticalReverse = 0 : isVerticalReverse = 1;
                    this.role = tempRole;
                    initMap = board2map(InitFen);
                    if (vue.fileloaded) {
                        cleanChess();
                        comm.init(initMap, !0);
                    }
                    mySendMessage(mysetting.routes.createHydzRoom, {
                        timeRule: tempRule,
                        role: tempRole,
                    }, function (data) {
                        if (data.errno == 0) {
                            _this.roomID = data.data.roomID;
                        } else {
                            _this.$toast(data.message);
                        }
                    });
                }
            },
            readyStart: function () {
                var _this = this;
                mySendMessage(mysetting.routes.updateRoom, {
                    status: 1
                }, function (data) {
                    if (data.errno == 0) {
                        _this.$set(_this.playersInfo[1], 'status', 504);
                    } else {
                        _this.$toast(data.message);
                        _this.overLeave();
                    }
                })
            },
            kickRoom: function (uid) {
                var _this = this;
                mySendMessage(mysetting.routes.kickRoom, {
                    kickUid: uid
                }, function (data) {
                    if (data.errno != 0) {
                        _this.$toast(data.message);
                    }
                })
            },//踢出房间
            clickButton: function (name, isactive) {
                if (name == 'leave' && isactive) {
                    this.returnBack();
                }
                if (name == 'huiqi' && isactive) {
                    onRegret();
                }
                if (name == 'renshu' && isactive) {
                    onGiveUp();
                }
                if (name == 'qiuhe' && isactive) {
                    onVote();
                }
                if (name == 'setting') {
                    this.popupSetting = true;
                }
            }, //点击左侧隐藏按钮（退出、认输、悔棋、求和、设置）
            scenePlay: function (s_c_body, status) {
                var _this = this;
                isVerticalReverse = 0;
                this.isplaying = true;
                this.playersInfo = s_c_body.players;
                this.dataX = [0];
                this.dataY = [0];
                if (s_c_body.moves) {
                    chessData=[];
                    var moves = [];
                    for (var i = 0; i < s_c_body.moves.length; i += 4) {
                        moves.push(s_c_body.moves.slice(i, i + 4));
                    }
                    for (var j = 0; j < moves.length; j++) {
                        var obj = {
                            id: j + 1,
                            perid: j,
                            step: status ? reverseStep(moves[j]) : moves[j],
                            index: j
                        };
                        chessData.push(obj)
                    }
                }
                if (comm.nodes){
                    if (status) {
                        comm.cMap=arrReverse(InitMap);
                        comm.init(arrReverse(InitMap));
                    }else {
                        comm.cMap=InitMap;
                        comm.init(InitMap);
                    }
                    var m = comm.parseMovesEx(chessData);
                    if (m[0]) {
                        comm.searchNodes(0);
                        if (vue.move_step) {
                            showPane(vue.move_step[0], vue.move_step[1]);
                            showLight(vue.move_step[2], vue.move_step[3]);
                        }
                    }
                }
                for (var i = 0; i < s_c_body.scores.length; i++) {
                    this.dataX[i] = i;
                    this.dataY[i] = turnScore(s_c_body.scores[i]);
                    if (i == s_c_body.scores.length - 1 && this.myChart2) {
                        this.changeToolTip(0, this.dataY.length - 1);
                    }
                }
                if (this.playersInfo[0].uid == uid) {
                    this.role = this.playersInfo[0].role;
                    this.playersInfo = this.exchangeAB(this.playersInfo);
                    this.player_times = this.exchangeAB(s_c_body.player_times);
                    this.chairId = 0;
                    this.optionInfo[1].times = s_c_body.vote_undo_last_count[0];
                    this.optionInfo[3].times = s_c_body.vote_peace_last_count[0];//悔棋求和次数
                    this.pageIndex = 1;
                } else if (this.playersInfo[1].uid == uid) {
                    this.role = this.playersInfo[1].role;
                    this.chairId = 1;
                    isVerticalReverse = 1;//black
                    this.player_times = s_c_body.player_times;
                    this.optionInfo[1].times = s_c_body.vote_undo_last_count[1];
                    this.optionInfo[3].times = s_c_body.vote_peace_last_count[1];
                    this.pageIndex = 1;
                } else {
                    this.role = 3;
                    this.playersInfo = this.exchangeAB(this.playersInfo);//黑方在上边
                    this.chairId = null;
                    this.player_times = this.exchangeAB(s_c_body.player_times);
                    this.pageIndex = 3;
                    if (this.pangguanInfos == 1) {
                        setTimeout(function () {
                            _this.initChart2();
                        }, 100);
                    }
                }
                this.player_status[0].total_time = this.player_times[0].steptimeTotal;
                this.player_status[1].total_time = this.player_times[1].steptimeTotal;
                this.current_user = s_c_body.current_user;
                initMap = board2map(s_c_body.chessid_map);
                movesIndex = s_c_body.move_chess_step;
                if (status == 1) {
                    isVerticalReverse ? isVerticalReverse = 0 : isVerticalReverse = 1;
                    initMap = arrReverse(initMap);
                    this.playersInfo = this.exchangeAB(this.playersInfo);
                    this.player_times = this.exchangeAB(this.player_times);
                    this.player_status = this.exchangeAB(this.player_status);
                }
                if (s_c_body.prevMove.from_pos) {
                    vue.move_step = s_c_body.prevMove.from_pos.x + '' + s_c_body.prevMove.from_pos.y + '' + s_c_body.prevMove.to_pos.x + '' + s_c_body.prevMove.to_pos.y;
                }
                this.player_status[0].display = false;
                this.player_status[1].display = false;
                if (isVerticalReverse == 1) {
                    vue.move_step = reverseStep(vue.move_step);
                    if (s_c_body.current_user != 0) {
                        this.player_status[1].display = true;
                        this.player_status[1].currentRate = this.player_times[1].steptime / this.player_status[1].total_time * 100;
                    } else {
                        this.player_status[0].display = true;
                        this.player_status[0].currentRate = this.player_times[0].steptime / this.player_status[0].total_time * 100;
                    }
                } else {
                    if (s_c_body.current_user == 0) {
                        this.player_status[1].display = true;
                        this.player_status[1].currentRate = this.player_times[1].steptime / this.player_status[1].total_time * 100;
                    } else {
                        this.player_status[0].display = true;
                        this.player_status[0].currentRate = this.player_times[0].steptime / this.player_status[0].total_time * 100;
                    }

                }
                this.iscontinue = true;
                this.pangguanList = s_c_body.observes;
                this.pangguanPerson = s_c_body.observesLength;
                this.initMove = s_c_body.prevMove;
                this.messageContent = s_c_body.messageContent ? s_c_body.messageContent : [];
                this.roomID = s_c_body.roomID;
                //判断是否收藏
                this.favorChess = s_c_body.isCollect;
                if (this.fileloaded) {
                    if (this.iscontinue) {
                        if (this.role == 1 || this.role == 2) {
                            this.pageIndex = 1;
                        } else {
                            this.pageIndex = 3;
                        }
                        this.iscontinue = false;
                        setTimeout(function () {
                            onGameBegin();
                        }, 10);
                    }
                } else {
                    setTimeout(function () {
                        if (!vue.fileloaded) {
                            vue.getUserInfo();
                            vue.getCommonData();
                        }
                    }, 2000)
                }
            },//所有界面的渲染入口
            prepare: function (params, status) {
                var s_c_body = params.playData;
                if (params.isplaying) {
                    waitServerPlay = false;
                    this.readyBegin.show = false;
                    this.scenePlay(s_c_body, status);
                } else {
                    this.pageIndex = 0;
                    if (!this.qipanLoading && light) hideLight();
                    if (!this.qipanLoading && box1) hidePane();
                    this.cancelTime();
                    waitServerPlay = true;
                    this.readyBegin.show = true;
                    this.role = params.role;
                    this.roomID = s_c_body.roomID;
                    this.pangguanList = s_c_body.observes;
                    this.pangguanPerson = s_c_body.observesLength;
                    if (s_c_body.creatorID != uid) {
                        this.isCreator = false
                    }
                    if (s_c_body.qsType == 3) {
                        this.isBuju = true;
                    }
                    if (params.role == 3) {
                        this.pageIndex = 3;
                        this.$set(this.playersInfo, 1, s_c_body.players[0]);
                        this.$set(this.playersInfo, 0, s_c_body.players[1]);
                    } else if (s_c_body.players[0] && s_c_body.players[0].uid == uid) {
                        this.$set(this.playersInfo, 1, s_c_body.players[0]);
                        this.$set(this.playersInfo, 0, s_c_body.players[1]);
                        s_c_body.players[0].role == 1 ? isVerticalReverse = 0 : isVerticalReverse = 1;
                    } else {
                        this.$set(this.playersInfo, 1, s_c_body.players[1]);
                        this.$set(this.playersInfo, 0, s_c_body.players[0]);
                        s_c_body.players[1].role == 1 ? isVerticalReverse = 0 : isVerticalReverse = 1;
                    }
                    initMap = board2map(s_c_body.initMap || InitFen);
                    if (this.fileloaded) {
                        comm.initChessBymap(initMap);
                    } else {
                        setTimeout(function () {
                            if (!vue.fileloaded) {
                                vue.getUserInfo();
                                vue.getCommonData();
                            }
                        }, 2000)
                    }
                    if (s_c_body.time_rule) {
                        this.readyBegin.gameTime = s_c_body.time_rule.gametime;
                        this.readyBegin.stepTime = s_c_body.time_rule.steptime;
                        this.readyBegin.addSecond = s_c_body.time_rule.addsecond;
                        this.readyBegin.readTime = s_c_body.time_rule.readtime;
                        if (this.playersInfo[0] && this.playersInfo[0].uid) this.player_times[0] = { gametime: s_c_body.time_rule.gametime }
                        if (this.playersInfo[1] && this.playersInfo[1].uid) this.player_times[1] = { gametime: s_c_body.time_rule.gametime }
                    } else {
                        if (this.isCreator) {
                            this.activeRule.show = true;
                        }
                    }
                }//加入了好友房间
            },
            rebackHall: function () {
                if (this.dialogType.lab == '对弈结果') {
                    this.resetValue();
                } else {
                    this.closePage();
                }
            },
            resetValue: function () {
                this.dialogType = dialog_default;
                this.player_times = [{}, {}];
                this.optionInfo = optionInfo;//悔棋求和次数重置
                this.popupAnalyse = false;
                this.popupButtons = false;
                this.popupSetting = false;
                this.popupPangguan = false;
                this.favorChess = false;
                this.popupInform = false;
                this.popupMessage = 0;
                this.popupGrade = false;
                this.popupGrade2 = false;
                this.shareRemind = false;
                this.imgText = 'text';
                this.message = [];
                this.messageContent = [];
                this.inputValue = '';
                this.popup_unit.show = false;
                this.isFullScreen = false;
                this.dataX = [0];
                this.dataY = [0];
                this.myChart = '';
                if (this.myChart2) {
                    this.initChart2();
                }
                this.pangguanInfos = 0;
                this.player_status = [{
                    total_time: 1200,
                    display: false,
                    currentRate: 100,
                }, {
                    total_time: 1200,
                    display: false,
                    currentRate: 100
                }];
                if (comm.nodes) {
                    comm.nodes.length = 0;
                    movesIndex = 0;
                    currentId = 0;
                }
                this.chairId = null;
                this.current_user = null;
                waitServerPlay = false;
                this.chess_move_action = chess_move_action;
                this.initMove = {};
                this.move_step = '';
                if (!!qlcp_timeer) {
                    clearInterval(qlcp_timeer);
                    qlcp_timeer = null;
                }
            },
            standUp: function () {
                var _this = this;
                mySendMessage(mysetting.routes.leaveRoom, {}, function (data) {
                    if (data.errno != 0) {
                        // vue.$toast(data.message);
                    }
                    vue.qlcp_lookon(_this.roomID, 0, 3, 1)
                })
            },
            qlcp_lookon: function (roomID, status, role, byCreator) {
                var _this = this;
                vue.roleStatus=status;
                if (roomID) {
                    mySendMessage(mysetting.routes.joinRoom, {
                        roomID: roomID,
                        role: role || null,
                        byCreator: byCreator || null
                    }, function (data) {
                        if (data.errno == 0) {
                            if (data.data.role != 3) {
                                _this.pageIndex = 0;
                            }
                            _this.pageType = data.data.roomType;
                            if (data.data.roomType == 'QS') {
                                _this.pageShareType = 'association';
                            } else {
                                _this.pageShareType = data.data.roomType;
                            }
                            _this.prepare(data.data, status);
                        } else {
                            _this.$dialog.alert({
                                title: '提醒',
                                message: data.message,
                                confirmButtonColor: '#3388ff'
                            }).then(function () {
                                _this.overLeave();
                            });
                        }
                    });
                }
            },//进入旁观，或进入房间
            overLeave: function () {
                mySendMessage(mysetting.routes.leaveRoom, {}, function (data) {
                    if (data.errno != 0) {
                        // vue.$toast(data.message);
                    }
                    vue.closePage();
                })
            },
            joinPlay: function () {
                hidePane();
                hideLight();
                mySendMessage(mysetting.routes.leaveRoom, {}, function (data) {
                    if (data.errno != 0) {
                        // vue.$toast(data.message);
                    }
                    vue.qlcp_lookon(vue.roomID, 0, null, 1);
                })
            },
            rebackRoom: function () {
                var _this = this;
                this.pageIndex = 0;
                hidePane();
                hideLight();
                mySendMessage(mysetting.routes.getPlayData, {}, function (data) {
                    if (data.errno == 0) {
                        _this.prepare(data.data);
                    } else {
                        _this.$toast(data.message);
                    }
                })
            },
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    this.fileloaded = true;
                    this.qipanLoading = false;
                    this.defaultImg = default_img;
                    initLayer(evt);
                    if (api.pageParam.showLoading) {
                        this.$toast.clear();
                    }
                    initMap.length == 0 ? initMap = comm.clone(InitMap) : initMap;
                    initialization(evt);
                    waitServerPlay = true;
                    if (this.iscontinue) {
                        this.iscontinue = false;
                        if (this.roomID && this.pageIndex == 0) {
                            this.qlcp_lookon(this.roomID, api.pageParam.role, null, this.byCreator);
                        }
                        onGameBegin()
                    }
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            },
            onChessGuide:function () {
                vue.openPage('chess/chess_guide', { role: vue.roleStatus });
            }
        },
        filters: {
            formatTime: function (time) {
                if (time >= 60) {
                    return (parseInt(time / 60) + '分钟')
                } else {
                    return (parseInt(time) + '秒');
                }
            }
        }
    });
}