apiready = function () {
    id = api.pageParam.id;
    fs = api.require('fs');
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            isBuy: -1,
            list: [],//课程章节列表

            selectNum: 0,
            selectSize: 0,
            freedisk: 0,
            totaldisk: 0,
            allSelect: false,
            downingLength: 0
        },
        created: function () {
            this.$toast.loading('加载中...');
            this.initDownloadListener();
            this.init();
            this.getUserInfo();
        },
        methods: {
            init: function () {
                this.ajaxPost(xqwxt_url + '&do=lesson&op=isBuy', {
                    id: id
                }, function (vm, ret) {
                    vm.isBuy = ret.data.isBuy;
                    if (ret.data.isBuy) {
                        vm.getList()
                    } else {
                        vm.closePage();
                    }
                });
            },
            getList: function () {
                this.ajaxPost(xqwxt_url + '&do=lesson&op=getCatalogList', {
                    isAll: 1,
                    id: id,
                    page: this.pageIndex
                }, function (vm, ret) {
                    if (ret && ret.data) {
                        vm.list = ret.data;
                        vm.allSelect = false;
                        vm.initDown();
                    }
                });
            },
            selectAll: function () {
                var vm = this;
                this.allSelect = !this.allSelect;
                this.selectNum = 0;
                this.selectSize = 0;
                var temp2 = new Array;
                Object.assign(temp2, vm.list);
                for (var i = 0; i < vm.list.length; i++) {
                    if (vm.list[i]['section'] && vm.list[i]['section'].length) {
                        var temp = new Array;
                        Object.assign(temp, vm.list[i].section);
                        for (var k = 0; k < vm.list[i].section.length; k++) {
                            if (vm.list[i].section[k].status == -1) {
                                temp[k].isSelect = vm.allSelect ? true : false;
                                if (this.allSelect) {
                                    this.selectNum++;
                                    this.selectSize += Number(vm.list[i].section[k].videosize);
                                }
                            }
                        }
                        temp2[i].section = temp;
                    }
                }
                this.list = temp2;
            },
            selectOne: function (i, k) {
                if (this.list[i].section[k].status != -1) return;
                var temp2 = new Array;
                Object.assign(temp2, this.list);
                var temp = new Array;
                Object.assign(temp, this.list[i].section);
                temp[k].isSelect = !this.list[i].section[k].isSelect;
                if (temp[k].isSelect) {
                    this.selectNum++;
                    this.selectSize += Number(this.list[i].section[k].videosize);
                } else {
                    this.allSelect = false;
                    this.selectNum--;
                    this.selectSize -= Number(this.list[i].section[k].videosize);
                }
                temp2[i].section = temp;
                this.list = temp2;
            },
            initDown: function () {
                var vm = this;
                var downing = $download.select({
                    uid: uid,
                    status: 0
                }, "*", " ORDER BY displayorder DESC");
                vm.downingLength = downing.length;
                if (vm.list && vm.list.length) {
                    var temp2 = new Array;
                    Object.assign(temp2, vm.list);
                    for (var i = 0; i < vm.list.length; i++) {
                        if (vm.list[i]['section'] && vm.list[i]['section'].length) {
                            var temp = new Array;
                            Object.assign(temp, vm.list[i].section);
                            for (var k = 0; k < vm.list[i].section.length; k++) {
                                if (vm.list[i]['section'][k].tid == 0) {
                                    var params = {
                                        uid: uid,
                                        pid: id,
                                        sid: vm.list[i]['section'][k].id
                                    }
                                    var result = $download.select(params, '*');
                                    if (result && result[0]) {
                                        temp[k].status = result[0]['status'];
                                        temp[k].is_cancel = result[0]['is_cancel'];
                                        temp[k].isSelect = true;
                                    } else {
                                        temp[k].status = -1;
                                        temp[k].isSelect ? '' : temp[k].isSelect = false;
                                    }
                                }
                            }
                            temp2[i].section = temp;
                        }
                    }
                    vm.list = temp2;
                }
                vm.getDisk();
                vm.$toast.clear();
            },
            initDownloadListener: function () {
                var vm = this;
                api.addEventListener({
                    name: 'lessonDowned'
                }, function (ret, err) {
                    if (ret && ret.value) {
                        vm.initDown();
                    }
                });
                api.addEventListener({
                    name: 'downRemoved'
                }, function (ret, err) {
                    if (ret) {
                        vm.initDown();
                        vm.$toast.success({
                            duration: 1000,
                            message: '删除成功',
                            forbidClick: true
                        });
                    }
                });
                api.addEventListener({
                    name: 'downFaild'
                }, function (ret, err) {
                    if (ret) {
                        vue.initDown();
                    }
                });
            },
            addDown: function () {
                var vm = this;
                if (this.selectNum == 0) return;
                this.setPermission(function (param) {
                    if (param) {
                        vm.judgeDownload();
                    } else {
                        vm.$toast('无法获得存储权限，请在设置中打开应用的存储权限');
                    }
                });
            },
            judgeDownload: function () {
                var vm = this;
                var downAdd = [];
                var flag_result=false;
                vm.isdown(function (result) {
                    if (result) {
                        if (vm.selectSize >= vm.freedisk * 1024) {
                            vm.$toast('手机空间不足以下载所选章节');
                        } else {
                            vm.$toast.loading({
                                duration: 0,
                                message: '添加下载中',
                                forbidClick: true
                            })
                            if (vm.list && vm.list.length) {
                                for (var i = 0; i < vm.list.length; i++) {
                                    if (vm.list[i]['section'] && vm.list[i]['section'].length) {
                                        for (var k = 0; k < vm.list[i].section.length; k++) {
                                            if (vm.list[i]['section'][k].tid == 0 && vm.list[i]['section'][k].status == -1 && vm.list[i]['section'][k].isSelect) {
                                                var cindex = i;
                                                var sindex = k;
                                                var params = {
                                                    uid: uid,
                                                    pid: id,
                                                    sid: vm.list[cindex]['section'][sindex].id
                                                }
                                                var result = $download.select(params, '*');
                                                if (result && result[0] && result[0].status == 0) {
                                                    var spercent = parseInt(result[0].percent);
                                                } else {
                                                    var spercent = 0;
                                                }
                                                if (localStorage.getItem(id + '_lessoninfo')) {
                                                    var lessoninfo = JSON.parse(localStorage.getItem(id + '_lessoninfo'));
                                                } else {
                                                    var lessoninfo = '';
                                                }
                                                var downinfo = {
                                                    uid: uid,
                                                    savePath: 'fs://mydownloads/' + id + '/' + id + '_' + vm.list[cindex]['section'][sindex].id + '.mp4',
                                                    stitle: vm.list[cindex]['section'][sindex].title,
                                                    videosize: vm.list[cindex]['section'][sindex].videosize,
                                                    pid: id,
                                                    ptitle: lessoninfo['bookname'],
                                                    pimage: lessoninfo['images'],
                                                    sid: vm.list[cindex]['section'][sindex].id,
                                                    videourl: vm.list[cindex]['section'][sindex].videourl,
                                                    is_free: vm.list[cindex]['section'][sindex].is_free,
                                                    percent: spercent,
                                                    status: 0,
                                                    is_cancel: 0,
                                                    displayorder: vm.list[cindex]['section'][sindex].displayorder,
                                                }
                                                downAdd.push(downinfo);
                                                flag_result = $download.insert_update(downinfo);
                                            }
                                        }
                                    }
                                }
                                if (flag_result) {
                                    vm.selectNum = 0;
                                    vm.selectSize = 0;
                                   // vm.initDown();
                                    vm.$toast.success({
                                        duration: 1000,
                                        message: '添加下载成功',
                                        forbidClick: true
                                    });
                                    api.sendEvent({
                                        name: 'addDownSuccess'
                                    })
                                    api.sendEvent({
                                        name: 'addDown',
                                        extra: JSON.stringify(downAdd)
                                    });
                                } else {
                                    vm.$toast('数据库写入错误，请关闭页面重试');
                                }
                            }
                        }
                    }
                })
            },
            isdown: function (fun) {
                var vm = this;
                var down = vm.self_setting.wifi_download;
                if ((api.connectionType == '2g' || api.connectionType == '3g' || api.connectionType == '4g' || api.connectionType == '5g' ||
                    api.connectionType == '2G' || api.connectionType == '3G' || api.connectionType == '4G' || api.connectionType == '5G') && down) {
                    vm.$dialog.confirm({
                        message: '您当前是' + api.connectionType + '网络,下载视频要消耗流量,确认下载吗?',
                        confirmButtonText: '确认下载',
                        confirmButtonColor: '#3388ff',
                        cancelButtonColor: '#666666'
                    }).then(function () {
                        fun(true);
                    }).catch(function () {
                        fun(false);
                    });
                } else {
                    fun(true);
                }
            },
            getDisk: function () {
                this.freedisk = Number(api.getFreeDiskSpace({
                    sync: true
                }) / (1024 * 1024 * 1024)).toFixed(2);
                this.totaldisk = Number(api.getTotalSpace({
                    sync: true
                }) / (1024 * 1024 * 1024)).toFixed(1);
            }
        }
    })
};