apiready = function () {
    mypomelo = api.require('mypomelo');

    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            pageType: 'rank',
            pageShareType: 'paihang_qlcp',
            title: ['全国', '省', '市'],
            loading: [false, false, false],
            finished: [false, false, false],
            pageIndex: [1, 1, 1],
            list: [[], [], []],
            paiming: {},
            weimian: {},
            isAI: false,
            isWeimian: false,
            weimianRule: false
        },
        created: function () {
            this.isAI = api.pageParam.isAI;
            this.isWeimian = api.pageParam.isWeimian;
            if (this.isAI) this.pageShareType = 'paihang_ai';
            if (this.isWeimian) this.title = ['卫冕分日榜', '卫冕分总榜'];
            this.initData();
        },
        methods: {
            initData: function () {
                var _this = this;
                var type = 1;
                if (this.isAI) type = 2;
                if (this.isWeimian) type = 3;
                mySendMessage(mysetting.routes.geSelfRank, {
                    type: type
                }, function (ret) {
                    if (ret.errno == 0) {
                        _this.paiming = ret.data;
                        _this.weimian = ret.data;
                    } else {
                        _this.$toast(ret.message);
                    }
                });
            },
            getList: function (index) {
                var vm = this;
                mySendMessage(mysetting.routes.getPaihangList, {
                    paihangType: vm.isWeimian ? (index == 0 ? 'today' : 'winscore') : '',
                    page: vm.pageIndex[index],
                    type: index + 1,
                    AI: vm.isAI || 0
                }, function (data) {
                    if (data.errno == 0) {
                        if (vm.pageIndex[index] == 1) {
                            vm.$set(vm.list, index, []);
                        }
                        for (var i = 0; i < data.data.length; i++) {
                            vm.list[index].push(data.data[i]);
                        }
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, false);
                        vm.pageIndex[index]++;
                    } else {
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, true);
                    }
                })

            }
        },
    });
}