var CDN_PATH = '../../';
var soundPlayer = '';
var mixin_chess = {
    data: function () {
        return {
            gameResult: false,
            gameWin: false,
            gameLose: false,
            gameChecked: false,
            gameEat: false,
            gameError: false,
            gameStalemate: false,
            gameCheckmate: false,//页面效果：吃将杀等
            qipanLoading: true,
            leftBtn: false,//最左侧上拉菜单
            soundTog: true,//棋谱音效（开关）
            rightBtn: false,//最右侧上拉菜单
            temp_url: CDN_PATH + 'assets/audio/',
            sound_type: 'man',
            soundList: [
                { id: 'select', src: 'select.mp3' },
                { id: 'drop', src: 'drop.mp3' },
                { id: 'gameWin', src: 'gameWin.mp3', type: 1 },
                { id: 'gameLose', src: 'gameLose.mp3', type: 1 },
                { id: 'gameEat', src: 'gameEat.mp3', type: 1 },
                { id: 'gameError', src: 'gameError.mp3', type: 1 },
                { id: 'gameChecked', src: 'gameChecked.mp3', type: 1 },
                { id: 'gameStalemate', src: 'gameStalemate.mp3', type: 1 },
                { id: 'gameCheckmate', src: 'gameCheckmate.mp3', type: 1 },
            ],
            // howlerList: {},
            screenWidth: '',
            screenHeight: '',
            chessWidth: '84%',
            boxHeight: 254,
            navBtn: false,
            toastValue: '测试',
            toastShow: false,
            setBtn: false,
            showSituation: false,//收藏里导入fen
            showFen: false,//输入fen
            fenValue: '',
            situationList: [],
            loading: false,
            finished: false,
            pageIndex: 1,
        }
    },
    created: function () {
        soundPlayer = api.require('audioStreamer');
        this.getUserInfo();
        this.resizeS();
        var _this = this;
        window.onresize = function () {
            _this.resizeS();
        }
    },
    watch: {
        memberinfo: function (val, oldVal) {
            if (val.uid != oldVal.uid) {
                if (this.memberinfo.gender == 2) {
                    this.sound_type = 'woman';
                }
                // for (var i = 0; i < this.soundList.length; i++) {
                //     if (!this.soundList[i].type) {
                //         this.howlerList[this.soundList[i].id] = new Howl({
                //             src: [this.temp_url + this.soundList[i].src]
                //         });
                //     }
                // }
                this.initValue();
            }
        }
    },
    methods: {
        getSituationList: function () {
            var vm = this;
            this.loading = true;
            mySendMessage(mysetting.routes.getCollects, {
                type: 'fen',
                page: this.pageIndex,
                psize: 8
            }, function (data) {
                if (data.errno == 0) {
                    for (var i = 0; i < data.data.length; i++) {
                        var item = data.data[i];
                        if (item.reverse) {
                            initialization(vm.target, 'tempCanvas', arrReverse(board2map(item.fen, 1)), '', 1);
                        } else {
                            initialization(vm.target, 'tempCanvas', board2map(item.fen, 1), '', '');
                        }
                        vm.$refs['tempCanvas'].width = 72 * 5;
                        vm.$refs['tempCanvas'].height = 83 * 5;
                        stage2.scaleX = stage2.scaleY = 0.5;
                        stage2.update();
                        data.data[i].src = stage2.toDataURL();
                        vm.situationList.push(data.data[i]);
                    }
                    vm.loading = false;
                    vm.finished = false;
                    vm.pageIndex++;
                } else {
                    vm.loading = false;
                    vm.finished = true;
                }
            })
        },
        importFrom: function () {
            this.setBtn = false;
            this.situationList = [];
            this.pageIndex = 1;
            this.loading = false;
            this.finished = false;
            this.showSituation = true;
            this.getSituationList();
        },
        importFen: function (item) {
            this.showSituation = false;
            canvas2 = '';
            if (stage2) stage2.removeAllChildren();
            var fen = item && item.fen ? item.fen : this.fenValue;
            if (comm.VerifyFEN(fen)) {
                cleanChess();
                cleanChessEx();
                if (fen.indexOf('w') == -1) {
                    comm.isOffensive = 1;
                    vue.isOffensive = 1;
                } else {
                    comm.isOffensive = 0;
                    vue.isOffensive = 0;
                }
                comm.map = initMap = board2map(fen);
                comm.cMap = comm.arr2Clone(comm.map);
                comm.init(comm.map, !0);
                onEditboard();
                if (item && item.reverse != isVerticalReverse) {
                    onReverse();
                }
            } else {
                this.$toast('fen数据不合法')
            }
            this.fenValue = '';
        },
        onSound: function () {
            onSound(); //棋谱音效
            mySendMessage(mysetting.routes.updateSetting, {
                type: 'sound',
                value: this.soundTog ? 1 : 0
            }, function (data) {
                if (data.errno != 0) {
                    vue.$toast(data.message);
                }
            })
        },
        onReplayFirst: function () {
            this.navBtn = false;
            onReplayFirst(); //回到初始局面
        },
        onChessRegret: function () {
            onChessRegret();
        },
        onReplayPrev: function () {
            if ((mode == playmode.CHESSANALYSE && this.tabActive == 1) || (mode == playmode.ANALYSE && this.currentAnalyseData.show)) {
                this.rebackCurrent();
            }
            if (mode == playmode.REPLAY) {
                if (this.autoReplay == 1) {
                    if (autoreplayset) clearInterval(autoreplayset);
                    autoreplayset = 0;
                    this.autoReplay = 0;
                    return;
                }
            }
            onReplayPrev(); //上一步
        },
        onReplayNext: function () {
            if ((mode == playmode.CHESSANALYSE && this.tabActive == 1) || (mode == playmode.ANALYSE && this.currentAnalyseData.show)) {
                this.rebackCurrent();
            }
            if (mode == playmode.REPLAY) {
                if (this.autoReplay == 1) {
                    if (autoreplayset) clearInterval(autoreplayset);
                    autoreplayset = 0;
                    this.autoReplay = 0;
                }
            }
            onReplayNext(); //下一步
        },
        onReplayEnd: function () {
            this.navBtn = false;
            onReplayEnd(); //回到最后一步局面
        },
        onOffensive: function () {
            onOffensive(); //黑方先手
        },
        onAnalyse: function () {
            onAnalyse(); //分析模式
        },
        onRedPlay: function () {
            onRedPlay(); //电脑执红
        },
        onBluePlay: function () {
            onBluePlay(); //电脑执黑
        },
        onReverse: function () {
            onReverse(); //翻转棋盘
            this.$forceUpdate();
        },
        initValue: function () {
            this.soundTog = this.self_setting.sound == 1 ? true : false;
            this.self_setting.sound == 1 ? voicemode = 1 : voicemode = 0;
        },
        resizeS: function () {
            var _this = this;
            this.screenWidth = document.body.clientWidth > 768 ? 768 : document.body.clientWidth;
            this.screenHeight = document.body.clientHeight - this.fixBar - this.fixBottom;
            if (this.pageType == 'chess') {
                if (this.screenHeight - 96 > 83 / 72 * this.screenWidth + 80) {
                    this.chessWidth = this.screenWidth;
                } else {
                    this.chessWidth = (this.screenHeight - 96 - 80) / 83 * 72;
                }
            } else if (this.infoShow && this.pageType == 'create') {
                if (this.screenHeight - 83 / 72 * this.screenWidth > this.screenWidth * 0.3) {
                    this.boxHeight = this.screenHeight - 83 / 72 * this.screenWidth;
                    this.chessWidth = this.screenWidth;
                } else {
                    this.boxHeight = this.screenWidth * 0.3;
                    this.chessWidth = (this.screenHeight - this.screenWidth * 0.3) / 83 * 72;
                }
            } else if (this.infoShow && this.pageType != 'man_machine' && this.pageType != 'create') {
                if (this.screenHeight - 83 / 72 * this.screenWidth * 0.84 > this.screenWidth * 0.3) {
                    if (this.pageType == 'tree') {
                        this.boxHeight = this.screenHeight - 83 / 72 * this.screenWidth * 0.84 - 46;
                    } else {
                        this.boxHeight = this.screenHeight - 83 / 72 * this.screenWidth * 0.84;
                    }
                    this.chessWidth = this.screenWidth * 0.84;
                } else {
                    this.boxHeight = this.screenWidth * 0.3;
                    this.chessWidth = (this.screenHeight - this.screenWidth * 0.3) / 83 * 72;
                }
            } else {
                if (this.screenHeight - 50 > 102 / 72 * this.screenWidth) {
                    this.chessWidth = this.screenWidth;
                    this.boxHeight = this.screenHeight - 50 - 102 / 72 * this.screenWidth;
                } else {
                    this.chessWidth = (this.screenHeight - 50) / 102 * 72;
                    this.boxHeight = 0;
                }
            }
            if (this.myChart) {
                setTimeout(function () {
                    _this.myChart.resize();
                }, 30)
            }
        }, //页面尺寸变化函数
        init: function () {
            var loader = new createjs.LoadQueue(false);
            // loader.installPlugin(createjs.Sound);
            loader.on("fileload", this.handleFileLoad);
            loader.on("error", this.handleError);
            loader.on("complete", this.handleComplete);
            loader.loadFile({ src: CDN_PATH + "script/util/ZobristTable.js" });
            loader.loadFile({ src: CDN_PATH + "script/lib/echarts.min.js?version=512" });
            loader.loadFile({ src: CDN_PATH + "script/lib/easeljs.min.js", id: 'Easeljs' });
            loader.loadFile({ src: CDN_PATH + "script/lib/tweenjs.min.js" });
            loader.loadFile({ src: CDN_PATH + "script/lib/MovieClip.js" });
            // loader.loadFile({ src: "../../script/lib/soundjs.min.js" });
            loader.loadFile({ src: CDN_PATH + "script/Model.js?version=618" });
            loader.loadFile({ src: CDN_PATH + "script/View.js?version=6181" });
            loader.loadFile({ src: CDN_PATH + "script/Control.js" });
            loader.loadFile({ src: CDN_PATH + "script/Control_chess.js?version=618" });
            loader.loadFile({ src: CDN_PATH + "script/Player.js?version=618" });
            loader.loadFile({ src: CDN_PATH + "script/Chess.js?version=618" });
            loader.loadFile({ src: CDN_PATH + "script/lib/gameRes.js" });
            loader.loadManifest([
                { src: CDN_PATH + "assets/images/board.png", id: "Board", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/tips.png", id: "Loading", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/che.png", id: "che", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/pao.png", id: "pao", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/ma.png", id: "ma", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/black_jiang.png", id: "blackJiang", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/black_shi.png", id: "blackShi", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/black_xiang.png", id: "blackXiang", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/black_zu.png", id: "blackZu", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/red_bing.png", id: "redBing", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/red_shi.png", id: "redShi", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/red_shuai.png", id: "redShuai", loadTimeout: 20000 },
                { src: CDN_PATH + "assets/images/red_xiang.png", id: "redXiang", loadTimeout: 20000 },
            ]);
        }, //初始化页面吗，加载资源
        handleError: function (evt) {
            this.$toast('chess preload error');
        },
        handleFileLoad: function (evt) {
            if (evt.item.type == "image") {
                images[evt.item.id] = evt.result;
            }
            if (evt.item.id == 'Easeljs') {
                chessList = new createjs.SpriteSheet(CHESS_SLIM);
                effectList = new createjs.SpriteSheet(F_ATLAS);
            }
        },
        handleComplete: function (evt) {
            if (chessList.complete && effectList.complete) {
                this.qipanLoading = false;
                initLayer(evt);
            } else {
                chessList.addEventListener("complete", function () {
                    vue.handleComplete();
                });
                effectList.addEventListener("complete", function () {
                    vue.handleComplete();
                });
            }
        }
    }
}
