function mySendMessage(route, message, cb) {
    if (api.connectionType == 'none') {
        cb({ errno: 404, message: '网络连接断开，请检查网络设置' });
        if (typeof vue === "object") vue.$toast('网络连接断开，请检查网络设置');
        return;
    }
    if (api.getGlobalData({ key: 'connected' })) {
        message.uniacid = 5;
        message.platform = 'APP';
        // message.isProduction = 1;//设置为测试环境，上线请关闭
        mypomelo.sendMessage({
            route: route,
            data: message
        }, function (data) {
            if (data.errno) {
                mypomelo.disconnect();
                api.execScript({
                    name: 'root',
                    script: 'loginGame()'
                });
            } else {
                data = data.data;
                if (data.errno == 60000) {
                    api.execScript({
                        name: 'root',
                        script: 'initPage()'
                    });
                } else if (data.errno == 70000) {
                    api.sendEvent({
                        name: 'rebootApp'
                    });
                    api.rebootApp();
                } else {
                    cb(data);
                }
            }
        });
    } else {
        api.execScript({
            name: 'root',
            script: 'loginGame()'
        });
    }
}
function re_login() {
    vue.dialogType = dialog_default;
    api.sendEvent({
        name: 'initIndexPage'
    });
}
function onKeyBoardChanged(isShow, height) {
    if (isShow == 1) {
        if (api.systemType == 'ios') {
            vue.keybordH = height - vue.fixBottom;
            if (api.frameName == 'play_chess/qlcp' || api.frameName == 'play_chess/create_room' || api.frameName == 'play_chess/ai_test') {
                vue.keybordH = height;
            }
            api.setFrameAttr({
                name: api.frameName,
                scrollEnabled: false
            });
        } else {
            vue.keybordH = height / (api.screenWidth / api.winWidth);
        }
        vue.keybordShow = true;
    } else if (isShow == 0) {
        vue.keybordH = 0;
        vue.keybordShow = false;
        if (api.systemType == 'ios') {
            api.setFrameAttr({
                name: api.frameName,
                scrollEnabled: true
            });
            if (api.frameName == 'lesson/lesson_detail') {
                if (vue.$refs.commentField) vue.$refs.commentField.blur()
                if (vue.$refs.replyField) vue.$refs.replyField.blur()
                if (vue.commentInput.showOverlay) {
                    vue.commentInput.showOverlay = false;
                }
                if (vue.replyInput.show) {
                    vue.replyInput.show = false;
                    vue.replyInput.showOverlay = false;
                }
            } else {
                if (vue.$refs.inputBox) {
                    vue.$refs.inputBox.blur()
                } else if (document.getElementsByTagName('input')[0]) {
                    document.getElementsByTagName('input')[0].blur();
                }
                if (api.frameName == 'lesson/lesson_comment') {
                    if (vue.replyInput.showOverlay) vue.replyInput.showOverlay = false;
                }
            }
        }
    }
}
getSignUrl = function (params, token) {
    var url = params;
    token = (token || '');
    if (localStorage.getItem('userinfo')) {
        var userinfo = JSON.parse(localStorage.getItem('userinfo'));
    } else {
        var userinfo = '';
    }
    if (params.indexOf('?') != -1) {
        params = params.split('?')[1];
    }

    if (typeof params == "string") {
        if (userinfo && userinfo.usertype) {
            return url + '&appKey=cfylovelhj1314&login=' + userinfo.usertype + '&sign=' + paramsStrSort(params, token);
        } else {
            return url + '&appKey=cfylovelhj1314&sign=' + paramsStrSort(params, token);
        }

    } else if (typeof params == "object") {
        var arr = [];
        for (var i = 0; i < params.length; i++) {
            arr.push((i + "=" + params[i]));
        }
        if (userinfo && userinfo.usertype) {
            return url + '&appKey=cfylovelhj1314&login=' + userinfo.usertype + '&sign=' + paramsStrSort(arr.join("&"), token);
        } else {
            return url + '&appKey=cfylovelhj1314&sign=' + paramsStrSort(arr.join("&"), token);
        }

    }

}

paramsStrSort = function (paramsStr, token) {
    if (localStorage.getItem('userinfo')) {
        var userinfo = JSON.parse(localStorage.getItem('userinfo'));
    } else {
        var userinfo = '';
    }
    if (userinfo && userinfo.usertype) {
        var url = paramsStr + '&appKey=cfylovelhj1314&login=' + userinfo.usertype;
    } else {
        var url = paramsStr + '&appKey=cfylovelhj1314';
    }

    var urlStr = url.split("&").sort().join("&");
    var newUrl = urlStr + "&xqwxtcfylhj1314";
    if (token != '') {
        newUrl = urlStr + '&xqwxtcfylhj1314' + '&token=' + token;
    }

    return hex_md5(newUrl);
}

var uid = '';
var xqwxt_url = '';
var CDN_PATH = "../../";
var defaultAvatar = '../../assets/images/headimg.png';
var nullAvatar = '../../assets/images/null_headimg.png';
var mixin = {
    data: function () {
        return {
            pageType: 'saunter',
            pageShareType: '',
            popupInform: false,
            popupGrade: false,
            popupGrade2: false,
            clickplayerinfo: '',
            sendBook: false,
            sendBookId: '',
            getBook: false,
            getBookInfo: {
                uid: '',
                nickname: '',
                headimg: '',
                time: 5
            },
            dialogType: dialog_default,
            popup_unit: {
                show: false,
                text: '',
                loading: false
            },
            shareRemind: false,
            light_yellow: '#E8C191',
            deep_yellow: '#5A422B',
            theme_yellow: '#a86f41',
            theme_blue: '#3388ff',
            /*app新增*/
            strengthList: [],
            integralList: [],
            engineList: [],
            uid: '',
            memberinfo: {
                uid: ''
            },
            fixBar: api.safeArea.top - 1,
            fixBottom: api.safeArea.bottom,
            keybordH: 0,
            keybordShow: false,
            setTimer: '',
            shareChessid: '',
            sharePlayerid: '',
            shareNumbers: '',
            commonRule: [],
            self_setting: '',
            noListener: true,
            hideInfo: false
            /*app新增*/
        }
    },
    created: function () {
        var _this = this;
        this.hideInfo = api.getGlobalData({ key: 'hideInfo' });
        if (this.noListener && api.getGlobalData({ key: 'connected' })) {
            this.initEventListener();
        }
        this.initDefaultData();
        // var umAnalytics = api.require('umAnalytics');
        // umAnalytics.init({
        //     debugMode: true
        // });
        // umAnalytics.onPageStart({
        //     pageName: api.frameName,
        // });
        var keyBoardMgr = api.require("keyBoardMgr");
        keyBoardMgr.addKBListener(function (ret, err) { });
        api.addEventListener({
            name: 'myKeyback'
        }, function (ret, err) {
            if (ret.value.name == api.winName) {
                if (_this.dialogType == dialog_login) return;
                if (api.winName == 'play_chess/qlcp' || api.winName == 'play_chess/ai_test' || api.winName == 'play_chess/create_room') {
                    _this.returnBack();
                } else {
                    var commentPageShow = api.getGlobalData({
                        key: 'commentPageShow'
                    });
                    if (api.winName == 'chess/ai' || api.winName == 'chess/analyse' || api.winName == 'chess/chess') {
                        _this.onSelect(0);
                    } else if (api.winName == 'data/search' && !_this.searchShow) {
                        _this.searchShow = true;
                    } else if (api.winName == 'message/chat_detail' && _this.showBigImg) {
                        _this.showBigImg = false;
                    } else if (api.winName == 'center/download_detail' && _this.currSectionId) {
                        oxPlayer.exitFullScreen();
                        recordPlayPosition();
                        oxPlayer.remove();
                        _this.currSectionId = '';
                    } else if (api.winName == 'lesson/lesson_detail' && _this.currSectionId && !commentPageShow) {
                        recordPlayPosition();
                        oxPlayer.remove();
                        _this.closePage();
                    } else if ((api.winName == 'lesson/lesson_detail' || api.winName == 'message/action') && commentPageShow) {
                        api.sendEvent({
                            name: 'commentPageShow',
                            extra: { show: false }
                        });
                        api.setGlobalData({
                            key: 'commentPageShow',
                            value: false
                        });
                        api.closeFrame({
                            name: 'lesson/lesson_comment'
                        });
                    } else {
                        _this.closePage();
                    }
                }
            }
        });
        api.addEventListener({
            name: 'hasNet'
        }, function (ret, err) {
            _this.initDefaultData();
        });
        if (!Object.assign) {
            Object.defineProperty(Object, "assign", {
                enumerable: false,
                configurable: true,
                writable: true,
                value: function (target, firstSource) {
                    "use strict";
                    if (target === undefined || target === null)
                        throw new TypeError("Cannot convert first argument to object");
                    var to = Object(target);
                    for (var i = 1; i < arguments.length; i++) {
                        var nextSource = arguments[i];
                        if (nextSource === undefined || nextSource === null) continue;
                        var keysArray = Object.keys(Object(nextSource));
                        for (var nextIndex = 0, len = keysArray.length; nextIndex < len; nextIndex++) {
                            var nextKey = keysArray[nextIndex];
                            var desc = Object.getOwnPropertyDescriptor(nextSource, nextKey);
                            if (desc !== undefined && desc.enumerable) to[nextKey] = nextSource[nextKey];
                        }
                    }
                    return to;
                }
            });
        }
    },
    filters: {
        filterTime: function (timestamp, format) {
            format = format || 'YYYY-MM-DD HH:mm';
            return moment(timestamp * 1000).format(format);
        }
    },
    methods: {
        initDefaultData: function () {
            uid = localStorage.getItem('userinfo') ? JSON.parse(localStorage.getItem('userinfo')).uid : '';
            this.uid = uid;
            var originuid = localStorage.getItem('userinfo') ? JSON.parse(localStorage.getItem('userinfo')).originuid : '';
            xqwxt_url = api.getGlobalData({ key: 'lesson_url' }) + '&appuid=' + uid + '&originuid=' + originuid;
            if (api.pageParam.showLoading) {
                this.$toast.loading({
                    duration: 0,
                    forbidClick: true,
                    message: '正在同步局面',
                    loadingType: 'spinner'
                });
            }
            if (api.pageParam.roomID) {
                this.roomID = api.pageParam.roomID;
            }
            if (api.pageParam.byCreator) {
                this.byCreator = api.pageParam.byCreator;
            }
            this.getCommonData();
        },
        initEventListener: function () {
            if (api.connectionType == 'none') return;
            if (!api.getGlobalData({ key: "connected" })) {
                api.execScript({
                    name: 'root',
                    script: 'loginGame()'
                });
                return;
            }
            this.noListener = false;
            if (this.pageType == 'qlcp' || this.pageType == 'QS' || this.pageType == 'hydz' || this.pageType == 'AI'|| this.pageType == 'chess_guide') {
                onQlcpListener();
            } else if (this.pageType == 'analyse' || this.pageType == 'man_machine' || this.pageType == 'practice' || this.pageType == 'create') {
                onAnalyseListener();
            } else if (api.frameName == 'message/chat_detail') {
                onMessageListener();
            } else {
                onCommonListener();
            }
        },
        getUserInfo: function () {
            var _this = this;
            mySendMessage(mysetting.routes.getCommonData, {}, function (data) {
                if (data.errno == 0) {
                    _this.memberinfo = data.data.member_info;
                    _this.self_setting = data.data.self_setting;
                } else {
                    _this.$toast(data.message);
                }
            });
        },
        getCommonData: function (reload) {
            var _this = this;
            if (!reload && localStorage.getItem('commonData')) {
                var ret = {};
                ret.data = JSON.parse(localStorage.getItem('commonData'));
                _this.strengthList = ret.data.strengthList;
                _this.integralList = ret.data.integralList;
                _this.engineList = ret.data.engineList;
                if (_this.pageType == 'qlcp' || _this.pageType == 'QS' || _this.pageType == 'hydz' || _this.pageType == 'AI') {
                    _this.commonRule = ret.data.rule;
                    _this.initData();
                }
            } else {
                this.ajaxPost(xqwxt_url + "&do=common&op=initChessData", {}, function (vm, ret) {
                    localStorage.setItem('commonData', JSON.stringify(ret.data));
                    vm.getCommonData(false);
                })
            }
        },
        // loadScript: function () {
        //     var scriptList = ['lib/echarts.min.js'];
        //     for (var i = 0; i < scriptList.length; i++) {
        //         var temp_tag = document.createElement('script');
        //         temp_tag.type = 'text/javascript';
        //         temp_tag.async = true;
        //         temp_tag.src = '../../script/' + scriptList[i];
        //         var head = document.getElementsByTagName('head')[0];
        //         head.appendChild(temp_tag);
        //     }
        // },
        onClickLeft: function () {
            this.closePage()
        },
        openPage: function (url, params) {
            if (!url) {
                this.$toast('功能暂未开放');
                return;
            }
            if (api.frameName == 'play_chess/association_detail') {
                this.closeInter();
            }
            if (this.mySwiper) {
                this.mySwiper.autoplay.stop();
            }
            closeEventListener();
            if (url == 'play_chess/qlcp' || url == 'play_chess/ai_test' || url == 'play_chess/create_room') {
                var params = params || {};
                params.reload = true;
            }
            api.openTabLayout({
                slidBackType: 'edge',
                name: url,
                url: '../../html/_header.html',
                pageParam: params,
                hideHomeIndicator: true,
                reload: params && params.reload ? true : false,
            });
        },
        closePage: function (name, duration) {
            // var umAnalytics = api.require('umAnalytics');
            // umAnalytics.onPageEnd({
            //     pageName: name || api.frameName,
            // });
            if (name) {
                if (duration) {
                    api.closeWin({
                        name: name,
                        animation: {
                            type: "push",
                            duration: 20
                        }
                    });
                } else {
                    api.closeWin({
                        name: name,
                    })
                }
            } else {
                api.closeWin();
            }
        },
        showInfo: function (_uid) {
            if (this.hideInfo) {
                return;
            }
            if (!parseInt(_uid)) {
                // this.$toast('无用户信息');
                return;
            }
            if (api.frameName == 'play_chess/qlcp' || api.frameName == 'play_chess/ai_test' || api.frameName == 'play_chess/create_room') {
                var _this = this;
                _this.popupInform = true;
                _this.clickplayerinfo = '';
                mySendMessage(mysetting.routes.getMemberInfo, {
                    uid: _uid
                }, function (data) {
                    if (data.errno == 0) {
                        _this.clickplayerinfo = data.data;
                    } else {
                        _this.popupInform = false;
                        _this.$toast(data.message);
                    }
                })
            } else {
                this.openPage('message/self_page/' + _uid, { infoUid: _uid, reload: true });
            }
        }, //点击头像时弹窗展示个人信息
        ajaxPost: function (url, values, func, isSpecial, index) {
            var vm = this;
            api.ajax({
                url: getSignUrl(url),
                method: 'post',
                cache: false,
                data: {
                    values: values || {}
                }
            }, function (ret, err) {
                //console.log(getSignUrl(url))
                if (isSpecial) {
                    if (ret) {
                        if (typeof index === 'undefined') {
                            if (vm.pageIndex == 1) vm.list = [];
                            if (ret.errno == 0) {
                                for (var j = 0; j < ret.data.length; j++) {
                                    vm.list.push(ret.data[j]);
                                }
                                vm.finished = false;
                                vm.pageIndex++;
                                if (values && values.psize) {
                                    if (ret.data.length < values.psize) {
                                        vm.finished = true;
                                    }
                                } else {
                                    if (ret.data.length < 10) {
                                        vm.finished = true;
                                    }
                                }
                                if (func) func(vm, ret);
                            } else {
                                vm.finished = true;
                            }
                            vm.isLoading = false;
                            vm.loading = false;
                        } else {
                            if (vm.pageIndex[index] == 1) vm.list[index] = [];
                            if (ret.errno == 0) {
                                for (var j = 0; j < ret.data.length; j++) {
                                    vm.list[index].push(ret.data[j]);
                                }
                                vm.$set(vm.finished, index, false);
                                vm.pageIndex[index]++;
                                if (values && values.psize) {
                                    if (ret.data.length < values.psize) {
                                        vm.$set(vm.finished, index, true);
                                    }
                                } else {
                                    if (ret.data.length < 10) {
                                        vm.$set(vm.finished, index, true);
                                    }
                                }
                                if (func) func(vm, ret);
                            } else {
                                vm.$set(vm.finished, index, true);
                            }
                            vm.$set(vm.isLoading, index, false);
                            vm.$set(vm.loading, index, false);
                        }
                    } else {
                        if (typeof index === 'undefined') {
                            if (vm.pageIndex == 1) vm.list = [];
                            vm.isLoading = false;
                            vm.loading = false;
                            vm.finished = true;
                        } else {
                            if (vm.pageIndex[index] == 1) vm.list[index] = [];
                            vm.$set(vm.isLoading, index, false);
                            vm.$set(vm.loading, index, false);
                            vm.$set(vm.finished, index, true);
                        }
                        if (api.connectionType == 'none') {
                            vm.$toast('网络连接断开，请检查网络设置');
                        } else {
                            vm.$toast({
                                message: err.msg,
                                position: 'bottom'
                            });
                        }
                    }
                } else {
                    if (ret) {
                        if (ret.errno == 0) {
                            func(vm, ret);
                        } else {
                            vm.$toast({
                                message: ret.message,
                                position: 'bottom'
                            });
                        }
                    } else {
                        if (api.connectionType == 'none') {
                            vm.$toast('网络连接断开，请检查网络设置');
                        } else {
                            vm.$toast({
                                message: err.msg,
                                position: 'bottom'
                            });
                        }
                    }
                }
            });
        },
        onRefresh: function (index) {
            var vm = this;
            setTimeout(function () {
                if (typeof index === 'undefined') {
                    vm.finished = true;
                    vm.pageIndex = 1;
                    vm.getList();
                } else {
                    vm.$set(vm.finished, index, true);
                    vm.$set(vm.pageIndex, index, 1);
                    vm.getList(index);
                }
            }, 300);
        },
        onLoad: function (index) {
            // var vm = this;
            // setTimeout(function () {
            if (typeof index === 'undefined') {
                this.getList();
            } else {
                this.getList(index);
            }
            // }, 30);
        },
        setPermission: function (cb, list) {
            var resultList = api.hasPermission({
                list: list || ['storage']
            });
            if (api.systemType == 'ios') {
                cb(1);
            }
            var flag = false;
            for (var i = 0; i < resultList.length; i++) {
                if (resultList[i].granted) {
                    flag = true;
                } else {
                    if (localStorage.getItem('notpermission' + resultList[i].name) == 1) {
                        cb(0);
                        return;
                    }
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cb(1);
            } else {
                api.requestPermission({
                    list: list || ['storage'],
                    code: 1
                }, function (ret, err) {
                    if (ret.code == 1) {
                        var plist = ret.list;
                        flag = false;
                        for (var i = 0; i < plist.length; i++) {
                            if (plist[i].name == 'storage' && plist[i].granted) {
                                api.sendEvent({
                                    name: 'initOpen'
                                });
                            }
                            if (!plist[i].granted) {
                                flag = true;
                            }
                            if (ret.never) {
                                localStorage.setItem('notpermission' + plist[i].name, 1);
                            }
                        }
                        if (flag) {
                            cb(0);
                        } else {
                            cb(1);
                        }
                    }
                });
            }
        },
        getVipData: function (list, name) {
            var list = list || [];
            for (var i = 0; i < list.length; i++) {
                if (list[i].name == name) {
                    this.vipData = list[i];
                }
            }
        }
    }
}

window.addEventListener('error', function(event) {
    console.log("addEventListener1", JSON.stringify(event.message)+"  at:"+JSON.stringify(event.filename)
        +"  lineno:"+JSON.stringify(event.lineno)+"  colno:"+JSON.stringify(event.colno))
    var txBugly = api.require('txBugly');
    if (localStorage.getItem('userinfo')) {
        var userinfo = JSON.parse(localStorage.getItem('userinfo'));
        txBugly.setUserValue({
            key:"uid",
            value:userinfo.uid
        })
    }
        txBugly.reportException({
            name:'js-error',
        reason:JSON.stringify(event.message)+"  at:"+JSON.stringify(event.filename)+"  lineno:"+JSON.stringify(event.lineno)+"  colno:"+JSON.stringify(event.colno) + " 版本:" + api.appVersion
        });
})
var yunKunUrl="https://www.chessdb.cn/chessdb.php?action=queryall&learn=1&showall=1&board=";
function reportBugly(e) {
    var txBugly = api.require('txBugly');
    if (localStorage.getItem('userinfo')) {
        var userinfo = JSON.parse(localStorage.getItem('userinfo'));
        txBugly.setUserValue({
            key:"uid",
            value:userinfo.uid
        })
    }
    txBugly.reportException({
        name:'js-error',
        reason:JSON.stringify(e) + " 版本:" + api.appVersion
    });
}
function trimNull(a) {
    var c = a.indexOf('\0');
    if (c>-1) {
        return a.substr(0, c);
    }
    return a;
}