//默认状态，隐藏弹窗必须将vur.dialogType的值赋值为dialog_default

var dialog_default = {
    display: false,
    button1_img: '',
    button2_img: '',
    button1_function: function () {
        vue.dialogType.display = false;
    },
    button2_function: function () {
        vue.dialogType.display = false;
    },
};
//匹配中
var dialog_pipei = {
    display: true,
    title: '正在寻找棋力相当的对手...',
    button1_img: 'assets/images/button/button_cancel.png',
    button2_img: '',
    button1_function: function () {
        onCacelGame();
    },
    button2_function: function () {
    },
};
//账号在其他地方登录了
var dialog_login = {
    display: true,
    title: '账号在其他地方登录',
    button1_img: 'assets/images/button/button_relogin.png',
    button2_img: '',
    button1_function: function () {
        re_login();
    },
    button2_function: function () {
    },
};
//与大厅断开连接
var dialog_reconnect = {
    display: true,
    title: '与服务器断开连接',
    button1_img: 'assets/images/button/button_cancel.png',
    button2_img: 'assets/images/button/button_reconnect.png',
    button1_function: function () {
        vue.dialogType = dialog_default;
    },
    button2_function: function () {
        re_login();
    },
};
//无用户信息
var dialog_nouser = {
    display: true,
    title: '无用户信息',
    button1_img: 'assets/images/button/button_reconnect.png',
    button2_img: '',
    button1_function: function () {
        re_login();
    },
    button2_function: function () {
    },
};
//退出逻辑
var dialog_tuichu = {
    display: true,
    title: '您确定要退出吗？',
    button1_img: 'assets/images/button/button_cancel.png',
    button2_img: 'assets/images/button/button_quit.png',
    button1_function: function () {
        vue.dialogType = dialog_default;
    },
    button2_function: function () {
        api.sendEvent({
            name: 'refreshQipu',
            extra: {}
        });
        if (vue.pageType == 'man_machine') {
            if (movesIndex > 0) {
                localStorage.removeItem('AiHistory');
                vue.qlcp_result.reason = '我方强退';
                vue.qlcp_result.winner = computer == 'red' ? 1 : 2;
                vue.qlcp_result.steps = Math.ceil(movesIndex / 2);
                var temp = {
                    result: vue.qlcp_result.winner,
                    reason: vue.qlcp_result.reason
                }
                onSend(temp, '', function () {
                    vue.closePage()
                }); 
            } else {
                vue.closePage()
            }
        } else {
            mySendMessage(mysetting.routes.leaveRoom, {}, function (data) {
                vue.rebackHall();
            })
        }
    },
};
//处理对方发来的huiqi
var dialog_agree_huiqi = {
    display: true,
    title: '对方向你发起悔棋请求',
    time: 10,
    button1_img: 'assets/images/button/button_disagree.png',
    button2_img: 'assets/images/button/button_agree.png',
    button1_function: function () {
        handle_agree(1, false);
    },
    button2_function: function () {
        handle_agree(1, true);
    }
};
//主动认输
var dialog_renshu = {
    display: true,
    title: '您确定认输吗',
    button1_img: 'assets/images/button/button_cancel.png',
    button2_img: 'assets/images/button/button_define.png',
    button1_function: function () {
        vue.dialogType = dialog_default;
    },
    button2_function: function () {
        mySendMessage(mysetting.routes.vote, { type: 3 }, function (data) {
            if (data.errno != 0) {
                vue.$toast(data.message);
            }
        });
        vue.dialogType = dialog_default;
    },
};
//发起求和
var dialog_qiuhe = {
    display: true,
    title: '您确定求和吗',
    button1_img: 'assets/images/button/button_cancel.png',
    button2_img: 'assets/images/button/button_define.png',
    button1_function: function () {
        vue.dialogType = dialog_default;
    },
    button2_function: function () {
        mySendMessage(mysetting.routes.vote, { type: 2 }, function (data) {
            if (data.errno == 0) {
                popupDisplay('正在等待对方同意', true);
                vue.optionInfo[3].times--;
                vue.$set(vue.optionInfo[3], 'isActive', false);
                vue.dialogType = dialog_default;
            } else {
                vue.dialogType = dialog_default;
                popupDisplay(data.message, false, 2);
            }
        })

    },
};
//处理对方发来的求和
var dialog_agree_qiuhe = {
    display: true,
    title: '对方向你发起求和',
    time: 10,
    button1_img: 'assets/images/button/button_disagree.png',
    button2_img: 'assets/images/button/button_agree.png',
    button1_function: function () {
        handle_agree(2, false);
    },
    button2_function: function () {
        handle_agree(2, true);
    }
};
//旁观页面的对弈结果显示
var dialog_pangguan = {
    display: true,
    lab: '对弈结果',
    title2: '',
    button1_img: 'assets/images/button/button_define.png',
    button2_img: 'assets/images/button/button_favor.png',
    button1_function: function () {
        vue.rebackHall();
    },
    button2_function: function () {
        mySendMessage(mysetting.routes.userCollect, { chessid: vue.qlcp_result.chessid }, function (data) {
            if (data.errno == 0) {
                vue.favorChess = data.data.isCollect;
                if (vue.favorChess) {
                    vue.$toast('收藏成功');
                    vue.dialogType.button2_img = 'assets/images/button/button_favored.png';
                } else {
                    vue.$toast('取消收藏');
                    vue.dialogType.button2_img = 'assets/images/button/button_favor.png';
                }
            } else {
                vue.$toast(data.message);
            }
        })
    },
};
function handle_agree(type, agree) {
    mySendMessage(mysetting.routes.voteApply, { type: type, agree: agree }, function (data) {
        if (data.errno != 0) {
            vue.$toast(data.message);
        }
    })
    vue.dialogType = dialog_default;
    if (timer) {
        clearInterval(timer);
    }
}
function toastDisplay(text) {
    vue.toastShow = true;
    vue.toastValue = text;
    setTimeout(function () {
        vue.toastShow = false;
    }, 2000);
}
function popupDisplay(text, isloading, second) {
    vue.popup_unit.show = true;
    vue.popup_unit.text = text;
    vue.popup_unit.loading = isloading;
    if (second) {
        setTimeout(function () {
            vue.popup_unit.show = false
        }, second * 1000);
    }
}
function getDay(day) {
    var today = new Date();
    var targetday_milliseconds = today.getTime() + 1000 * 60 * 60 * 24 * day;
    today.setTime(targetday_milliseconds); //注意，这行是关键代码
    var tYear = today.getFullYear();
    var tMonth = today.getMonth();
    var tDate = today.getDate();
    tMonth = doHandleMonth(tMonth + 1);
    tDate = doHandleMonth(tDate);
    return tYear + "" + tMonth + "" + tDate;
}
function doHandleMonth(month) {
    var m = month;
    if (month.toString().length == 1) {
        m = "0" + month;
    }
    return m;
}
