/*绘图相关常量*/
var CANVAS_W = 720, CANVAS_H = 830;//画布（棋盘）的宽高
var CANVAS_EDIT_H = 1020;
var SPACE_W = 78, SPACE_H = 78;//棋盘一个格子的宽高
var CHESS_BODY_W = 128, CHESS_BODY_H = 132;//棋子背景的宽高
var CHESS_LABEL_W = 99, CHESS_LABEL_H = 113;//棋子的宽高
var SCALE = 0.57; //棋子缩放比例
var BOARD_EDIT_CHANGE = 95; //编辑棋盘状态下棋子移动距离
var DOTS_W = 14, DOTS_H = 14;//绿色小点点的宽高
var LIGHT_W = 78 * 1.05, LIGHT_H = 78 * 1.05;//白色大光圈的宽高
var BOX_W = 30, BOX_H = 30;//白色小圈圈的宽高
var BORDER_W = 78 * 1.05, BORDER_H = 78 * 1.05;//绿色选择框的宽高
var HAS_BORDER_LINE = 1;//是否显示棋盘刻度线
var BOARD_LINE_W = 642, BOARD_LINE_TOP = 8, BOARD_LINE_BOTTOM = 36;//棋盘刻度线
var boardset = { boutside: -1.3, routside: 10.5, outsidescale: 1.58 };
var CHESS_SLIM = {
    "images": ["../../assets/images/chess_slim_.png?version=1"],
    "frames": [[0, 0, 162, 166], [0, 166, 99, 96], [99, 166, 99, 96], [0, 262, 99, 96], [99, 262, 99, 96], [0, 358, 99, 96], [99, 358, 99, 96], [0, 454, 99, 96], [99, 454, 99, 96], [0, 550, 99, 96], [99, 550, 99, 96], [0, 646, 99, 96], [99, 646, 99, 96], [0, 742, 99, 96], [99, 742, 99, 96]]
}
var F_ATLAS = {
    "images": ["../../assets/images/f_atlas_.png"],
    "frames": [
        [1, 1, 78, 78, 0, 0, 0],
        [81, 1, 78, 78, 0, 0, 0],
        [161, 1, 32, 32, 0, 0, 0],
        [161, 35, 14, 14, 0, 0, 0]
    ]
}

/*逻辑相关常量*/
var RED = 1, BLACK = -1;
var STATE = { CHECKED: 1, EAT: 2, ERROR: 4, CHECKMATE: 8, SLATEMATE: 16 };
var playmode = {
    AIPLAY: 0,
    EDITBOARD: 1,
    ANALYSE: 2,
    REPLAY: 3,
    CREATE: 4,
    ONLINE: 5,
    TEST: 6,
    CHESSANALYSE: 7,
    GAMEOVER: 8,
    TREE: 9
};

/*全局变量 - 绘图相关*/
var comm = {};
var canvas, stage, canvas2, stage2, wrapperFunc;
var chessLayer, chessTopLayer, chessBottomLayer;
var box1, light, border, dots, tips;
var stageshape = [], stagetext = [], chessnum = [], stageshape2 = [], stagetext2 = [], stageshape3 = [], stagetext3 = [],stageshape4 = [],stageshape5 = [], Dots = {}, dots; //划线相关
var board, verticalReverseboard, board2, verticalReverseboard2;
var chessList, effectList;
var defaultChessList=[];

/*全局变量 - 逻辑相关*/
var mode, voicemode = 1, acceptMessage = 1, isanalyse = 0, waitServerPlay = false;
var r_autoset = 0, b_autoset = 0;
var currentId = 0, moves = [], movesIndex = 0, isVerticalReverse = 0, eatKey = '', initMap = [];
var priority = 0; //优先级
var isshowTip = false;
var autoreplayset = 0;//自动播放
var removeOnDrops = [];
var callOnDrops = [];
var callOnDropsArgs = [];
var reportDefine = {
    // BK: { S: 50, log: 2 },
    // BZ: { S: 100, log: 100 },
    // BC: { S: 100, log: 100 },
    // BS: { S: 29000, log: 100 },
    // SW: { S: 200 },
    // isCJ: 15
};//开局，中局，残局，杀棋，失误阈值。
var chessScore = { "C": 9, "M": 4.5, "P": 4.5, "S": 0, "X": 0, "Z": 0, "c": 9, "m": 4.5, "p": 4.5, "s": 0, "x": 0, "z": 0 }

var state = 0;

/*象棋相关固定参数*/
var InitFen = "rnbakabnr/9/1c5c1/p1p1p1p1p/9/9/P1P1P1P1P/1C5C1/9/RNBAKABNR w";
var InitMap = [
    ["C0", "M0", "X0", "S0", "J0", "S1", "X1", "M1", "C1"],
    [, , , , , , , , ""],
    [, "P0", , , , , , "P1", "",],
    ["Z0", , "Z1", , "Z2", , "Z3", , "Z4"],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    ["z0", , "z1", , "z2", , "z3", , "z4"],
    [, "p0", , , , , , "p1", ""],
    [, , , , , , , , ""],
    ["c0", "m0", "x0", "s0", "j0", "s1", "x1", "m1", "c1"]
];
var EmptyMap = [
    [, , , , "J0", , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , "j0", , , , ""]
];
var emptyMap = [
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""],
    [, , , , , , , , ""]
];
var sMapFull = [["C0", "M0", "P0", "X0", "S0", "Z0"], ["c0", "m0", "p0", "x0", "s0", "z0"]];
var sMapFullReveser = [["c0", "m0", "p0", "x0", "s0", "z0"], ["C0", "M0", "P0", "X0", "S0", "Z0"]];
var sMapEmpty = [[, , , , , ,], [, , , , , ,]];
var chessMan = {
    "C": ["C0", "C1"],
    "M": ["M0", "M1"],
    "P": ["P0", "P1"],
    "X": ["X0", "X1"],
    "S": ["S0", "S1"],
    "Z": ["Z0", "Z1", "Z2", "Z3", "Z4"],
    "c": ["c0", "c1"],
    "m": ["m0", "m1"],
    "p": ["p0", "p1"],
    "x": ["x0", "x1"],
    "s": ["s0", "s1"],
    "z": ["z0", "z1", "z2", "z3", "z4"]
};
var emptychessMan = {
    "C": [],
    "M": [],
    "P": [],
    "S": [],
    "X": [],
    "Z": [],
    "c": [],
    "m": [],
    "p": [],
    "s": [],
    "x": [],
    "z": []
};
/*将fen格式转换为MAP*/
board2map = function (board, notReverse) {
    var key = {
        "k": ["J0"],
        "b": ["X0", "X1"],
        "a": ["S0", "S1"],
        "p": ["Z0", "Z1", "Z2", "Z3", "Z4"],
        "r": ["C0", "C1"],
        "n": ["M0", "M1"],
        "c": ["P0", "P1"],
        "K": ["j0"],
        "B": ["x0", "x1"],
        "A": ["s0", "s1"],
        "P": ["z0", "z1", "z2", "z3", "z4"],
        "R": ["c0", "c1"],
        "N": ["m0", "m1"],
        "C": ["p0", "p1"]
    };
    var tmap = [
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""],
        [, , , , , , , , ""]
    ];
    if (!board) {
        return tmap;
    }
    board = board.replace(/\//g, '');
    var arr = board.split("");
    var index = 0;
    for (var i = 0; i < 90; i++) {
        if (isNumber(arr[i])) {
            index += parseInt(arr[i]);
        } else if (arr[i] == ' ') {
            break;
        } else {
            if (isVerticalReverse && !notReverse) {
                tmap[9 - parseInt(index / 9)][8 - index % 9] = (key[arr[i]]).shift();
            } else {
                tmap[parseInt(index / 9)][index % 9] = (key[arr[i]]).shift();
            }
            index++;
        }
    }
    return tmap;
}
/*判断是否数字*/
isNumber = function (value) {
    var patrn = /^(-)?\d+(\.\d+)?$/;
    if (patrn.exec(value) == null || value == "") {
        return false
    } else {
        return true
    }
}
/*二维数组翻转*/
arrReverse = function (e) {
    for (var a = [], m = 0; m < e.length; m++) {
        a[m] = e[e.length - 1 - m].slice().reverse();
    }
    return a
}
/*X坐标翻转*/
reverseX = function (e) {
    return 8 - e
}
/*Y坐标翻转*/
reverseY = function (e) {
    return 9 - e
}
/*步法翻转,左上角转右下角，右下角转左上角*/
reverseStep = function (e) {
    if(!e){
        return ''
    }
    var a = e.split("");
    a[0] = reverseX(a[0]);
    a[1] = reverseY(a[1]);
    a[2] = reverseX(a[2]);
    a[3] = reverseY(a[3]);
    return a.join("");
}
function turnScore(score) {
    var temp = 0;
    var temp_val = Math.abs(score);
    if (temp_val > 10 || temp_val < -10) {
        temp = Math.round(10000 * Math.log(temp_val / 10) / Math.log(5)); //保留四位小数
    } else {
        temp = 0;
    }
    if (score >= 0) {
        temp = temp;
    } else {
        temp = -temp;
    }
    return temp;
}

