mixin_pay = {
    data: function () {
        return {
            orderType: '',
            pageType: 'pay',
            kefu: {
                nickname: '',
                avatar: '',
                qrcode: '',
            },
            chat_dialog:false
        }
    },
    created: function () {
    },
    methods: {
        wxPay: function () {
            var vm = this;
            var wx = api.require('wxPlus');
            wx.isInstalled(function (ret2, err) {
                vm.$toast.loading({
                    duration: 0,
                    message: '正在调起微信支付...',
                    forbidClick: true
                });
                vm.ajaxPost(xqwxt_url + '&do=pay&op=wx_app', {
                    ordertype: vm.orderType,
                    orderid: vm.orderid,
                    isScan: ret2.installed || api.uiMode == 'phone' ? 0 : 1
                }, function (vm, ret) {
                    vm.$toast.clear();
                    if (!ret2.installed && api.uiMode != 'phone') {
                        vm.scanType = 'wechat';
                        vm.scanImg = ret.data;
                        vm.showScan = true;
                    } else {
                        var wxPayPlus = api.require('wxPayPlus');
                        wxPayPlus.payOrder({
                            apiKey: ret.data.appid,
                            orderId: ret.data.prepayid,
                            mchId: ret.data.partnerid,
                            nonceStr: ret.data.noncestr,
                            timeStamp: ret.data.timestamp,
                            package: ret.data.package,
                            sign: ret.data.sign
                        }, function (ret, err) {
                            if (ret.status) {
                                vm.checkBuy('wechat');
                            } else {
                                if (err.code == -2) {
                                    vm.$toast('取消支付');
                                } else {
                                    vm.$toast('未知错误，请稍后重试');
                                }
                            }
                        });
                    }
                })
            });
        },
        aliPay: function () {
            this.$toast.loading({
                duration: 0,
                message: '正在调起支付宝支付...',
                forbidClick: true
            });
            this.ajaxPost(xqwxt_url + '&do=pay&op=ali_app', {
                ordertype: this.orderType,
                orderid: this.orderid,
                isScan: api.uiMode == 'phone' ? 0 : 1
            }, function (vm, ret) {
                vm.$toast.clear();
                if (api.uiMode != 'phone') {
                    vm.scanType = 'ali';
                    vm.scanImg = ret.data;
                    vm.showScan = true;
                } else {
                    var aliPayTradePlus = api.require('aliPayTradePlus');
                    aliPayTradePlus.payOrder({
                        orderInfo: ret.data
                    }, function (ret, err) {
                        if (ret.code == 9000) {
                            vm.checkBuy('ali');
                        } else {
                            if (ret.code == 6001) {
                                vm.$toast('取消支付');
                            } else {
                                vm.$toast('未知错误，请稍后重试');
                            }
                        }
                    });
                }
            })
        },
        creditPay: function () {
            var vm = this;
            this.$toast.clear();
            this.$dialog.confirm({
                message: '将使用余额支付订单，订单金额为' + vm.price,
                confirmButtonText: '支付',
                confirmButtonColor: '#3388ff',
                cancelButtonColor: '#666666'
            }).then(function () {
                vm.$toast.loading({
                    duration: 0,
                    message: '正在使用余额支付...',
                    forbidClick: true
                });
                vm.checkBuy('credit2');
            }).catch(function () {

            })
        },
        checkBuy: function (type) {
            var tempOp = type == 'wechat' ? 'wx_query' : (type == 'ali' ? 'ali_query' : type);
            this.ajaxPost(xqwxt_url + '&do=pay&op=' + tempOp, {
                ordertype: this.orderType,
                orderid: this.orderid
            }, function (vm, ret) {
                vm.$toast.success({
                    duration: 1000,
                    message: '支付成功',
                    forbidClick: true
                });
                if (vm.orderType == 'credit2') {
                    api.sendEvent({
                        name: 'balance_change',
                    });
                    vm.init();
                } else if (vm.orderType == 'vip' || vm.orderType == 'lesson') {
                    setTimeout(() => {
                        vm.chat_dialog=true
                    }, 1000);
                }
              
            });
        },
        chat_dialog_cancel(){
            let vm=this
            api.sendEvent({
                name: 'buySuccess'
            });
            setTimeout(function () {
                vm.closePage();
            }, 1000);
        }
    }
}
